# Gross, but seems to be the way to get the ghidra apis/values from an external module
from __main__ import currentProgram, monitor
from ghidra.program.flatapi import FlatProgramAPI

flatProgramAPI = FlatProgramAPI(currentProgram)
toAddr = flatProgramAPI.toAddr
getDataAt = flatProgramAPI.getDataAt
getReferencesTo = flatProgramAPI.getReferencesTo
getFunctionContaining = flatProgramAPI.getFunctionContaining

memory = currentProgram.getMemory()

services = {
  'fs_user_handle': {
    0x100c6: 'fs::Dummy1',
    0x40100c4: 'fs::Control',
    0x8010002: 'fs::Initialize',
    0x80201c2: 'fs::OpenFile',
    0x8030204: 'fs::OpenFileDirectly',
    0x8040142: 'fs::DeleteFile',
    0x8050244: 'fs::RenameFile',
    0x8060142: 'fs::DeleteDirectory',
    0x8070142: 'fs::DeleteDirectoryRecursively',
    0x8080202: 'fs::CreateFile',
    0x8090182: 'fs::CreateDirectory',
    0x80a0244: 'fs::RenameDirectory',
    0x80b0102: 'fs::OpenDirectory',
    0x80c00c2: 'fs::OpenArchive',
    0x80d0144: 'fs::ControlArchive',
    0x80e0080: 'fs::CloseArchive',
    0x80f0180: 'fs::Obsoleted_2_0_FormatThisUserSaveData',
    0x8100200: 'fs::Obsoleted_3_0_CreateSystemSaveData',
    0x8110040: 'fs::Obsoleted_3_0_DeleteSystemSaveData',
    0x8120080: 'fs::GetFreeBytes',
    0x8130000: 'fs::GetCardType',
    0x8140000: 'fs::GetSdmcArchiveResource',
    0x8150000: 'fs::GetNandArchiveResource',
    0x8160000: 'fs::GetSdmcFatfsError',
    0x8170000: 'fs::IsSdmcDetected',
    0x8180000: 'fs::IsSdmcWritable',
    0x8190042: 'fs::GetSdmcCid',
    0x81a0042: 'fs::GetNandCid',
    0x81b0000: 'fs::GetSdmcSpeedInfo',
    0x81c0000: 'fs::GetNandSpeedInfo',
    0x81d0042: 'fs::GetSdmcLog',
    0x81e0042: 'fs::GetNandLog',
    0x81f0000: 'fs::ClearSdmcLog',
    0x8200000: 'fs::ClearNandLog',
    0x8210000: 'fs::CardSlotIsInserted',
    0x8220000: 'fs::CardSlotPowerOn',
    0x8230000: 'fs::CardSlotPowerOff',
    0x8240000: 'fs::CardSlotGetCardIFPowerStatus',
    0x8250040: 'fs::CardNorDirectCommand',
    0x8260080: 'fs::CardNorDirectCommandWithAddress',
    0x8270082: 'fs::CardNorDirectRead',
    0x82800c2: 'fs::CardNorDirectReadWithAddress',
    0x8290082: 'fs::CardNorDirectWrite',
    0x82a00c2: 'fs::CardNorDirectWriteWithAddress',
    0x82b00c2: 'fs::CardNorDirectRead_4xIO',
    0x82c0082: 'fs::CardNorDirectCpuWriteWithoutVerify',
    0x82d0040: 'fs::CardNorDirectSectorEraseWithoutVerify',
    0x82e0040: 'fs::GetProductInfo',
    0x82f0040: 'fs::GetProgramLaunchInfo',
    0x8300182: 'fs::Obsoleted_3_0_CreateExtSaveData',
    0x8310180: 'fs::Obsoleted_3_0_CreateSharedExtSaveData',
    0x8320102: 'fs::Obsoleted_3_0_ReadExtSaveDataIcon',
    0x8330082: 'fs::Obsoleted_3_0_EnumerateExtSaveData',
    0x8340082: 'fs::Obsoleted_3_0_EnumerateSharedExtSaveData',
    0x8350080: 'fs::Obsoleted_3_0_DeleteExtSaveData',
    0x8360080: 'fs::Obsoleted_3_0_DeleteSharedExtSaveData',
    0x8370040: 'fs::SetCardSpiBaudRate',
    0x8380040: 'fs::SetCardSpiBusMode',
    0x8390000: 'fs::SendInitializeInfoTo9',
    0x83a0100: 'fs::GetSpecialContentIndex',
    0x83b00c2: 'fs::GetLegacyRomHeader',
    0x83c00c2: 'fs::GetLegacyBannerData',
    0x83d0100: 'fs::CheckAuthorityToAccessExtSaveData',
    0x83e00c2: 'fs::QueryTotalQuotaSize',
    0x83f00c0: 'fs::Obsoleted_3_0_GetExtDataBlockSize',
    0x8400040: 'fs::AbnegateAccessRight',
    0x8410000: 'fs::DeleteSdmcRoot',
    0x8420040: 'fs::DeleteAllExtSaveDataOnNand',
    0x8430000: 'fs::InitializeCtrFileSystem',
    0x8440000: 'fs::CreateSeed',
    0x84500c2: 'fs::GetFormatInfo',
    0x8460102: 'fs::GetLegacyRomHeader2',
    0x8470180: 'fs::Obsoleted_2_0_FormatCtrCardUserSaveData',
    0x8480042: 'fs::GetSdmcCtrRootPath',
    0x8490040: 'fs::GetArchiveResource',
    0x84a0002: 'fs::ExportIntegrityVerificationSeed',
    0x84b0002: 'fs::ImportIntegrityVerificationSeed',
    0x84c0242: 'fs::FormatSaveData',
    0x84d0102: 'fs::GetLegacySubBannerData',
    0x84e0342: 'fs::UpdateSha256Context',
    0x84f0102: 'fs::ReadSpecialFile',
    0x8500040: 'fs::GetSpecialFileSize',
    0x8510242: 'fs::CreateExtSaveData',
    0x8520100: 'fs::DeleteExtSaveData',
    0x8530142: 'fs::ReadExtSaveDataIcon',
    0x85400c0: 'fs::GetExtDataBlockSize',
    0x8550102: 'fs::EnumerateExtSaveData',
    0x8560240: 'fs::CreateSystemSaveData',
    0x8570080: 'fs::DeleteSystemSaveData',
    0x8580000: 'fs::StartDeviceMoveAsSource',
    0x8590200: 'fs::StartDeviceMoveAsDestination',
    0x85a00c0: 'fs::SetArchivePriority',
    0x85b0080: 'fs::GetArchivePriority',
    0x85c00c0: 'fs::SetCtrCardLatencyParameter',
    0x85d01c0: 'fs::SetFsCompatibilityInfo',
    0x85e0040: 'fs::ResetCardCompatibilityParameter',
    0x85f0040: 'fs::SwitchCleanupInvalidSaveData',
    0x8600042: 'fs::EnumerateSystemSaveData',
    0x8610042: 'fs::InitializeWithSdkVersion',
    0x8620040: 'fs::SetPriority',
    0x8630000: 'fs::GetPriority',
    0x8640000: 'fs::Obsoleted_4_0_GetNandInfo',
    0x8650140: 'fs::SetSaveDataSecureValue',
    0x86600c0: 'fs::GetSaveDataSecureValue',
    0x86700c4: 'fs::ControlSecureSave',
    0x8680000: 'fs::GetMediaType',
    0x8690000: 'fs::Obsoleted_4_0_GetNandEraseCount',
    0x86a0082: 'fs::ReadNandReport',
    0x86b00c2: 'fs::SetOtherSaveDataSecureValue',
    0x86c00c2: 'fs::GetOtherSaveDataSecureValue',
    0x86e00c0: 'fs::SetThisSaveDataSecureValue',
    0x86f0040: 'fs::GetThisSaveDataSecureValue',
    0x87900c2: 'fs::GetLegacyBannerData',
    0x87a0180: 'fs::AddSeed',
    0x87d0000: 'fs::GetNumSeeds',
    0x88600c0: 'fs::CheckUpdatedDat'
  },
  'fs_reg_handle': {
    0x100c6: 'fs::Dummy1',
    0x40103c0: 'fs::Register',
    0x4020040: 'fs::Unregister',
    0x40300c0: 'fs::GetProgramInfo',
    0x4040100: 'fs::LoadProgram',
    0x4050080: 'fs::UnloadProgram',
    0x4060080: 'fs::CheckHostLoadId'
  },
  'pxifs0_handle': {
    0x101c2: 'pxifs0::OpenFile',
    0x20142: 'pxifs0::DeleteFile',
    0x30244: 'pxifs0::RenameFile',
    0x40142: 'pxifs0::DeleteDirectory',
    0x50202: 'pxifs0::CreateFile',
    0x60182: 'pxifs0::CreateDirectory',
    0x70244: 'pxifs0::RenameDirectory',
    0x80102: 'pxifs0::OpenDirectory',
    0x90142: 'pxifs0::ReadFile',
    0xa00c2: 'pxifs0::CalculateFileHashSHA256',
    0xb0182: 'pxifs0::WriteFile',
    0xc0104: 'pxifs0::CalcSavegameMAC',
    0xd0080: 'pxifs0::GetFileSize',
    0xe0100: 'pxifs0::SetFileSize',
    0xf0080: 'pxifs0::CloseFile',
    0x1000c2: 'pxifs0::ReadDirectory',
    0x110080: 'pxifs0::CloseDirectory',
    0x1200c2: 'pxifs0::OpenArchive',
    0x130102: 'pxifs0::HasFile',
    0x140102: 'pxifs0::HasDirectory',
    0x1500c0: 'pxifs0::CommitSaveData',
    0x160080: 'pxifs0::CloseArchive',
    0x170080: 'pxifs0::LockArchive',
    0x180000: 'pxifs0::GetCardType',
    0x190000: 'pxifs0::GetSdmcArchiveResource',
    0x1a0000: 'pxifs0::GetNandArchiveResource',
    0x1b0000: 'pxifs0::GetSdmcFatFsError',
    0x1c0000: 'pxifs0::IsSdmcDetected',
    0x1d0000: 'pxifs0::IsSdmcWritable',
    0x1e0042: 'pxifs0::GetSdmcCid',
    0x1f0042: 'pxifs0::GetNandCid',
    0x200000: 'pxifs0::GetSdmcSpeedInfo',
    0x210000: 'pxifs0::GetNandSpeedInfo',
    0x220042: 'pxifs0::GetSdmcLog',
    0x230042: 'pxifs0::GetNandLog',
    0x240000: 'pxifs0::ClearSdmcLog',
    0x250000: 'pxifs0::ClearNandLog',
    0x260000: 'pxifs0::CardSlotIsInserted',
    0x270000: 'pxifs0::CardSlotPowerOn',
    0x280000: 'pxifs0::CardSlotPowerOff',
    0x290000: 'pxifs0::CardSlotGetIFPowerStatus',
    0x2a0040: 'pxifs0::CardNorDirectCommand',
    0x2b0080: 'pxifs0::CardNorDirectCommandWithAddress',
    0x2c0082: 'pxifs0::CardNorDirectRead',
    0x2d00c2: 'pxifs0::CardNorDirectReadWithAddress',
    0x2e0082: 'pxifs0::CardNorDirectWrite',
    0x2f00c2: 'pxifs0::CardNorDirectWriteWithAddress',
    0x3000c2: 'pxifs0::CardNorDirectRead_4xIO',
    0x310082: 'pxifs0::CardNorDirectCpuWriteWithoutVerify',
    0x320040: 'pxifs0::CardNorDirectSectorEraseWithoutVerify',
    0x330080: 'pxifs0::GetProductInfo',
    0x340040: 'pxifs0::SetCardSpiBaudrate',
    0x350040: 'pxifs0::SetCardSpiBusMode',
    0x360040: 'pxifs0::SendInitializeInfoTo9',
    0x370100: 'pxifs0::CreateExtSaveData',
    0x380100: 'pxifs0::DeleteExtSaveData',
    0x390102: 'pxifs0::EnumerateExtSaveData',
    0x3a0100: 'pxifs0::GetSpecialContentIndex',
    0x3b00c2: 'pxifs0::GetLegacyRomHeader',
    0x3c0102: 'pxifs0::GetLegacyBannerData',
    0x3d0040: 'pxifs0::FormatCardNorDevice',
    0x3e0000: 'pxifs0::DeleteSdmcRoot',
    0x3f0040: 'pxifs0::DeleteAllExtSaveDataOnNand',
    0x400000: 'pxifs0::InitializeCtrFilesystem',
    0x410000: 'pxifs0::CreateSeed',
    0x420042: 'pxifs0::GetSdmcCtrRootPath',
    0x430040: 'pxifs0::GetArchiveResource',
    0x440002: 'pxifs0::ExportIntegrityVerificationSeed',
    0x450002: 'pxifs0::ImportIntegrityVerificationSeed',
    0x460102: 'pxifs0::GetLegacySubBannerData',
    0x470042: 'pxifs0::GenerateRandomBytes',
    0x4800c2: 'pxifs0::GetFileLastModified',
    0x490102: 'pxifs0::ReadSpecialFile',
    0x4a0040: 'pxifs0::GetSpecialFileSize',
    0x4b0000: 'pxifs0::StartDeviceMoveAsSource',
    0x4c0240: 'pxifs0::StartDeviceMoveAsDestination',
    0x4d01c4: 'pxifs0::ReadFileSHA256',
    0x4e0204: 'pxifs0::WriteFileSHA256',
    0x4f0080: 'pxifs0::SetCtrCardLatencyParameter',
    0x500040: 'pxifs0::SetPriority',
    0x510040: 'pxifs0::SwitchCleanupInvalidSaveData',
    0x520042: 'pxifs0::EnumerateSystemSaveData',
    0x550082: 'pxifs0::ReadNandReport'
  },
  'pxifs1_handle': {
    0x101c2: 'pxifs1::OpenFile',
    0x20142: 'pxifs1::DeleteFile',
    0x30244: 'pxifs1::RenameFile',
    0x40142: 'pxifs1::DeleteDirectory',
    0x50202: 'pxifs1::CreateFile',
    0x60182: 'pxifs1::CreateDirectory',
    0x70244: 'pxifs1::RenameDirectory',
    0x80102: 'pxifs1::OpenDirectory',
    0x90142: 'pxifs1::ReadFile',
    0xa00c2: 'pxifs1::CalculateFileHashSHA256',
    0xb0182: 'pxifs1::WriteFile',
    0xc0104: 'pxifs1::CalcSavegameMAC',
    0xd0080: 'pxifs1::GetFileSize',
    0xe0100: 'pxifs1::SetFileSize',
    0xf0080: 'pxifs1::CloseFile',
    0x1000c2: 'pxifs1::ReadDirectory',
    0x110080: 'pxifs1::CloseDirectory',
    0x1200c2: 'pxifs1::OpenArchive',
    0x130102: 'pxifs1::HasFile',
    0x140102: 'pxifs1::HasDirectory',
    0x1500c0: 'pxifs1::CommitSaveData',
    0x160080: 'pxifs1::CloseArchive',
    0x170080: 'pxifs1::LockArchive',
    0x180000: 'pxifs1::GetCardType',
    0x190000: 'pxifs1::GetSdmcArchiveResource',
    0x1a0000: 'pxifs1::GetNandArchiveResource',
    0x1b0000: 'pxifs1::GetSdmcFatFsError',
    0x1c0000: 'pxifs1::IsSdmcDetected',
    0x1d0000: 'pxifs1::IsSdmcWritable',
    0x1e0042: 'pxifs1::GetSdmcCid',
    0x1f0042: 'pxifs1::GetNandCid',
    0x200000: 'pxifs1::GetSdmcSpeedInfo',
    0x210000: 'pxifs1::GetNandSpeedInfo',
    0x220042: 'pxifs1::GetSdmcLog',
    0x230042: 'pxifs1::GetNandLog',
    0x240000: 'pxifs1::ClearSdmcLog',
    0x250000: 'pxifs1::ClearNandLog',
    0x260000: 'pxifs1::CardSlotIsInserted',
    0x270000: 'pxifs1::CardSlotPowerOn',
    0x280000: 'pxifs1::CardSlotPowerOff',
    0x290000: 'pxifs1::CardSlotGetIFPowerStatus',
    0x2a0040: 'pxifs1::CardNorDirectCommand',
    0x2b0080: 'pxifs1::CardNorDirectCommandWithAddress',
    0x2c0082: 'pxifs1::CardNorDirectRead',
    0x2d00c2: 'pxifs1::CardNorDirectReadWithAddress',
    0x2e0082: 'pxifs1::CardNorDirectWrite',
    0x2f00c2: 'pxifs1::CardNorDirectWriteWithAddress',
    0x3000c2: 'pxifs1::CardNorDirectRead_4xIO',
    0x310082: 'pxifs1::CardNorDirectCpuWriteWithoutVerify',
    0x320040: 'pxifs1::CardNorDirectSectorEraseWithoutVerify',
    0x330080: 'pxifs1::GetProductInfo',
    0x340040: 'pxifs1::SetCardSpiBaudrate',
    0x350040: 'pxifs1::SetCardSpiBusMode',
    0x360040: 'pxifs1::SendInitializeInfoTo9',
    0x370100: 'pxifs1::CreateExtSaveData',
    0x380100: 'pxifs1::DeleteExtSaveData',
    0x390102: 'pxifs1::EnumerateExtSaveData',
    0x3a0100: 'pxifs1::GetSpecialContentIndex',
    0x3b00c2: 'pxifs1::GetLegacyRomHeader',
    0x3c0102: 'pxifs1::GetLegacyBannerData',
    0x3d0040: 'pxifs1::FormatCardNorDevice',
    0x3e0000: 'pxifs1::DeleteSdmcRoot',
    0x3f0040: 'pxifs1::DeleteAllExtSaveDataOnNand',
    0x400000: 'pxifs1::InitializeCtrFilesystem',
    0x410000: 'pxifs1::CreateSeed',
    0x420042: 'pxifs1::GetSdmcCtrRootPath',
    0x430040: 'pxifs1::GetArchiveResource',
    0x440002: 'pxifs1::ExportIntegrityVerificationSeed',
    0x450002: 'pxifs1::ImportIntegrityVerificationSeed',
    0x460102: 'pxifs1::GetLegacySubBannerData',
    0x470042: 'pxifs1::GenerateRandomBytes',
    0x4800c2: 'pxifs1::GetFileLastModified',
    0x490102: 'pxifs1::ReadSpecialFile',
    0x4a0040: 'pxifs1::GetSpecialFileSize',
    0x4b0000: 'pxifs1::StartDeviceMoveAsSource',
    0x4c0240: 'pxifs1::StartDeviceMoveAsDestination',
    0x4d01c4: 'pxifs1::ReadFileSHA256',
    0x4e0204: 'pxifs1::WriteFileSHA256',
    0x4f0080: 'pxifs1::SetCtrCardLatencyParameter',
    0x500040: 'pxifs1::SetPriority',
    0x510040: 'pxifs1::SwitchCleanupInvalidSaveData',
    0x520042: 'pxifs1::EnumerateSystemSaveData',
    0x550082: 'pxifs1::ReadNandReport'
  },
  'pxifsb_handle': {
    0x101c2: 'pxifsb::OpenFile',
    0x20142: 'pxifsb::DeleteFile',
    0x30244: 'pxifsb::RenameFile',
    0x40142: 'pxifsb::DeleteDirectory',
    0x50202: 'pxifsb::CreateFile',
    0x60182: 'pxifsb::CreateDirectory',
    0x70244: 'pxifsb::RenameDirectory',
    0x80102: 'pxifsb::OpenDirectory',
    0x90142: 'pxifsb::ReadFile',
    0xa00c2: 'pxifsb::CalculateFileHashSHA256',
    0xb0182: 'pxifsb::WriteFile',
    0xc0104: 'pxifsb::CalcSavegameMAC',
    0xd0080: 'pxifsb::GetFileSize',
    0xe0100: 'pxifsb::SetFileSize',
    0xf0080: 'pxifsb::CloseFile',
    0x1000c2: 'pxifsb::ReadDirectory',
    0x110080: 'pxifsb::CloseDirectory',
    0x1200c2: 'pxifsb::OpenArchive',
    0x130102: 'pxifsb::HasFile',
    0x140102: 'pxifsb::HasDirectory',
    0x1500c0: 'pxifsb::CommitSaveData',
    0x160080: 'pxifsb::CloseArchive',
    0x170080: 'pxifsb::LockArchive',
    0x180000: 'pxifsb::GetCardType',
    0x190000: 'pxifsb::GetSdmcArchiveResource',
    0x1a0000: 'pxifsb::GetNandArchiveResource',
    0x1b0000: 'pxifsb::GetSdmcFatFsError',
    0x1c0000: 'pxifsb::IsSdmcDetected',
    0x1d0000: 'pxifsb::IsSdmcWritable',
    0x1e0042: 'pxifsb::GetSdmcCid',
    0x1f0042: 'pxifsb::GetNandCid',
    0x200000: 'pxifsb::GetSdmcSpeedInfo',
    0x210000: 'pxifsb::GetNandSpeedInfo',
    0x220042: 'pxifsb::GetSdmcLog',
    0x230042: 'pxifsb::GetNandLog',
    0x240000: 'pxifsb::ClearSdmcLog',
    0x250000: 'pxifsb::ClearNandLog',
    0x260000: 'pxifsb::CardSlotIsInserted',
    0x270000: 'pxifsb::CardSlotPowerOn',
    0x280000: 'pxifsb::CardSlotPowerOff',
    0x290000: 'pxifsb::CardSlotGetIFPowerStatus',
    0x2a0040: 'pxifsb::CardNorDirectCommand',
    0x2b0080: 'pxifsb::CardNorDirectCommandWithAddress',
    0x2c0082: 'pxifsb::CardNorDirectRead',
    0x2d00c2: 'pxifsb::CardNorDirectReadWithAddress',
    0x2e0082: 'pxifsb::CardNorDirectWrite',
    0x2f00c2: 'pxifsb::CardNorDirectWriteWithAddress',
    0x3000c2: 'pxifsb::CardNorDirectRead_4xIO',
    0x310082: 'pxifsb::CardNorDirectCpuWriteWithoutVerify',
    0x320040: 'pxifsb::CardNorDirectSectorEraseWithoutVerify',
    0x330080: 'pxifsb::GetProductInfo',
    0x340040: 'pxifsb::SetCardSpiBaudrate',
    0x350040: 'pxifsb::SetCardSpiBusMode',
    0x360040: 'pxifsb::SendInitializeInfoTo9',
    0x370100: 'pxifsb::CreateExtSaveData',
    0x380100: 'pxifsb::DeleteExtSaveData',
    0x390102: 'pxifsb::EnumerateExtSaveData',
    0x3a0100: 'pxifsb::GetSpecialContentIndex',
    0x3b00c2: 'pxifsb::GetLegacyRomHeader',
    0x3c0102: 'pxifsb::GetLegacyBannerData',
    0x3d0040: 'pxifsb::FormatCardNorDevice',
    0x3e0000: 'pxifsb::DeleteSdmcRoot',
    0x3f0040: 'pxifsb::DeleteAllExtSaveDataOnNand',
    0x400000: 'pxifsb::InitializeCtrFilesystem',
    0x410000: 'pxifsb::CreateSeed',
    0x420042: 'pxifsb::GetSdmcCtrRootPath',
    0x430040: 'pxifsb::GetArchiveResource',
    0x440002: 'pxifsb::ExportIntegrityVerificationSeed',
    0x450002: 'pxifsb::ImportIntegrityVerificationSeed',
    0x460102: 'pxifsb::GetLegacySubBannerData',
    0x470042: 'pxifsb::GenerateRandomBytes',
    0x4800c2: 'pxifsb::GetFileLastModified',
    0x490102: 'pxifsb::ReadSpecialFile',
    0x4a0040: 'pxifsb::GetSpecialFileSize',
    0x4b0000: 'pxifsb::StartDeviceMoveAsSource',
    0x4c0240: 'pxifsb::StartDeviceMoveAsDestination',
    0x4d01c4: 'pxifsb::ReadFileSHA256',
    0x4e0204: 'pxifsb::WriteFileSHA256',
    0x4f0080: 'pxifsb::SetCtrCardLatencyParameter',
    0x500040: 'pxifsb::SetPriority',
    0x510040: 'pxifsb::SwitchCleanupInvalidSaveData',
    0x520042: 'pxifsb::EnumerateSystemSaveData',
    0x550082: 'pxifsb::ReadNandReport'
  },
  'pxifsr_handle': {
    0x101c2: 'pxifsr::OpenFile',
    0x20142: 'pxifsr::DeleteFile',
    0x30244: 'pxifsr::RenameFile',
    0x40142: 'pxifsr::DeleteDirectory',
    0x50202: 'pxifsr::CreateFile',
    0x60182: 'pxifsr::CreateDirectory',
    0x70244: 'pxifsr::RenameDirectory',
    0x80102: 'pxifsr::OpenDirectory',
    0x90142: 'pxifsr::ReadFile',
    0xa00c2: 'pxifsr::CalculateFileHashSHA256',
    0xb0182: 'pxifsr::WriteFile',
    0xc0104: 'pxifsr::CalcSavegameMAC',
    0xd0080: 'pxifsr::GetFileSize',
    0xe0100: 'pxifsr::SetFileSize',
    0xf0080: 'pxifsr::CloseFile',
    0x1000c2: 'pxifsr::ReadDirectory',
    0x110080: 'pxifsr::CloseDirectory',
    0x1200c2: 'pxifsr::OpenArchive',
    0x130102: 'pxifsr::HasFile',
    0x140102: 'pxifsr::HasDirectory',
    0x1500c0: 'pxifsr::CommitSaveData',
    0x160080: 'pxifsr::CloseArchive',
    0x170080: 'pxifsr::LockArchive',
    0x180000: 'pxifsr::GetCardType',
    0x190000: 'pxifsr::GetSdmcArchiveResource',
    0x1a0000: 'pxifsr::GetNandArchiveResource',
    0x1b0000: 'pxifsr::GetSdmcFatFsError',
    0x1c0000: 'pxifsr::IsSdmcDetected',
    0x1d0000: 'pxifsr::IsSdmcWritable',
    0x1e0042: 'pxifsr::GetSdmcCid',
    0x1f0042: 'pxifsr::GetNandCid',
    0x200000: 'pxifsr::GetSdmcSpeedInfo',
    0x210000: 'pxifsr::GetNandSpeedInfo',
    0x220042: 'pxifsr::GetSdmcLog',
    0x230042: 'pxifsr::GetNandLog',
    0x240000: 'pxifsr::ClearSdmcLog',
    0x250000: 'pxifsr::ClearNandLog',
    0x260000: 'pxifsr::CardSlotIsInserted',
    0x270000: 'pxifsr::CardSlotPowerOn',
    0x280000: 'pxifsr::CardSlotPowerOff',
    0x290000: 'pxifsr::CardSlotGetIFPowerStatus',
    0x2a0040: 'pxifsr::CardNorDirectCommand',
    0x2b0080: 'pxifsr::CardNorDirectCommandWithAddress',
    0x2c0082: 'pxifsr::CardNorDirectRead',
    0x2d00c2: 'pxifsr::CardNorDirectReadWithAddress',
    0x2e0082: 'pxifsr::CardNorDirectWrite',
    0x2f00c2: 'pxifsr::CardNorDirectWriteWithAddress',
    0x3000c2: 'pxifsr::CardNorDirectRead_4xIO',
    0x310082: 'pxifsr::CardNorDirectCpuWriteWithoutVerify',
    0x320040: 'pxifsr::CardNorDirectSectorEraseWithoutVerify',
    0x330080: 'pxifsr::GetProductInfo',
    0x340040: 'pxifsr::SetCardSpiBaudrate',
    0x350040: 'pxifsr::SetCardSpiBusMode',
    0x360040: 'pxifsr::SendInitializeInfoTo9',
    0x370100: 'pxifsr::CreateExtSaveData',
    0x380100: 'pxifsr::DeleteExtSaveData',
    0x390102: 'pxifsr::EnumerateExtSaveData',
    0x3a0100: 'pxifsr::GetSpecialContentIndex',
    0x3b00c2: 'pxifsr::GetLegacyRomHeader',
    0x3c0102: 'pxifsr::GetLegacyBannerData',
    0x3d0040: 'pxifsr::FormatCardNorDevice',
    0x3e0000: 'pxifsr::DeleteSdmcRoot',
    0x3f0040: 'pxifsr::DeleteAllExtSaveDataOnNand',
    0x400000: 'pxifsr::InitializeCtrFilesystem',
    0x410000: 'pxifsr::CreateSeed',
    0x420042: 'pxifsr::GetSdmcCtrRootPath',
    0x430040: 'pxifsr::GetArchiveResource',
    0x440002: 'pxifsr::ExportIntegrityVerificationSeed',
    0x450002: 'pxifsr::ImportIntegrityVerificationSeed',
    0x460102: 'pxifsr::GetLegacySubBannerData',
    0x470042: 'pxifsr::GenerateRandomBytes',
    0x4800c2: 'pxifsr::GetFileLastModified',
    0x490102: 'pxifsr::ReadSpecialFile',
    0x4a0040: 'pxifsr::GetSpecialFileSize',
    0x4b0000: 'pxifsr::StartDeviceMoveAsSource',
    0x4c0240: 'pxifsr::StartDeviceMoveAsDestination',
    0x4d01c4: 'pxifsr::ReadFileSHA256',
    0x4e0204: 'pxifsr::WriteFileSHA256',
    0x4f0080: 'pxifsr::SetCtrCardLatencyParameter',
    0x500040: 'pxifsr::SetPriority',
    0x510040: 'pxifsr::SwitchCleanupInvalidSaveData',
    0x520042: 'pxifsr::EnumerateSystemSaveData',
    0x550082: 'pxifsr::ReadNandReport'
  },
  'pxipm_handle': {
    0x10082: 'pxipm::GetProgramInfo',
    0x20200: 'pxipm::RegisterProgram',
    0x30080: 'pxipm::UnregisterProgram'
  },
  'pxi_am9_handle': {
    0x10040: 'pxi::GetTitleCount',
    0x20082: 'pxi::GetTitleList',
    0x30084: 'pxi::GetTitleInfo',
    0x400c0: 'pxi::DeleteTitle',
    0x500c0: 'pxi::GetTitleProductCode',
    0x600c0: 'pxi::GetTitleExtDataId',
    0x70080: 'pxi::DeletePendingTitles',
    0x80080: 'pxi::InstallFIRM',
    0x90000: 'pxi::InstallTikBegin',
    0xa0042: 'pxi::InstallTikWrite',
    0xb0000: 'pxi::InstallTikAbort',
    0xc0000: 'pxi::InstallTikFinish',
    0xd0080: 'pxi::DeleteTicket',
    0xe0000: 'pxi::GetTicketCount',
    0xf0082: 'pxi::GetTicketList',
    0x100100: 'pxi::InstallTitleBegin',
    0x110000: 'pxi::InstallTitleAbort',
    0x1200c0: 'pxi::InstallTitleResume',
    0x130000: 'pxi::InstallTmdBegin',
    0x140042: 'pxi::InstallTmdWrite',
    0x150000: 'pxi::InstallTmdAbort',
    0x160040: 'pxi::InstallTmdFinish',
    0x170040: 'pxi::InstallContentBegin',
    0x180042: 'pxi::InstallContentWrite',
    0x190000: 'pxi::InstallContentAbort',
    0x1a0000: 'pxi::InstallContentAbortDSi',
    0x1b0040: 'pxi::InstallContentResume',
    0x1c0000: 'pxi::InstallContentFinish',
    0x1d0080: 'pxi::GetPendingTitleCount',
    0x1e00c2: 'pxi::GetPendingTitleList',
    0x1f0084: 'pxi::GetPendingTitleInfo',
    0x2000c0: 'pxi::DeletePendingTitle',
    0x2100c0: 'pxi::GetNumImportContentContexts',
    0x220102: 'pxi::GetImportContentContextList',
    0x230104: 'pxi::GetImportContentContexts',
    0x240102: 'pxi::DeleteImportContentContexts',
    0x250000: 'pxi::GetNumCurrentImportContentContexts',
    0x260042: 'pxi::GetCurrentImportContentContextList',
    0x270044: 'pxi::GetCurrentImportContentContexts',
    0x280000: 'pxi::InstallTitleAbortDSi',
    0x290000: 'pxi::InstallTitleFinish',
    0x2a00c2: 'pxi::InstallTitlesFinish',
    0x390146: 'pxi::Sign',
    0x3b0042: 'pxi::GetCTCert',
    0x3c0000: 'pxi::GetDeviceID',
    0x3d0108: 'pxi::SetCertificates',
    0x3e0042: 'pxi::SetCertificate',
    0x3f0040: 'pxi::IsImportDatabaseInitialized',
    0x400040: 'pxi::DoCleanup',
    0x410000: 'pxi::DeleteAllTemporaryPrograms',
    0x420142: 'pxi::InstallTitlesFinishFIRM',
    0x4301c8: 'pxi::VerifyDSiWareFooter',
    0x460182: 'pxi::WriteTWLSavedata',
    0x470080: 'pxi::InitializeTitleDatabase',
    0x480040: 'pxi::ReloadDBS',
    0x490080: 'pxi::GetNumTicketIds',
    0x4a0102: 'pxi::GetTicketIdList',
    0x4b0100: 'pxi::DeleteTicketId',
    0x4c0042: 'pxi::GetPersonalizedTicketInfoList',
    0x4d0144: 'pxi::ExportDSiWare',
    0x4e00c0: 'pxi::InstallTitleBeginDSi',
    0x4f00c0: 'pxi::GetDSiWareExportSize',
    0x500044: 'pxi::GetTwlProgramListForReboot',
    0x510000: 'pxi::DeleteAllTwlUserPrograms',
    0x520040: 'pxi::DeleteAllExpiredUserPrograms',
    0x530084: 'pxi::ValidateDSiWareMovableSedHash',
    0x540000: 'pxi::GetTWLPartitionInfo',
    0x5500c4: 'pxi::ValidateDSiWareSectionMAC',
    0x5600c0: 'pxi::CheckContentRights',
    0x570042: 'pxi::InstallTitleSetContentIndices',
    0x5800c0: 'pxi::GetNumContentInfos',
    0x590104: 'pxi::FindContentInfos',
    0x5a0142: 'pxi::ListContentInfos',
    0x5b0000: 'pxi::GetNumCurrentContentInfos',
    0x5d0082: 'pxi::ListCurrentContentInfos',
    0x5e0102: 'pxi::DeleteContents',
    0x600102: 'pxi::ListDataTitleTicketInfos',
    0x610142: 'pxi::ExportLicenseTicket',
    0x620044: 'pxi::GetTicketLimitInfos',
    0x630042: 'pxi::UpdateImportContentContexts',
    0x6400c0: 'pxi::GetInternalTitleLocationInfo',
    0x6500c0: 'pxi::MigrateAGBtoSAV',
    0x670082: 'pxi::DeleteProgramsAtomically',
    0x6801c2: 'pxi::GetItemRights',
    0x6900c0: 'pxi::IsDataTitleInUse',
    0x6a00c0: 'pxi::GetNumExistingContentInfos',
    0x6d0184: 'pxi::ExportTicketWrapped'
  },
  'pxi_dev_handle': {
    0x101c2: 'pxi::ReadHostIO',
    0x201c2: 'pxi::WriteHostIO',
    0x30102: 'pxi::ReadHostEx',
    0x40102: 'pxi::WriteHostEx',
    0x50102: 'pxi::WriteHostExStart',
    0x60102: 'pxi::WriteHostExChunk',
    0x70000: 'pxi::WriteHostExEnd',
    0x80000: 'pxi::InitializeMIDI',
    0x90000: 'pxi::FinalizeMIDI',
    0xa0000: 'pxi::GetMIDIInfo',
    0xb0000: 'pxi::GetMIDIBufferSize',
    0xc0042: 'pxi::ReadMIDI',
    0xd0688: 'pxi::SPIMultiWriteRead',
    0xe0284: 'pxi::SPIWriteRead',
    0xf0000: 'pxi::GetCardDevice'
  },
  'pxi_mc_handle': {
    0x10000: 'pxi::ShutdownPxi',
    0x50040: 'pxi::Sleep'
  },
  'pxi_ps9_handle': {
    0x100c6: 'pxi::CryptWithRsa',
    0x20284: 'pxi::SignRsaSha256',
    0x30284: 'pxi::VerifyRsaSha256',
    0x401c4: 'pxi::EncryptDecryptAes',
    0x50284: 'pxi::EncryptSignDecryptVerifyAesCcm',
    0x60000: 'pxi::GetRomId',
    0x70000: 'pxi::GetRomId2',
    0x80000: 'pxi::GetCTRCardAutoStartupBit',
    0x90000: 'pxi::GetRomMakerCode',
    0xa0000: 'pxi::GetLocalFriendCodeSeed',
    0xb0000: 'pxi::GetDeviceId',
    0xc0042: 'pxi::SeedRNG',
    0xd0042: 'pxi::GenerateRandomBytes'
  },
  'am_sys_handle': {
    0x10040: 'am::GetNumPrograms',
    0x20082: 'am::GetProgramList',
    0x30084: 'am::GetProgramInfos',
    0x400c0: 'am::DeleteUserProgram',
    0x500c0: 'am::GetProductCode',
    0x600c0: 'am::GetStorageId',
    0x70080: 'am::DeleteTicket',
    0x80000: 'am::GetNumTickets',
    0x90082: 'am::GetTicketList',
    0xa0000: 'am::GetDeviceId',
    0xb0040: 'am::GetNumImportTitleContexts',
    0xc0082: 'am::GetImportTitleContextList',
    0xd0084: 'am::GetImportTitleContexts',
    0xe00c0: 'am::DeleteImportTitleContext',
    0xf00c0: 'am::GetNumImportContentContexts',
    0x100102: 'am::GetImportContentContextList',
    0x110104: 'am::GetImportContentContexts',
    0x120102: 'am::DeleteImportContentContexts',
    0x130040: 'am::NeedsCleanup',
    0x140040: 'am::DoCleanup',
    0x150040: 'am::DeleteAllImportContexts',
    0x160000: 'am::DeleteAllTemporaryPrograms',
    0x170044: 'am::ImportTwlBackupLegacy',
    0x180080: 'am::InitializeTitleDatabase',
    0x190040: 'am::QueryAvailableTitleDatabase',
    0x1a00c0: 'am::CalcTwlBackupSize',
    0x1b0144: 'am::ExportTwlBackup',
    0x1c0084: 'am::ImportTwlBackup',
    0x1d0000: 'am::DeleteAllTwlUserPrograms',
    0x1e00c8: 'am::ReadTwlBackupInfo',
    0x1f0040: 'am::DeleteAllExpiredUserPrograms',
    0x200000: 'am::GetTwlArchiveResourceInfo',
    0x210042: 'am::GetPersonalizedTicketInfoList',
    0x220080: 'am::DeleteAllImportContextsFiltered',
    0x230080: 'am::GetNumImportTitleContextsFiltered',
    0x2400c2: 'am::GetImportTitleContextListFiltered',
    0x2500c0: 'am::CheckContentRights',
    0x260044: 'am::GetTicketLimitInfos',
    0x270044: 'am::GetDemoLaunchInfos',
    0x280108: 'am::ReadTwlBackupInfoEx',
    0x290082: 'am::DeleteUserProgramsAtomically',
    0x2a00c0: 'am::GetNumExistingContentInfos',
    0x2b0142: 'am::ListExistingContentInfos',
    0x2c0084: 'am::GetProgramInfosIgnorePlatform',
    0x2d00c0: 'am::CheckContentRightsIgnorePlatform'
  },
  'am_u_handle': {
    0x10040: 'am::GetNumPrograms',
    0x20082: 'am::GetProgramList',
    0x30084: 'am::GetProgramInfos',
    0x400c0: 'am::DeleteUserProgram',
    0x500c0: 'am::GetProductCode',
    0x600c0: 'am::GetStorageId',
    0x70080: 'am::DeleteTicket',
    0x80000: 'am::GetNumTickets',
    0x90082: 'am::GetTicketList',
    0xa0000: 'am::GetDeviceId',
    0xb0040: 'am::GetNumImportTitleContexts',
    0xc0082: 'am::GetImportTitleContextList',
    0xd0084: 'am::GetImportTitleContexts',
    0xe00c0: 'am::DeleteImportTitleContext',
    0xf00c0: 'am::GetNumImportContentContexts',
    0x100102: 'am::GetImportContentContextList',
    0x110104: 'am::GetImportContentContexts',
    0x120102: 'am::DeleteImportContentContexts',
    0x130040: 'am::NeedsCleanup',
    0x140040: 'am::DoCleanup',
    0x150040: 'am::DeleteAllImportContexts',
    0x160000: 'am::DeleteAllTemporaryPrograms',
    0x170044: 'am::ImportTwlBackupLegacy',
    0x180080: 'am::InitializeTitleDatabase',
    0x190040: 'am::QueryAvailableTitleDatabase',
    0x1a00c0: 'am::CalcTwlBackupSize',
    0x1b0144: 'am::ExportTwlBackup',
    0x1c0084: 'am::ImportTwlBackup',
    0x1d0000: 'am::DeleteAllTwlUserPrograms',
    0x1e00c8: 'am::ReadTwlBackupInfo',
    0x1f0040: 'am::DeleteAllExpiredUserPrograms',
    0x200000: 'am::GetTwlArchiveResourceInfo',
    0x210042: 'am::GetPersonalizedTicketInfoList',
    0x220080: 'am::DeleteAllImportContextsFiltered',
    0x230080: 'am::GetNumImportTitleContextsFiltered',
    0x2400c2: 'am::GetImportTitleContextListFiltered',
    0x2500c0: 'am::CheckContentRights',
    0x260044: 'am::GetTicketLimitInfos',
    0x270044: 'am::GetDemoLaunchInfos',
    0x280108: 'am::ReadTwlBackupInfoEx',
    0x290082: 'am::DeleteUserProgramsAtomically',
    0x2a00c0: 'am::GetNumExistingContentInfos',
    0x2b0142: 'am::ListExistingContentInfos',
    0x2c0084: 'am::GetProgramInfosIgnorePlatform',
    0x2d00c0: 'am::CheckContentRightsIgnorePlatform',
    0x4010080: 'am::UpdateFirmwareTo',
    0x4020040: 'am::BeginImportProgram',
    0x4030000: 'am::BeginImportProgramTemporarily',
    0x4040002: 'am::CancelImportProgram',
    0x4050002: 'am::EndImportProgram',
    0x4060002: 'am::EndImportProgramWithoutCommit',
    0x40700c2: 'am::CommitImportPrograms',
    0x4080042: 'am::GetProgramInfoFromCia',
    0x4090004: 'am::GetSystemMenuDataFromCia',
    0x40a0002: 'am::GetDependencyListFromCia',
    0x40b0002: 'am::GetTransferSizeFromCia',
    0x40c0002: 'am::GetCoreVersionFromCia',
    0x40d0042: 'am::GetRequiredSizeFromCia',
    0x40e00c2: 'am::CommitImportProgramsAndUpdateFirmwareAuto',
    0x40f0000: 'am::UpdateFirmwareAuto',
    0x41000c0: 'am::DeleteProgram',
    0x4110044: 'am::GetTwlProgramListForReboot',
    0x4120000: 'am::GetSystemUpdaterMutex',
    0x4130002: 'am::GetMetaSizeFromCia',
    0x4140044: 'am::GetMetaDataFromCia',
    0x4150080: 'am::CheckDemoLaunchRights',
    0x41600c0: 'am::GetInternalTitleLocationInfo',
    0x41700c0: 'am::PerpetuateAgbSaveData',
    0x4180040: 'am::BeginImportProgramForOverWrite',
    0x4190000: 'am::BeginImportSystemProgram'
  },
  'am_net_handle': {
    0x10040: 'am::GetNumPrograms',
    0x20082: 'am::GetProgramList',
    0x30084: 'am::GetProgramInfos',
    0x400c0: 'am::DeleteUserProgram',
    0x500c0: 'am::GetProductCode',
    0x600c0: 'am::GetStorageId',
    0x70080: 'am::DeleteTicket',
    0x80000: 'am::GetNumTickets',
    0x90082: 'am::GetTicketList',
    0xa0000: 'am::GetDeviceId',
    0xb0040: 'am::GetNumImportTitleContexts',
    0xc0082: 'am::GetImportTitleContextList',
    0xd0084: 'am::GetImportTitleContexts',
    0xe00c0: 'am::DeleteImportTitleContext',
    0xf00c0: 'am::GetNumImportContentContexts',
    0x100102: 'am::GetImportContentContextList',
    0x110104: 'am::GetImportContentContexts',
    0x120102: 'am::DeleteImportContentContexts',
    0x130040: 'am::NeedsCleanup',
    0x140040: 'am::DoCleanup',
    0x150040: 'am::DeleteAllImportContexts',
    0x160000: 'am::DeleteAllTemporaryPrograms',
    0x170044: 'am::ImportTwlBackupLegacy',
    0x180080: 'am::InitializeTitleDatabase',
    0x190040: 'am::QueryAvailableTitleDatabase',
    0x1a00c0: 'am::CalcTwlBackupSize',
    0x1b0144: 'am::ExportTwlBackup',
    0x1c0084: 'am::ImportTwlBackup',
    0x1d0000: 'am::DeleteAllTwlUserPrograms',
    0x1e00c8: 'am::ReadTwlBackupInfo',
    0x1f0040: 'am::DeleteAllExpiredUserPrograms',
    0x200000: 'am::GetTwlArchiveResourceInfo',
    0x210042: 'am::GetPersonalizedTicketInfoList',
    0x220080: 'am::DeleteAllImportContextsFiltered',
    0x230080: 'am::GetNumImportTitleContextsFiltered',
    0x2400c2: 'am::GetImportTitleContextListFiltered',
    0x2500c0: 'am::CheckContentRights',
    0x260044: 'am::GetTicketLimitInfos',
    0x270044: 'am::GetDemoLaunchInfos',
    0x280108: 'am::ReadTwlBackupInfoEx',
    0x290082: 'am::DeleteUserProgramsAtomically',
    0x2a00c0: 'am::GetNumExistingContentInfos',
    0x2b0142: 'am::ListExistingContentInfos',
    0x2c0084: 'am::GetProgramInfosIgnorePlatform',
    0x2d00c0: 'am::CheckContentRightsIgnorePlatform',
    0x4010080: 'am::UpdateFirmwareTo',
    0x4020040: 'am::BeginImportProgram',
    0x4030000: 'am::BeginImportProgramTemporarily',
    0x4040002: 'am::CancelImportProgram',
    0x4050002: 'am::EndImportProgram',
    0x4060002: 'am::EndImportProgramWithoutCommit',
    0x40700c2: 'am::CommitImportPrograms',
    0x4080042: 'am::GetProgramInfoFromCia',
    0x4090004: 'am::GetSystemMenuDataFromCia',
    0x40a0002: 'am::GetDependencyListFromCia',
    0x40b0002: 'am::GetTransferSizeFromCia',
    0x40c0002: 'am::GetCoreVersionFromCia',
    0x40d0042: 'am::GetRequiredSizeFromCia',
    0x40e00c2: 'am::CommitImportProgramsAndUpdateFirmwareAuto',
    0x40f0000: 'am::UpdateFirmwareAuto',
    0x41000c0: 'am::DeleteProgram',
    0x4110044: 'am::GetTwlProgramListForReboot',
    0x4120000: 'am::GetSystemUpdaterMutex',
    0x4130002: 'am::GetMetaSizeFromCia',
    0x4140044: 'am::GetMetaDataFromCia',
    0x4150080: 'am::CheckDemoLaunchRights',
    0x41600c0: 'am::GetInternalTitleLocationInfo',
    0x41700c0: 'am::PerpetuateAgbSaveData',
    0x4180040: 'am::BeginImportProgramForOverWrite',
    0x4190000: 'am::BeginImportSystemProgram',
    0x8010000: 'am::BeginImportTicket',
    0x8020002: 'am::CancelImportTicket',
    0x8030002: 'am::EndImportTicket',
    0x8040100: 'am::BeginImportTitle',
    0x8050000: 'am::StopImportTitle',
    0x80600c0: 'am::ResumeImportTitle',
    0x8070000: 'am::CancelImportTitle',
    0x8080000: 'am::EndImportTitle',
    0x80900c2: 'am::CommitImportTitles',
    0x80a0000: 'am::BeginImportTmd',
    0x80b0002: 'am::CancelImportTmd',
    0x80c0042: 'am::EndImportTmd',
    0x80d0042: 'am::CreateImportContentContexts',
    0x80e0040: 'am::BeginImportContent',
    0x80f0002: 'am::StopImportContent',
    0x8100040: 'am::ResumeImportContent',
    0x8110002: 'am::CancelImportContent',
    0x8120002: 'am::EndImportContent',
    0x8130000: 'am::GetNumCurrentImportContentContexts',
    0x8140042: 'am::GetCurrentImportContentContextList',
    0x8150044: 'am::GetCurrentImportContentContexts',
    0x8160146: 'am::Sign',
    0x8170146: 'am::Verify',
    0x8180042: 'am::GetDeviceCert',
    0x8190108: 'am::ImportCertificates',
    0x81a0042: 'am::ImportCertificate',
    0x81b00c2: 'am::CommitImportTitlesAndUpdateFirmwareAuto',
    0x81c0100: 'am::DeleteTicketId',
    0x81d0080: 'am::GetNumTicketIds',
    0x81e0102: 'am::GetTicketIdList',
    0x81f0080: 'am::GetNumTicketsOfProgram',
    0x8200102: 'am::ListTicketInfos',
    0x8210142: 'am::ExportLicenseTicket',
    0x8220000: 'am::GetNumCurrentContentInfos',
    0x8230044: 'am::FindCurrentContentInfos',
    0x8240082: 'am::ListCurrentContentInfos',
    0x8250102: 'am::CalculateContextRequiredSize',
    0x8260042: 'am::UpdateImportContentContexts',
    0x8270000: 'am::DeleteAllDemoLaunchInfos',
    0x82800c0: 'am::BeginImportTitleForOverWrite',
    0x8290184: 'am::ExportTicketWrapped'
  },
  'am_app_handle': {
    0x100100c0: 'am::GetDLCContentInfoCount',
    0x10020104: 'am::FindDLCContentInfos',
    0x10030142: 'am::ListDLCContentInfos',
    0x10040102: 'am::DeleteContents',
    0x10050084: 'am::GetDLCTitleInfos',
    0x10060080: 'am::GetDLCOrLicenseNumTickets',
    0x10070102: 'am::ListDataTitleTicketInfos',
    0x100801c2: 'am::GetDLCOrLicenseItemRights',
    0x100900c0: 'am::IsDataTitleInUse',
    0x100a0000: 'am::IsExternalTitleDatabaseInitialized',
    0x100b00c0: 'am::GetNumDLCExistingContentInfos',
    0x100c0142: 'am::ListExistingContentInfos',
    0x100d0084: 'am::GetPatchTitleInfos'
  },
  'pm_app_handle': {
    0x10140: 'pm::LaunchTitle',
    0x20082: 'pm::LaunchFIRM',
    0x30080: 'pm::TerminateApplication',
    0x40100: 'pm::TerminateTitle',
    0x500c0: 'pm::TerminateProcess',
    0x60082: 'pm::PrepareForReboot',
    0x70042: 'pm::GetFIRMLaunchParams',
    0x80100: 'pm::GetTitleExheaderFlags',
    0x90042: 'pm::SetFIRMLaunchParams',
    0xa0140: 'pm::SetAppResourceLimit',
    0xb0140: 'pm::GetAppResourceLimit',
    0xc0080: 'pm::UnregisterProcess',
    0xd0240: 'pm::LaunchTitleUpdate'
  },
  'pm_dbg_handle': {
    0x10140: 'pm::LaunchAppDebug',
    0x20140: 'pm::LaunchApp',
    0x30000: 'pm::RunQueuedProcess'
  },
  'nim_u_handle': {
    0x20000: 'nim::GetUpdateDownloadProgress',
    0x40000: 'nim::FinishTitlesInstall',
    0x90000: 'nim::CheckSysupdateAvailable',
    0xa0000: 'nim::GetState',
    0xb0000: 'nim::GetSystemTitleHash',
    0xc0082: 'nim::UnregisterTask',
    0x290246: 'nim::RegisterTask'
  },
  'nim_s_handle': {
    0x10200: 'nim::StartDownloadSimple',
    0x20000: 'nim::CancelDownload',
    0x30000: 'nim::GetProgress',
    0x50082: 'nim::UnregisterTask',
    0x60080: 'nim::IsTaskRegistered',
    0xa0000: 'nim::CheckSysupdateAvailableSOAP',
    0xb0084: 'nim::SetAttribute',
    0x16020a: 'nim::ListTitles',
    0x220080: 'nim::AccountDeleteTitleETicketsSOAP',
    0x290000: 'nim::AccountCheckBalanceSOAP',
    0x2d0042: 'nim::DownloadTickets',
    0x3c0002: 'nim::RegisterSelf',
    0x3f0000: 'nim::GetInitializeResult',
    0x420240: 'nim::StartDownload',
    0x550246: 'nim::RegisterTask',
    0x570082: 'nim::ConnectNoTicketDownload'
  },
  'nim_aoc_handle': {
    0x30042: 'nim::SetApplicationId',
    0x40042: 'nim::SetTin',
    0x902d0: 'nim::ListContentSetsEx',
    0x180000: 'nim::GetBalance',
    0x1d0000: 'nim::GetCustomerSupportCode',
    0x210000: 'nim::Initialize',
    0x240282: 'nim::CalculateContentsRequiredSize',
    0x250000: 'nim::RefreshServerTime'
  },
  'cfg_u_handle': {
    0x10082: 'cfg::GetConfigInfoBlk2',
    0x20000: 'cfg::SecureInfoGetRegion',
    0x30040: 'cfg::GenHashConsoleUnique/GetTransferableId',
    0x40000: 'cfg::GetRegionCanadaUSA/IsCoppacsSupported',
    0x50000: 'cfg::GetSystemModel',
    0x60000: 'cfg::GetModelNintendo2DS',
    0x80080: 'cfg::TranslateCountryInfo',
    0x90040: 'cfg::GetCountryCodeString',
    0xa0040: 'cfg::GetCountryCodeID',
    0xb0000: 'cfg::IsFangateSupported'
  },
  'cfg_s_handle': {
    0x4010082: 'cfg::GetConfigInfoBlk8',
    0x4020082: 'cfg::SetConfigInfoBlk4',
    0x4030000: 'cfg::UpdateConfigNANDSavegame',
    0x4040042: 'cfg::GetLocalFriendCodeSeedData',
    0x4050000: 'cfg::GetLocalFriendCodeSeed',
    0x4060000: 'cfg::SecureInfoGetRegion',
    0x4070000: 'cfg::SecureInfoGetByte101',
    0x4080042: 'cfg::SecureInfoGetSerialNo',
    0x4090000: 'cfg::UpdateConfigBlk00040003',
    0x40f0000: 'cfg::ClearParentalControls',
    0x10082: 'cfg::GetConfigInfoBlk2',
    0x20000: 'cfg::SecureInfoGetRegion',
    0x30040: 'cfg::GenHashConsoleUnique/GetTransferableId',
    0x40000: 'cfg::GetRegionCanadaUSA/IsCoppacsSupported',
    0x50000: 'cfg::GetSystemModel',
    0x60000: 'cfg::GetModelNintendo2DS',
    0x80080: 'cfg::TranslateCountryInfo',
    0x90040: 'cfg::GetCountryCodeString',
    0xa0040: 'cfg::GetCountryCodeID',
    0xb0000: 'cfg::IsFangateSupported'
  },
  'cfg_i_handle': {
    0x4010082: 'cfg::GetConfigInfoBlk8',
    0x4020082: 'cfg::SetConfigInfoBlk4',
    0x4030000: 'cfg::UpdateConfigNANDSavegame',
    0x4040042: 'cfg::GetLocalFriendCodeSeedData',
    0x4050000: 'cfg::GetLocalFriendCodeSeed',
    0x4060000: 'cfg::SecureInfoGetRegion',
    0x4070000: 'cfg::SecureInfoGetByte101',
    0x4080042: 'cfg::SecureInfoGetSerialNo',
    0x4090000: 'cfg::UpdateConfigBlk00040003',
    0x40f0000: 'cfg::ClearParentalControls',
    0x8010082: 'cfg::GetConfigInfoBlk8',
    0x8020082: 'cfg::SetConfigInfoBlk4',
    0x8030000: 'cfg::UpdateConfigNANDSavegame',
    0x80400c2: 'cfg::CreateConfigInfoBlk',
    0x8050000: 'cfg::DeleteConfigNANDSavefile',
    0x8060000: 'cfg::FormatConfig',
    0x80a0000: 'cfg::ResetAnalogStickCalibrationParam',
    0x80b0082: 'cfg::SetGetLocalFriendCodeSeedData',
    0x80c0042: 'cfg::SetLocalFriendCodeSeedSignature',
    0x80d0000: 'cfg::DeleteCreateNANDLocalFriendCodeSeed',
    0x80e0000: 'cfg::VerifySigLocalFriendCodeSeed',
    0x80f0042: 'cfg::GetLocalFriendCodeSeedData',
    0x8100000: 'cfg::GetLocalFriendCodeSeed',
    0x8110084: 'cfg::SetSecureInfo',
    0x8120000: 'cfg::DeleteCreateNANDSecureInfo',
    0x8130000: 'cfg::VerifySigSecureInfo',
    0x8140042: 'cfg::SecureInfoGetData',
    0x8150042: 'cfg::SecureInfoGetSignature',
    0x8160000: 'cfg::SecureInfoGetRegion',
    0x8170000: 'cfg::SecureInfoGetByte101',
    0x8180042: 'cfg::SecureInfoGetSerialNo',
    0x10082: 'cfg::GetConfigInfoBlk2',
    0x20000: 'cfg::SecureInfoGetRegion',
    0x30040: 'cfg::GenHashConsoleUnique',
    0x40000: 'cfg::GetRegionCanadaUSA',
    0x50000: 'cfg::GetSystemModel',
    0x60000: 'cfg::GetModelNintendo2DS',
    0x80080: 'cfg::TranslateCountryInfo',
    0x90040: 'cfg::GetCountryCodeString',
    0xa0040: 'cfg::GetCountryCodeID',
    0xb0000: 'cfg::IsFangateSupported'
  },
  'cfg_nor_handle': {
    0x10040: 'cfg::Initialize',
    0x20000: 'cfg::Shutdown',
    0x50082: 'cfg::ReadData',
    0x60082: 'cfg::WriteData',
    0x90000: 'cfg::ReadIdentification',
    0xe0000: 'cfg::ReadStatusRegister',
    0xf0082: 'cfg::ReadDataOther',
    0x100082: 'cfg::WriteDataOther'
  },
  'ns_s_handle': {
    0x100c0: 'ns::LaunchFIRM',
    0x200c0: 'ns::LaunchTitle',
    0x30000: 'ns::TerminateApplication',
    0x40040: 'ns::TerminateProcess',
    0x500c0: 'ns::LaunchApplicationFIRM',
    0x60042: 'ns::SetWirelessRebootInfo',
    0x70042: 'ns::CardUpdateInitialize',
    0x80000: 'ns::CardUpdateShutdown',
    0xd0140: 'ns::SetTWLBannerHMAC',
    0xe0000: 'ns::ShutdownAsync',
    0x100180: 'ns::RebootSystem',
    0x110100: 'ns::TerminateTitle',
    0x1200c0: 'ns::SetApplicationCpuTimeLimit',
    0x150140: 'ns::LaunchApplication',
    0x160000: 'ns::RebootSystemClean'
  },
  'ns_p_handle': {
    0x10040: 'ns::RebootSystem',
    0x20000: 'ns::ShutdownAsync'
  },
  'apt_a_handle': {
    0x10040: 'apt::GetLockHandle',
    0x20080: 'apt::Initialize',
    0x30040: 'apt::Enable',
    0x40040: 'apt::Finalize',
    0x50040: 'apt::GetAppletManInfo',
    0x60040: 'apt::GetAppletInfo',
    0x70000: 'apt::GetLastSignaledAppletId',
    0x80000: 'apt::CountRegisteredApplet',
    0x90040: 'apt::IsRegistered',
    0xa0040: 'apt::GetAttribute',
    0xb0040: 'apt::InquireNotification',
    0xc0104: 'apt::SendParameter',
    0xd0080: 'apt::ReceiveParameter',
    0xe0080: 'apt::GlanceParameter',
    0xf0100: 'apt::CancelParameter',
    0x1000c2: 'apt::DebugFunc',
    0x1100c0: 'apt::MapProgramIdForDebug',
    0x120040: 'apt::SetHomeMenuAppletIdForDebug',
    0x130000: 'apt::GetPreparationState',
    0x140040: 'apt::SetPreparationState',
    0x150140: 'apt::PrepareToStartApplication',
    0x160040: 'apt::PreloadLibraryApplet',
    0x170040: 'apt::FinishPreloadingLibraryApplet',
    0x180040: 'apt::PrepareToStartLibraryApplet',
    0x190040: 'apt::PrepareToStartSystemApplet',
    0x1a0000: 'apt::PrepareToStartNewestHomeMenu',
    0x1b00c4: 'apt::StartApplication',
    0x1c0000: 'apt::WakeupApplication',
    0x1d0000: 'apt::CancelApplication',
    0x1e0084: 'apt::StartLibraryApplet',
    0x1f0084: 'apt::StartSystemApplet',
    0x200044: 'apt::StartNewestHomeMenu',
    0x210000: 'apt::OrderToCloseApplication',
    0x220040: 'apt::PrepareToCloseApplication',
    0x230040: 'apt::PrepareToJumpToApplication',
    0x240044: 'apt::JumpToApplication',
    0x2500c0: 'apt::PrepareToCloseLibraryApplet',
    0x260000: 'apt::PrepareToCloseSystemApplet',
    0x270044: 'apt::CloseApplication',
    0x280044: 'apt::CloseLibraryApplet',
    0x290044: 'apt::CloseSystemApplet',
    0x2a0000: 'apt::OrderToCloseSystemApplet',
    0x2b0000: 'apt::PrepareToJumpToHomeMenu',
    0x2c0044: 'apt::JumpToHomeMenu',
    0x2d0000: 'apt::PrepareToLeaveHomeMenu',
    0x2e0044: 'apt::LeaveHomeMenu',
    0x2f0040: 'apt::PrepareToLeaveResidentApplet',
    0x300044: 'apt::LeaveResidentApplet',
    0x310100: 'apt::PrepareToDoApplicationJump',
    0x320084: 'apt::DoApplicationJump',
    0x330000: 'apt::GetProgramIdOnApplicationJump',
    0x340084: 'apt::SendDeliverArg',
    0x350080: 'apt::ReceiveDeliverArg',
    0x360040: 'apt::LoadSysMenuArg',
    0x370042: 'apt::StoreSysMenuArg',
    0x380040: 'apt::PreloadResidentApplet',
    0x390040: 'apt::PrepareToStartResidentApplet',
    0x3a0044: 'apt::StartResidentApplet',
    0x3b0040: 'apt::CancelLibraryApplet',
    0x3c0042: 'apt::SendDspSleep',
    0x3d0042: 'apt::SendDspWakeUp',
    0x3e0080: 'apt::ReplySleepQuery',
    0x3f0040: 'apt::ReplySleepNotificationComplete',
    0x400042: 'apt::SendCaptureBufferInfo',
    0x410040: 'apt::ReceiveCaptureBufferInfo',
    0x420080: 'apt::SleepSystem',
    0x430040: 'apt::NotifyToWait',
    0x440000: 'apt::GetSharedFont',
    0x450040: 'apt::GetWirelessRebootInfo',
    0x460104: 'apt::Wrap',
    0x470104: 'apt::Unwrap',
    0x480100: 'apt::GetProgramInfo',
    0x490180: 'apt::Reboot',
    0x4a0040: 'apt::GetCaptureInfo',
    0x4b00c2: 'apt::AppletUtility',
    0x4c0000: 'apt::SetFatalErrDispMode',
    0x4d0080: 'apt::GetAppletProgramInfo',
    0x4e0000: 'apt::HardwareResetAsync',
    0x4f0080: 'apt::SetApplicationCpuTimeLimit',
    0x500040: 'apt::GetApplicationCpuTimeLimit',
    0x510080: 'apt::GetStartupArgument',
    0x520104: 'apt::Wrap1',
    0x530104: 'apt::Unwrap1',
    0x550040: 'apt::SetScreencapPostPermission',
    0x560000: 'apt::GetScreencapPostPermission',
    0x570044: 'apt::WakeupApplication2',
    0x580002: 'apt::GetProgramID',
    0x1010000: 'apt::CheckNew3DSApp',
    0x1020000: 'apt::CheckNew3DS',
    0x1040000: 'apt::IsStandardMemoryLayout',
    0x1050100: 'apt::IsTitleAllowed'
  },
  'apt_u_handle': {
    0x10040: 'apt::GetLockHandle',
    0x20080: 'apt::Initialize',
    0x30040: 'apt::Enable',
    0x40040: 'apt::Finalize',
    0x50040: 'apt::GetAppletManInfo',
    0x60040: 'apt::GetAppletInfo',
    0x70000: 'apt::GetLastSignaledAppletId',
    0x80000: 'apt::CountRegisteredApplet',
    0x90040: 'apt::IsRegistered',
    0xa0040: 'apt::GetAttribute',
    0xb0040: 'apt::InquireNotification',
    0xc0104: 'apt::SendParameter',
    0xd0080: 'apt::ReceiveParameter',
    0xe0080: 'apt::GlanceParameter',
    0xf0100: 'apt::CancelParameter',
    0x1000c2: 'apt::DebugFunc',
    0x1100c0: 'apt::MapProgramIdForDebug',
    0x120040: 'apt::SetHomeMenuAppletIdForDebug',
    0x130000: 'apt::GetPreparationState',
    0x140040: 'apt::SetPreparationState',
    0x150140: 'apt::PrepareToStartApplication',
    0x160040: 'apt::PreloadLibraryApplet',
    0x170040: 'apt::FinishPreloadingLibraryApplet',
    0x180040: 'apt::PrepareToStartLibraryApplet',
    0x190040: 'apt::PrepareToStartSystemApplet',
    0x1a0000: 'apt::PrepareToStartNewestHomeMenu',
    0x1b00c4: 'apt::StartApplication',
    0x1c0000: 'apt::WakeupApplication',
    0x1d0000: 'apt::CancelApplication',
    0x1e0084: 'apt::StartLibraryApplet',
    0x1f0084: 'apt::StartSystemApplet',
    0x200044: 'apt::StartNewestHomeMenu',
    0x210000: 'apt::OrderToCloseApplication',
    0x220040: 'apt::PrepareToCloseApplication',
    0x230040: 'apt::PrepareToJumpToApplication',
    0x240044: 'apt::JumpToApplication',
    0x2500c0: 'apt::PrepareToCloseLibraryApplet',
    0x260000: 'apt::PrepareToCloseSystemApplet',
    0x270044: 'apt::CloseApplication',
    0x280044: 'apt::CloseLibraryApplet',
    0x290044: 'apt::CloseSystemApplet',
    0x2a0000: 'apt::OrderToCloseSystemApplet',
    0x2b0000: 'apt::PrepareToJumpToHomeMenu',
    0x2c0044: 'apt::JumpToHomeMenu',
    0x2d0000: 'apt::PrepareToLeaveHomeMenu',
    0x2e0044: 'apt::LeaveHomeMenu',
    0x2f0040: 'apt::PrepareToLeaveResidentApplet',
    0x300044: 'apt::LeaveResidentApplet',
    0x310100: 'apt::PrepareToDoApplicationJump',
    0x320084: 'apt::DoApplicationJump',
    0x330000: 'apt::GetProgramIdOnApplicationJump',
    0x340084: 'apt::SendDeliverArg',
    0x350080: 'apt::ReceiveDeliverArg',
    0x360040: 'apt::LoadSysMenuArg',
    0x370042: 'apt::StoreSysMenuArg',
    0x380040: 'apt::PreloadResidentApplet',
    0x390040: 'apt::PrepareToStartResidentApplet',
    0x3a0044: 'apt::StartResidentApplet',
    0x3b0040: 'apt::CancelLibraryApplet',
    0x3c0042: 'apt::SendDspSleep',
    0x3d0042: 'apt::SendDspWakeUp',
    0x3e0080: 'apt::ReplySleepQuery',
    0x3f0040: 'apt::ReplySleepNotificationComplete',
    0x400042: 'apt::SendCaptureBufferInfo',
    0x410040: 'apt::ReceiveCaptureBufferInfo',
    0x420080: 'apt::SleepSystem',
    0x430040: 'apt::NotifyToWait',
    0x440000: 'apt::GetSharedFont',
    0x450040: 'apt::GetWirelessRebootInfo',
    0x460104: 'apt::Wrap',
    0x470104: 'apt::Unwrap',
    0x480100: 'apt::GetProgramInfo',
    0x490180: 'apt::Reboot',
    0x4a0040: 'apt::GetCaptureInfo',
    0x4b00c2: 'apt::AppletUtility',
    0x4c0000: 'apt::SetFatalErrDispMode',
    0x4d0080: 'apt::GetAppletProgramInfo',
    0x4e0000: 'apt::HardwareResetAsync',
    0x4f0080: 'apt::SetApplicationCpuTimeLimit',
    0x500040: 'apt::GetApplicationCpuTimeLimit',
    0x510080: 'apt::GetStartupArgument',
    0x520104: 'apt::Wrap1',
    0x530104: 'apt::Unwrap1',
    0x550040: 'apt::SetScreencapPostPermission',
    0x560000: 'apt::GetScreencapPostPermission',
    0x570044: 'apt::WakeupApplication2',
    0x580002: 'apt::GetProgramID',
    0x1010000: 'apt::CheckNew3DSApp',
    0x1020000: 'apt::CheckNew3DS',
    0x1040000: 'apt::IsStandardMemoryLayout',
    0x1050100: 'apt::IsTitleAllowed'
  },
  'apt_s_handle': {
    0x10040: 'apt::GetLockHandle',
    0x20080: 'apt::Initialize',
    0x30040: 'apt::Enable',
    0x40040: 'apt::Finalize',
    0x50040: 'apt::GetAppletManInfo',
    0x60040: 'apt::GetAppletInfo',
    0x70000: 'apt::GetLastSignaledAppletId',
    0x80000: 'apt::CountRegisteredApplet',
    0x90040: 'apt::IsRegistered',
    0xa0040: 'apt::GetAttribute',
    0xb0040: 'apt::InquireNotification',
    0xc0104: 'apt::SendParameter',
    0xd0080: 'apt::ReceiveParameter',
    0xe0080: 'apt::GlanceParameter',
    0xf0100: 'apt::CancelParameter',
    0x1000c2: 'apt::DebugFunc',
    0x1100c0: 'apt::MapProgramIdForDebug',
    0x120040: 'apt::SetHomeMenuAppletIdForDebug',
    0x130000: 'apt::GetPreparationState',
    0x140040: 'apt::SetPreparationState',
    0x150140: 'apt::PrepareToStartApplication',
    0x160040: 'apt::PreloadLibraryApplet',
    0x170040: 'apt::FinishPreloadingLibraryApplet',
    0x180040: 'apt::PrepareToStartLibraryApplet',
    0x190040: 'apt::PrepareToStartSystemApplet',
    0x1a0000: 'apt::PrepareToStartNewestHomeMenu',
    0x1b00c4: 'apt::StartApplication',
    0x1c0000: 'apt::WakeupApplication',
    0x1d0000: 'apt::CancelApplication',
    0x1e0084: 'apt::StartLibraryApplet',
    0x1f0084: 'apt::StartSystemApplet',
    0x200044: 'apt::StartNewestHomeMenu',
    0x210000: 'apt::OrderToCloseApplication',
    0x220040: 'apt::PrepareToCloseApplication',
    0x230040: 'apt::PrepareToJumpToApplication',
    0x240044: 'apt::JumpToApplication',
    0x2500c0: 'apt::PrepareToCloseLibraryApplet',
    0x260000: 'apt::PrepareToCloseSystemApplet',
    0x270044: 'apt::CloseApplication',
    0x280044: 'apt::CloseLibraryApplet',
    0x290044: 'apt::CloseSystemApplet',
    0x2a0000: 'apt::OrderToCloseSystemApplet',
    0x2b0000: 'apt::PrepareToJumpToHomeMenu',
    0x2c0044: 'apt::JumpToHomeMenu',
    0x2d0000: 'apt::PrepareToLeaveHomeMenu',
    0x2e0044: 'apt::LeaveHomeMenu',
    0x2f0040: 'apt::PrepareToLeaveResidentApplet',
    0x300044: 'apt::LeaveResidentApplet',
    0x310100: 'apt::PrepareToDoApplicationJump',
    0x320084: 'apt::DoApplicationJump',
    0x330000: 'apt::GetProgramIdOnApplicationJump',
    0x340084: 'apt::SendDeliverArg',
    0x350080: 'apt::ReceiveDeliverArg',
    0x360040: 'apt::LoadSysMenuArg',
    0x370042: 'apt::StoreSysMenuArg',
    0x380040: 'apt::PreloadResidentApplet',
    0x390040: 'apt::PrepareToStartResidentApplet',
    0x3a0044: 'apt::StartResidentApplet',
    0x3b0040: 'apt::CancelLibraryApplet',
    0x3c0042: 'apt::SendDspSleep',
    0x3d0042: 'apt::SendDspWakeUp',
    0x3e0080: 'apt::ReplySleepQuery',
    0x3f0040: 'apt::ReplySleepNotificationComplete',
    0x400042: 'apt::SendCaptureBufferInfo',
    0x410040: 'apt::ReceiveCaptureBufferInfo',
    0x420080: 'apt::SleepSystem',
    0x430040: 'apt::NotifyToWait',
    0x440000: 'apt::GetSharedFont',
    0x450040: 'apt::GetWirelessRebootInfo',
    0x460104: 'apt::Wrap',
    0x470104: 'apt::Unwrap',
    0x480100: 'apt::GetProgramInfo',
    0x490180: 'apt::Reboot',
    0x4a0040: 'apt::GetCaptureInfo',
    0x4b00c2: 'apt::AppletUtility',
    0x4c0000: 'apt::SetFatalErrDispMode',
    0x4d0080: 'apt::GetAppletProgramInfo',
    0x4e0000: 'apt::HardwareResetAsync',
    0x4f0080: 'apt::SetApplicationCpuTimeLimit',
    0x500040: 'apt::GetApplicationCpuTimeLimit',
    0x510080: 'apt::GetStartupArgument',
    0x520104: 'apt::Wrap1',
    0x530104: 'apt::Unwrap1',
    0x550040: 'apt::SetScreencapPostPermission',
    0x560000: 'apt::GetScreencapPostPermission',
    0x570044: 'apt::WakeupApplication2',
    0x580002: 'apt::GetProgramID',
    0x1010000: 'apt::CheckNew3DSApp',
    0x1020000: 'apt::CheckNew3DS',
    0x1040000: 'apt::IsStandardMemoryLayout',
    0x1050100: 'apt::IsTitleAllowed'
  },
  'ldr_ro_handle': {
    0x100c2: 'ldr::Initialize',
    0x20082: 'ldr::LoadCRR',
    0x30042: 'ldr::UnloadCRR',
    0x402c2: 'ldr::LoadCRO',
    0x500c2: 'ldr::UnloadCRO',
    0x60042: 'ldr::LinkCRO',
    0x70042: 'ldr::UnlinkCRO',
    0x80042: 'ldr::Shutdown',
    0x902c2: 'ldr::LoadCRO_New'
  },
  'ndm_u_handle': {
    0x10042: 'ndm::EnterExclusiveState',
    0x20002: 'ndm::LeaveExclusiveState',
    0x30000: 'ndm::QueryExclusiveMode',
    0x40002: 'ndm::LockState',
    0x50002: 'ndm::UnlockState',
    0x60040: 'ndm::SuspendDaemons',
    0x70040: 'ndm::ResumeDaemons',
    0x80040: 'ndm::SuspendScheduler',
    0x90000: 'ndm::ResumeScheduler',
    0xa0000: 'ndm::GetCurrentState',
    0xb0000: 'ndm::GetTargetState',
    0xd0040: 'ndm::QueryStatus',
    0xe0040: 'ndm::GetDaemonDisableCount',
    0xf0000: 'ndm::GetSchedulerDisableCount',
    0x100040: 'ndm::SetScanInterval',
    0x110000: 'ndm::GetScanInterval',
    0x120040: 'ndm::SetRetryInterval',
    0x130000: 'ndm::GetRetryInterval',
    0x140040: 'ndm::OverrideDefaultDaemons',
    0x150000: 'ndm::ResetDefaultDaemons',
    0x160000: 'ndm::GetDefaultDaemons',
    0x170000: 'ndm::ClearHalfAwakeMacFilter'
  },
  'csnd_snd_handle': {
    0x10140: 'csnd::Initialize',
    0x20000: 'csnd::Shutdown',
    0x30040: 'csnd::ExecuteCommands',
    0x40080: 'csnd::PlaySoundDirectly',
    0x50000: 'csnd::AcquireSoundChannels',
    0x60000: 'csnd::ReleaseSoundChannels',
    0x70000: 'csnd::AcquireCapUnit',
    0x80040: 'csnd::ReleaseCapUnit',
    0x90082: 'csnd::FlushDataCache',
    0xa0082: 'csnd::StoreDataCache',
    0xb0082: 'csnd::InvalidateDataCache',
    0xc0000: 'csnd::Reset'
  },
  'cam_u_handle': {
    0x10040: 'cam::StartCapture',
    0x20040: 'cam::StopCapture',
    0x30040: 'cam::IsBusy',
    0x40040: 'cam::ClearBuffer',
    0x50040: 'cam::GetVsyncInterruptEvent',
    0x60040: 'cam::GetBufferErrorInterruptEvent',
    0x70102: 'cam::SetReceiving',
    0x80040: 'cam::IsFinishedReceiving',
    0x90100: 'cam::SetTransferLines',
    0xa0080: 'cam::GetMaxLines',
    0xb0100: 'cam::SetTransferBytes',
    0xc0040: 'cam::GetTransferBytes',
    0xd0080: 'cam::GetMaxBytes',
    0xe0080: 'cam::SetTrimming',
    0xf0040: 'cam::IsTrimming',
    0x100140: 'cam::SetTrimmingParams',
    0x110040: 'cam::GetTrimmingParams',
    0x120140: 'cam::SetTrimmingParamsCenter',
    0x130040: 'cam::Activate',
    0x140080: 'cam::SwitchContext',
    0x150080: 'cam::SetExposure',
    0x160080: 'cam::SetWhiteBalance',
    0x170080: 'cam::SetWhiteBalanceWithoutBaseUp',
    0x180080: 'cam::SetSharpness',
    0x190080: 'cam::SetAutoExposure',
    0x1a0040: 'cam::IsAutoExposure',
    0x1b0080: 'cam::SetAutoWhiteBalance',
    0x1c0040: 'cam::IsAutoWhiteBalance',
    0x1d00c0: 'cam::FlipImage',
    0x1e0200: 'cam::SetDetailSize',
    0x1f00c0: 'cam::SetSize',
    0x200080: 'cam::SetFrameRate',
    0x210080: 'cam::SetPhotoMode',
    0x2200c0: 'cam::SetEffect',
    0x230080: 'cam::SetContrast',
    0x240080: 'cam::SetLensCorrection',
    0x2500c0: 'cam::SetOutputFormat',
    0x260140: 'cam::SetAutoExposureWindow',
    0x270140: 'cam::SetAutoWhiteBalanceWindow',
    0x280080: 'cam::SetNoiseFilter',
    0x290080: 'cam::SynchronizeVsyncTiming',
    0x2a0080: 'cam::GetLatestVsyncTiming',
    0x2b0000: 'cam::GetStereoCameraCalibrationData',
    0x2c0400: 'cam::SetStereoCameraCalibrationData',
    0x2d00c0: 'cam::WriteRegisterI2c',
    0x2e00c0: 'cam::WriteMcuVariableI2c',
    0x2f0080: 'cam::ReadRegisterI2cExclusive',
    0x300080: 'cam::ReadMcuVariableI2cExclusive',
    0x310180: 'cam::SetImageQualityCalibrationData',
    0x320000: 'cam::GetImageQualityCalibrationData',
    0x3302c0: 'cam::SetPackageParameterWithoutContext',
    0x340140: 'cam::SetPackageParameterWithContext',
    0x3501c0: 'cam::SetPackageParameterWithContextDetail',
    0x360000: 'cam::GetSuitableY2rStandardCoefficient',
    0x370202: 'cam::PlayShutterSoundWithWave',
    0x380040: 'cam::PlayShutterSound',
    0x390000: 'cam::DriverInitialize',
    0x3a0000: 'cam::DriverFinalize',
    0x3b0000: 'cam::GetActivatedCamera',
    0x3c0000: 'cam::GetSleepCamera',
    0x3d0040: 'cam::SetSleepCamera',
    0x3e0040: 'cam::SetBrightnessSynchronization'
  },
  'cam_s_handle': {
    0x10040: 'cam::StartCapture',
    0x20040: 'cam::StopCapture',
    0x30040: 'cam::IsBusy',
    0x40040: 'cam::ClearBuffer',
    0x50040: 'cam::GetVsyncInterruptEvent',
    0x60040: 'cam::GetBufferErrorInterruptEvent',
    0x70102: 'cam::SetReceiving',
    0x80040: 'cam::IsFinishedReceiving',
    0x90100: 'cam::SetTransferLines',
    0xa0080: 'cam::GetMaxLines',
    0xb0100: 'cam::SetTransferBytes',
    0xc0040: 'cam::GetTransferBytes',
    0xd0080: 'cam::GetMaxBytes',
    0xe0080: 'cam::SetTrimming',
    0xf0040: 'cam::IsTrimming',
    0x100140: 'cam::SetTrimmingParams',
    0x110040: 'cam::GetTrimmingParams',
    0x120140: 'cam::SetTrimmingParamsCenter',
    0x130040: 'cam::Activate',
    0x140080: 'cam::SwitchContext',
    0x150080: 'cam::SetExposure',
    0x160080: 'cam::SetWhiteBalance',
    0x170080: 'cam::SetWhiteBalanceWithoutBaseUp',
    0x180080: 'cam::SetSharpness',
    0x190080: 'cam::SetAutoExposure',
    0x1a0040: 'cam::IsAutoExposure',
    0x1b0080: 'cam::SetAutoWhiteBalance',
    0x1c0040: 'cam::IsAutoWhiteBalance',
    0x1d00c0: 'cam::FlipImage',
    0x1e0200: 'cam::SetDetailSize',
    0x1f00c0: 'cam::SetSize',
    0x200080: 'cam::SetFrameRate',
    0x210080: 'cam::SetPhotoMode',
    0x2200c0: 'cam::SetEffect',
    0x230080: 'cam::SetContrast',
    0x240080: 'cam::SetLensCorrection',
    0x2500c0: 'cam::SetOutputFormat',
    0x260140: 'cam::SetAutoExposureWindow',
    0x270140: 'cam::SetAutoWhiteBalanceWindow',
    0x280080: 'cam::SetNoiseFilter',
    0x290080: 'cam::SynchronizeVsyncTiming',
    0x2a0080: 'cam::GetLatestVsyncTiming',
    0x2b0000: 'cam::GetStereoCameraCalibrationData',
    0x2c0400: 'cam::SetStereoCameraCalibrationData',
    0x2d00c0: 'cam::WriteRegisterI2c',
    0x2e00c0: 'cam::WriteMcuVariableI2c',
    0x2f0080: 'cam::ReadRegisterI2cExclusive',
    0x300080: 'cam::ReadMcuVariableI2cExclusive',
    0x310180: 'cam::SetImageQualityCalibrationData',
    0x320000: 'cam::GetImageQualityCalibrationData',
    0x3302c0: 'cam::SetPackageParameterWithoutContext',
    0x340140: 'cam::SetPackageParameterWithContext',
    0x3501c0: 'cam::SetPackageParameterWithContextDetail',
    0x360000: 'cam::GetSuitableY2rStandardCoefficient',
    0x370202: 'cam::PlayShutterSoundWithWave',
    0x380040: 'cam::PlayShutterSound',
    0x390000: 'cam::DriverInitialize',
    0x3a0000: 'cam::DriverFinalize',
    0x3b0000: 'cam::GetActivatedCamera',
    0x3c0000: 'cam::GetSleepCamera',
    0x3d0040: 'cam::SetSleepCamera',
    0x3e0040: 'cam::SetBrightnessSynchronization'
  },
  'cam_c_handle': {
    0x10040: 'cam::StartCapture',
    0x20040: 'cam::StopCapture',
    0x30040: 'cam::IsBusy',
    0x40040: 'cam::ClearBuffer',
    0x50040: 'cam::GetVsyncInterruptEvent',
    0x60040: 'cam::GetBufferErrorInterruptEvent',
    0x70102: 'cam::SetReceiving',
    0x80040: 'cam::IsFinishedReceiving',
    0x90100: 'cam::SetTransferLines',
    0xa0080: 'cam::GetMaxLines',
    0xb0100: 'cam::SetTransferBytes',
    0xc0040: 'cam::GetTransferBytes',
    0xd0080: 'cam::GetMaxBytes',
    0xe0080: 'cam::SetTrimming',
    0xf0040: 'cam::IsTrimming',
    0x100140: 'cam::SetTrimmingParams',
    0x110040: 'cam::GetTrimmingParams',
    0x120140: 'cam::SetTrimmingParamsCenter',
    0x130040: 'cam::Activate',
    0x140080: 'cam::SwitchContext',
    0x150080: 'cam::SetExposure',
    0x160080: 'cam::SetWhiteBalance',
    0x170080: 'cam::SetWhiteBalanceWithoutBaseUp',
    0x180080: 'cam::SetSharpness',
    0x190080: 'cam::SetAutoExposure',
    0x1a0040: 'cam::IsAutoExposure',
    0x1b0080: 'cam::SetAutoWhiteBalance',
    0x1c0040: 'cam::IsAutoWhiteBalance',
    0x1d00c0: 'cam::FlipImage',
    0x1e0200: 'cam::SetDetailSize',
    0x1f00c0: 'cam::SetSize',
    0x200080: 'cam::SetFrameRate',
    0x210080: 'cam::SetPhotoMode',
    0x2200c0: 'cam::SetEffect',
    0x230080: 'cam::SetContrast',
    0x240080: 'cam::SetLensCorrection',
    0x2500c0: 'cam::SetOutputFormat',
    0x260140: 'cam::SetAutoExposureWindow',
    0x270140: 'cam::SetAutoWhiteBalanceWindow',
    0x280080: 'cam::SetNoiseFilter',
    0x290080: 'cam::SynchronizeVsyncTiming',
    0x2a0080: 'cam::GetLatestVsyncTiming',
    0x2b0000: 'cam::GetStereoCameraCalibrationData',
    0x2c0400: 'cam::SetStereoCameraCalibrationData',
    0x2d00c0: 'cam::WriteRegisterI2c',
    0x2e00c0: 'cam::WriteMcuVariableI2c',
    0x2f0080: 'cam::ReadRegisterI2cExclusive',
    0x300080: 'cam::ReadMcuVariableI2cExclusive',
    0x310180: 'cam::SetImageQualityCalibrationData',
    0x320000: 'cam::GetImageQualityCalibrationData',
    0x3302c0: 'cam::SetPackageParameterWithoutContext',
    0x340140: 'cam::SetPackageParameterWithContext',
    0x3501c0: 'cam::SetPackageParameterWithContextDetail',
    0x360000: 'cam::GetSuitableY2rStandardCoefficient',
    0x370202: 'cam::PlayShutterSoundWithWave',
    0x380040: 'cam::PlayShutterSound',
    0x390000: 'cam::DriverInitialize',
    0x3a0000: 'cam::DriverFinalize',
    0x3b0000: 'cam::GetActivatedCamera',
    0x3c0000: 'cam::GetSleepCamera',
    0x3d0040: 'cam::SetSleepCamera',
    0x3e0040: 'cam::SetBrightnessSynchronization'
  },
  'cam_q_handle': {
    0x10040: 'cam::StartCapture',
    0x20040: 'cam::StopCapture',
    0x40040: 'cam::ClearBuffer',
    0x80040: 'cam::IsFinishedRecieving',
    0x90100: 'cam::SetTransferLines',
    0xb0100: 'cam::SetTransferBytes',
    0xe0080: 'cam::SetTrimming',
    0x100140: 'cam::SetTrimmingParams',
    0x120140: 'cam::SetTrimmingParamsCenter',
    0x130040: 'cam::Activate',
    0x140080: 'cam::SwitchContext',
    0x150080: 'cam::SetExposure',
    0x160080: 'cam::SetWhiteBalance',
    0x170080: 'cam::SetSharpness',
    0x180080: 'cam::SetAutoExposure',
    0x1a0080: 'cam::SetAutoWhiteBalance',
    0x1c00c0: 'cam::FlipImage',
    0x1e00c0: 'cam::SetSize',
    0x1f0080: 'cam::SetFrameRate',
    0x200080: 'cam::SetPhotoMode',
    0x2100c0: 'cam::SetEffect',
    0x220080: 'cam::SetContrast',
    0x230080: 'cam::SetLensCorrection',
    0x2400c0: 'cam::SetOutputFormat',
    0x270080: 'cam::SetNoiseFilter',
    0x280080: 'cam::SyncronizeVsyncTiming',
    0x2c0080: 'cam::SetPackageParameterWithContext',
    0x350040: 'cam::SetSleepCamera',
    0x360040: 'cam::SetBrightnessSyncronization'
  },
  'y2r_u_handle': {
    0x10040: 'y2r::SetInputFormat',
    0x20000: 'y2r::GetInputFormat',
    0x30040: 'y2r::SetOutputFormat',
    0x40000: 'y2r::GetOutputFormat',
    0x50040: 'y2r::SetRotation',
    0x60000: 'y2r::GetRotation',
    0x70040: 'y2r::SetBlockAlignment',
    0x80000: 'y2r::GetBlockAlignment',
    0x90040: 'y2r::SetSpacialDithering',
    0xa0000: 'y2r::GetSpacialDithering',
    0xb0040: 'y2r::SetTemporalDithering',
    0xc0000: 'y2r::GetTemporalDithering',
    0xd0040: 'y2r::SetTransferEndInterrupt',
    0xe0000: 'y2r::GetTransferEndInterrupt',
    0xf0000: 'y2r::GetTransferEndEvent',
    0x100102: 'y2r::SetSendingY',
    0x110102: 'y2r::SetSendingU',
    0x120102: 'y2r::SetSendingV',
    0x130102: 'y2r::SetSendingYuv',
    0x140000: 'y2r::IsFinishedSendingYuv',
    0x150000: 'y2r::IsFinishedSendingY',
    0x160000: 'y2r::IsFinishedSendingU',
    0x170000: 'y2r::IsFinishedSendingV',
    0x180102: 'y2r::SetReceiving',
    0x190000: 'y2r::IsFinishedReceiving',
    0x1a0040: 'y2r::SetInputLineWidth',
    0x1b0000: 'y2r::GetInputLineWidth',
    0x1c0040: 'y2r::SetInputLines',
    0x1d0000: 'y2r::GetInputLines',
    0x1e0100: 'y2r::SetCoefficientParams',
    0x1f0000: 'y2r::GetCoefficientParams',
    0x200040: 'y2r::SetStandardCoefficient',
    0x210040: 'y2r::GetStandardCoefficientParams',
    0x220040: 'y2r::SetAlpha',
    0x230000: 'y2r::GetAlpha',
    0x240200: 'y2r::SetDitheringWeightParams',
    0x250000: 'y2r::GetDitheringWeightParams',
    0x260000: 'y2r::StartConversion',
    0x270000: 'y2r::StopConversion',
    0x280000: 'y2r::IsBusyConversion',
    0x2901c0: 'y2r::SetPackageParameter',
    0x2a0000: 'y2r::PingProcess',
    0x2b0000: 'y2r::DriverInitialize',
    0x2c0000: 'y2r::DriverFinalize',
    0x2d0000: 'y2r::GetPackageParameter'
  },
  'cdc_hid_handle': {
    0x10042: 'cdc::GetData',
    0x20042: 'cdc::Initialize',
    0x30000: 'cdc::Finalize'
  },
  'cdc_mic_handle': {
    0x10040: 'cdc::SetGain',
    0x20080: 'cdc::GetGain',
    0x30040: 'cdc::SetPower',
    0x40080: 'cdc::GetPower',
    0x50042: 'cdc::SetIirFilterMic'
  },
  'cdc_chk_handle': {
    0x100c0: 'cdc::ReadSPI',
    0x200c0: 'cdc::ReadSPI',
    0x300c2: 'cdc::WriteSPI',
    0x400c2: 'cdc::WriteSPI'
  },
  'dlp_clnt_handle': {
    0x100c3: 'dlp::clnt::Initialize',
    0x20000: 'dlp::clnt::Finalize',
    0x30000: 'dlp::clnt::GetEventDesc',
    0x40000: 'dlp::clnt::GetChannel',
    0x50180: 'dlp::clnt::StartScan',
    0x60000: 'dlp::clnt::StopScan',
    0x70080: 'dlp::clnt::GetServerInfo',
    0x80100: 'dlp::clnt::GetTitleInfo',
    0x90040: 'dlp::clnt::GetTitleInfoInOrder',
    0xa0080: 'dlp::clnt::DeleteScanInfo',
    0xb0100: 'dlp::clnt::PrepareForSystemDownload',
    0xc0000: 'dlp::clnt::StartSystemDownload',
    0xd0100: 'dlp::clnt::StartTitleDownload',
    0xe0000: 'dlp::clnt::GetMyStatus',
    0xf0040: 'dlp::clnt::GetConnectingNodes',
    0x100040: 'dlp::clnt::GetNodeInfo',
    0x110000: 'dlp::clnt::GetWirelessRebootPassphrase',
    0x120000: 'dlp::clnt::StopSession',
    0x130100: 'dlp::clnt::GetCupVersion',
    0x140100: 'dlp::clnt::GetDupAvailability'
  },
  'dlp_srvr_handle': {
    0x10183: 'dlp::srvr::Initialize',
    0x20000: 'dlp::srvr::Finalize',
    0x30000: 'dlp::srvr::GetServerState',
    0x40000: 'dlp::srvr::GetEventDescription',
    0x50080: 'dlp::srvr::StartAccepting',
    0x60000: 'dlp::srvr::EndAccepting',
    0x70000: 'dlp::srvr::StartDistribution',
    0x800c0: 'dlp::srvr::SendWirelessRebootPassphrase',
    0x90040: 'dlp::srvr::AcceptClient',
    0xa0040: 'dlp::srvr::DisconnectClient',
    0xb0042: 'dlp::srvr::GetConnectingClients',
    0xc0040: 'dlp::srvr::GetClientInfo',
    0xd0040: 'dlp::srvr::GetClientState',
    0xe0040: 'dlp::srvr::IsChild',
    0xf0303: 'dlp::srvr::InitializeWithName',
    0x100000: 'dlp::srvr::GetDupNoticeNeed'
  },
  'dlp_fkcl_handle': {
    0x10083: 'dlp::fkcl::Initialize',
    0x20000: 'dlp::fkcl::Finalize',
    0x30000: 'dlp::fkcl::GetEventDesc',
    0x40000: 'dlp::fkcl::GetChannels',
    0x50180: 'dlp::fkcl::StartScan',
    0x60000: 'dlp::fkcl::StopScan',
    0x70080: 'dlp::fkcl::GetServerInfo',
    0x80100: 'dlp::fkcl::GetTitleInfo',
    0x90040: 'dlp::fkcl::GetTitleInfoInOrder',
    0xa0080: 'dlp::fkcl::DeleteScanInfo',
    0xb0100: 'dlp::fkcl::StartFakeSession',
    0xc0000: 'dlp::fkcl::GetMyStatus',
    0xd0040: 'dlp::fkcl::GetConnectingNodes',
    0xe0040: 'dlp::fkcl::GetNodeInfo',
    0xf0000: 'dlp::fkcl::GetWirelessRebootPassphrase'
  },
  'dsp__dsp_handle': {
    0x10040: 'dsp::RecvData',
    0x20040: 'dsp::RecvDataIsReady',
    0x30080: 'dsp::SendData',
    0x40040: 'dsp::SendDataIsEmpty',
    0x500c2: 'dsp::SendFifoEx',
    0x600c0: 'dsp::RecvFifoEx',
    0x70040: 'dsp::SetSemaphore',
    0x80000: 'dsp::GetSemaphore',
    0x90040: 'dsp::ClearSemaphore',
    0xa0040: 'dsp::MaskSemaphore',
    0xb0000: 'dsp::CheckSemaphoreRequest',
    0xc0040: 'dsp::ConvertProcessAddressFromDspDram',
    0xd0082: 'dsp::WriteProcessPipe',
    0xe00c0: 'dsp::ReadPipe',
    0xf0080: 'dsp::GetPipeReadableSize',
    0x1000c0: 'dsp::ReadPipeIfPossible',
    0x1100c2: 'dsp::LoadComponent',
    0x120000: 'dsp::UnloadComponent',
    0x130082: 'dsp::FlushDataCache',
    0x140082: 'dsp::InvalidateDCache',
    0x150082: 'dsp::RegisterInterruptEvents',
    0x160000: 'dsp::GetSemaphoreEventHandle',
    0x170040: 'dsp::SetSemaphoreMask',
    0x180040: 'dsp::GetPhysicalAddress',
    0x190040: 'dsp::GetVirtualAddress',
    0x1a0042: 'dsp::SetIirFilterI2S1',
    0x1b0042: 'dsp::SetIirFilterI2S2',
    0x1c0082: 'dsp::SetIirFilterEQ',
    0x1d00c0: 'dsp::ReadMultiEx_SPI2',
    0x1e00c2: 'dsp::WriteMultiEx_SPI2',
    0x1f0000: 'dsp::GetHeadphoneStatus',
    0x200040: 'dsp::ForceHeadphoneOut',
    0x210000: 'dsp::GetIsDspOccupied'
  },
  'gsp__gpu_handle': {
    0x10082: 'gsp::WriteHWRegs',
    0x20084: 'gsp::WriteHWRegsWithMask',
    0x30082: 'gsp::WriteHWRegRepeat',
    0x40080: 'gsp::ReadHWRegs',
    0x50200: 'gsp::SetBufferSwap',
    0x60082: 'gsp::SetCommandList',
    0x700c2: 'gsp::RequestDma',
    0x80082: 'gsp::FlushDataCache',
    0x90082: 'gsp::InvalidateDataCache',
    0xa0044: 'gsp::RegisterInterruptEvents',
    0xb0040: 'gsp::SetLcdForceBlack',
    0xc0000: 'gsp::TriggerCmdReqQueue',
    0xd0140: 'gsp::SetDisplayTransfer',
    0xe0180: 'gsp::SetTextureCopy',
    0xf0200: 'gsp::SetMemoryFill',
    0x100040: 'gsp::SetAxiConfigQoSMode',
    0x110040: 'gsp::SetPerfLogMode',
    0x120000: 'gsp::GetPerfLog',
    0x130042: 'gsp::RegisterInterruptRelayQueue',
    0x140000: 'gsp::UnregisterInterruptRelayQueue',
    0x150002: 'gsp::TryAcquireRight',
    0x160042: 'gsp::AcquireRight',
    0x170000: 'gsp::ReleaseRight',
    0x180000: 'gsp::ImportDisplayCaptureInfo',
    0x190000: 'gsp::SaveVramSysArea',
    0x1a0000: 'gsp::RestoreVramSysArea',
    0x1b0000: 'gsp::ResetGpuCore',
    0x1c0040: 'gsp::SetLedForceOff',
    0x1d0040: 'gsp::SetTestCommand',
    0x1e0080: 'gsp::SetInternalPriorities',
    0x1f0082: 'gsp::StoreDataCache'
  },
  'gsp__lcd_handle': {
    0xa0080: 'gsp::SetBrightnessRaw',
    0xb0080: 'gsp::SetBrightness',
    0xf0000: 'gsp::PowerOnAllBacklights',
    0x100000: 'gsp::PowerOffAllBacklights',
    0x110040: 'gsp::PowerOnBacklight',
    0x120040: 'gsp::PowerOffBacklight',
    0x130040: 'gsp::SetLedForceOff',
    0x140000: 'gsp::GetVendor',
    0x150040: 'gsp::GetBrightness'
  },
  'boss_u_handle': {
    0x10082: 'boss::InitializeSession',
    0x20100: 'boss::SetStorageInfo',
    0x30000: 'boss::UnregisterStorage',
    0x40000: 'boss::GetTaskStorageInfo',
    0x90040: 'boss::SetOptoutFlag',
    0xa0000: 'boss::GetOptoutFlag',
    0xb00c2: 'boss::RegisterTask',
    0xc0082: 'boss::UnregisterTask',
    0xd0082: 'boss::ReconfigureTask',
    0xe0000: 'boss::GetTaskIdList',
    0x100102: 'boss::GetNsDataIdList',
    0x110102: 'boss::GetNsDataIdList1',
    0x120102: 'boss::GetNsDataIdList2',
    0x130102: 'boss::GetNsDataIdList3',
    0x140082: 'boss::SendProperty',
    0x150042: 'boss::SendPropertyHandle',
    0x160082: 'boss::ReceiveProperty',
    0x180082: 'boss::UpdateTaskCount',
    0x1a0042: 'boss::GetTaskCount',
    0x1b0042: 'boss::GetTaskServiceStatus',
    0x1c0042: 'boss::StartTask',
    0x1d0042: 'boss::StartTaskImmediate',
    0x1e0042: 'boss::CancelTask',
    0x1f0000: 'boss::GetTaskFinishHandle',
    0x200082: 'boss::GetTaskState',
    0x210042: 'boss::GetTaskResult',
    0x2300c2: 'boss::GetTaskStatus',
    0x260040: 'boss::DeleteNsData',
    0x2700c2: 'boss::GetNsDataHeaderInfo',
    0x280102: 'boss::ReadNsData',
    0x2b0080: 'boss::SetNsDataNewFlag',
    0x2c0040: 'boss::GetNsDataNewFlag',
    0x2e0040: 'boss::GetErrorCode',
    0x2f0140: 'boss::RegisterStorageEntry',
    0x330042: 'boss::StartBgImmediate',
    0x340042: 'boss::GetTaskProperty0',
    0x3500c2: 'boss::RegisterImmediateTask'
  },
  'boss_p_handle': {
    0x4010082: 'boss::InitializeSessionPrivileged',
    0x4040080: 'boss::GetAppNewFlag',
    0x40d0182: 'boss::GetNsDataIdListPrivileged',
    0x40e0182: 'boss::GetNsDataIdListPrivileged1',
    0x4130082: 'boss::SendPropertyPrivileged',
    0x41500c0: 'boss::DeleteNsDataPrivileged',
    0x4160142: 'boss::GetNsDataHeaderInfoPrivileged',
    0x4170182: 'boss::ReadNsDataPrivileged',
    0x41a0100: 'boss::SetNsDataNewFlagPrivileged',
    0x41b00c0: 'boss::GetNsDataNewFlagPrivileged'
  },
  'cecd_u_handle': {
    0x100c2: 'cecd::OpenRawFile',
    0x20042: 'cecd::ReadRawFile',
    0x30104: 'cecd::ReadMessage',
    0x40106: 'cecd::ReadMessageWithHMAC',
    0x50042: 'cecd::WriteRawFile',
    0x60104: 'cecd::WriteMessage',
    0x70106: 'cecd::WriteMessageWithHMAC',
    0x80102: 'cecd::Delete',
    0xa00c4: 'cecd::GetSystemInfo',
    0xb0040: 'cecd::RunCommand',
    0xc0040: 'cecd::RunCommandAlt',
    0xd0082: 'cecd::GetCecInfoBuffer',
    0xe0000: 'cecd::GetCecStateAbbreviated',
    0xf0000: 'cecd::GetCecInfoEventHandle',
    0x100000: 'cecd::GetChangeStateEventHandle',
    0x110104: 'cecd::OpenAndWrite',
    0x120104: 'cecd::OpenAndRead',
    0x1e0082: 'cecd::GetEventLog',
    0x1f0000: 'cecd::GetEventLogStart'
  },
  'cecd_ndm_handle': {
    0x10000: 'cecd::Initialize',
    0x20000: 'cecd::Deinitialize',
    0x30000: 'cecd::ResumeDaemon',
    0x40040: 'cecd::SuspendDaemon',
    0x50000: 'cecd::QueryStatus',
    0x60042: 'cecd::GetNZoneInfo',
    0x70042: 'cecd::SetNZoneSSIDList',
    0x80042: 'cecd::SetNZoneMacFilter'
  },
  'ir_u_handle': {
    0x10000: 'ir::Initialize',
    0x20000: 'ir::Shutdown',
    0x30042: 'ir::StartSendTransfer',
    0x40000: 'ir::WaitSendTransfer',
    0x500c2: 'ir::StartRecvTransfer',
    0x60000: 'ir::WaitRecvTransfer',
    0x70000: 'ir::GetRecvTransferCount',
    0x80000: 'ir::GetSendState',
    0x90040: 'ir::SetBitRate',
    0xa0000: 'ir::GetBitRate',
    0xb0040: 'ir::SetIRLEDState',
    0xc0000: 'ir::GetIRLEDRecvState',
    0xd0000: 'ir::GetSendFinishedEvent',
    0xe0000: 'ir::GetRecvFinishedEvent',
    0xf0000: 'ir::GetTransferState',
    0x100000: 'ir::GetErrorStatus',
    0x110040: 'ir::SetSleepModeActive',
    0x120040: 'ir::SetSleepModeState'
  },
  'ir_user_handle': {
    0x10182: 'ir::InitializeIrnop',
    0x20000: 'ir::FinalizeIrnop',
    0x30000: 'ir::ClearReceiveBuffer',
    0x40000: 'ir::ClearSendBuffer',
    0x500c0: 'ir::WaitConnection',
    0x60040: 'ir::RequireConnection',
    0x702c0: 'ir::AutoConnection',
    0x80000: 'ir::AnyConnection',
    0x90000: 'ir::Disconnect',
    0xa0000: 'ir::GetReceiveEvent',
    0xb0000: 'ir::GetSendEvent',
    0xc0000: 'ir::GetConnectionStatusEvent',
    0xd0042: 'ir::SendIrnop',
    0xe0042: 'ir::SendIrnopLarge',
    0xf0040: 'ir::ReceiveIrnop',
    0x100042: 'ir::ReceiveIrnopLarge',
    0x180182: 'ir::InitializeIrnopShared',
    0x190040: 'ir::ReleaseReceivedData',
    0x1a0040: 'ir::SetOwnMachineId'
  },
  'ir_rst_handle': {
    0x10000: 'ir::GetHandles',
    0x20080: 'ir::Initialize',
    0x30000: 'ir::Shutdown'
  },
  'i2c__mcu_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__cam_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__lcd_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__deb_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__hid_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__ir_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__eep_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__nfc_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'i2c__qtm_handle': {
    0x10100: 'i2c::SetRegisterBits8',
    0x200c0: 'i2c::EnableRegisterBits8',
    0x300c0: 'i2c::DisableRegisterBits8',
    0x40102: 'i2c::MultiSetRegisterBits16',
    0x500c0: 'i2c::WriteRegister8',
    0x60080: 'i2c::WriteCommand8',
    0x700c0: 'i2c::WriteRegister16',
    0x800c2: 'i2c::MultiWriteRegister16',
    0x90080: 'i2c::ReadRegister8',
    0xa0080: 'i2c::ReadRegister16',
    0xb00c2: 'i2c::WriteRegisterBuffer8',
    0xc00c2: 'i2c::WriteRegisterBuffer16',
    0xd00c0: 'i2c::ReadRegisterBuffer8',
    0xe00c2: 'i2c::WriteRegisterBuffer',
    0xf00c0: 'i2c::ReadRegisterBuffer',
    0x1000c0: 'i2c::ReadEEPROM',
    0x1100c2: 'i2c::WriteRegisterBuffer',
    0x1200c2: 'i2c::ReadRegisterBuffer',
    0x130040: 'i2c::ReadDeviceRaw8',
    0x140082: 'i2c::WriteDeviceRaw',
    0x150080: 'i2c::ReadDeviceRaw'
  },
  'gpio_cdc_handle': {
    0x10040: 'gpio::GetRegPart1',
    0x20080: 'gpio::SetRegPart1',
    0x30040: 'gpio::GetRegPart2',
    0x40080: 'gpio::SetRegPart2',
    0x50040: 'gpio::GetInterruptMask',
    0x60080: 'gpio::SetInterruptMask',
    0x70040: 'gpio::GetGPIOData',
    0x80080: 'gpio::SetGPIOData',
    0x90082: 'gpio::BindInterrupt',
    0xa0042: 'gpio::UnbindInterrupt'
  },
  'gpio_mcu_handle': {
    0x10040: 'gpio::GetRegPart1',
    0x20080: 'gpio::SetRegPart1',
    0x30040: 'gpio::GetRegPart2',
    0x40080: 'gpio::SetRegPart2',
    0x50040: 'gpio::GetInterruptMask',
    0x60080: 'gpio::SetInterruptMask',
    0x70040: 'gpio::GetGPIOData',
    0x80080: 'gpio::SetGPIOData',
    0x90082: 'gpio::BindInterrupt',
    0xa0042: 'gpio::UnbindInterrupt'
  },
  'gpio_hid_handle': {
    0x10040: 'gpio::GetRegPart1',
    0x20080: 'gpio::SetRegPart1',
    0x30040: 'gpio::GetRegPart2',
    0x40080: 'gpio::SetRegPart2',
    0x50040: 'gpio::GetInterruptMask',
    0x60080: 'gpio::SetInterruptMask',
    0x70040: 'gpio::GetGPIOData',
    0x80080: 'gpio::SetGPIOData',
    0x90082: 'gpio::BindInterrupt',
    0xa0042: 'gpio::UnbindInterrupt'
  },
  'gpio_nwm_handle': {
    0x10040: 'gpio::GetRegPart1',
    0x20080: 'gpio::SetRegPart1',
    0x30040: 'gpio::GetRegPart2',
    0x40080: 'gpio::SetRegPart2',
    0x50040: 'gpio::GetInterruptMask',
    0x60080: 'gpio::SetInterruptMask',
    0x70040: 'gpio::GetGPIOData',
    0x80080: 'gpio::SetGPIOData',
    0x90082: 'gpio::BindInterrupt',
    0xa0042: 'gpio::UnbindInterrupt'
  },
  'gpio_ir_handle': {
    0x10040: 'gpio::GetRegPart1',
    0x20080: 'gpio::SetRegPart1',
    0x30040: 'gpio::GetRegPart2',
    0x40080: 'gpio::SetRegPart2',
    0x50040: 'gpio::GetInterruptMask',
    0x60080: 'gpio::SetInterruptMask',
    0x70040: 'gpio::GetGPIOData',
    0x80080: 'gpio::SetGPIOData',
    0x90082: 'gpio::BindInterrupt',
    0xa0042: 'gpio::UnbindInterrupt'
  },
  'gpio_nfc_handle': {
    0x10040: 'gpio::GetRegPart1',
    0x20080: 'gpio::SetRegPart1',
    0x30040: 'gpio::GetRegPart2',
    0x40080: 'gpio::SetRegPart2',
    0x50040: 'gpio::GetInterruptMask',
    0x60080: 'gpio::SetInterruptMask',
    0x70040: 'gpio::GetGPIOData',
    0x80080: 'gpio::SetGPIOData',
    0x90082: 'gpio::BindInterrupt',
    0xa0042: 'gpio::UnbindInterrupt'
  },
  'gpio_qtm_handle': {
    0x10040: 'gpio::GetRegPart1',
    0x20080: 'gpio::SetRegPart1',
    0x30040: 'gpio::GetRegPart2',
    0x40080: 'gpio::SetRegPart2',
    0x50040: 'gpio::GetInterruptMask',
    0x60080: 'gpio::SetInterruptMask',
    0x70040: 'gpio::GetGPIOData',
    0x80080: 'gpio::SetGPIOData',
    0x90082: 'gpio::BindInterrupt',
    0xa0042: 'gpio::UnbindInterrupt'
  },
  'hid_user_handle': {
    0x10200: 'hid::CallibrateTouchScreen',
    0x20000: 'hid::HIDSPVR:UpdateTouchConfig',
    0xa0000: 'hid::GetIPCHandles',
    0xb0000: 'hid::StartAnalogStickCalibration',
    0xc0040: 'hid::StopAnalogStickCalibration',
    0xd01c0: 'hid::SetAnalogStickCalibrateParam',
    0xe0000: 'hid::GetAnalogStickCalibrateParam',
    0x110000: 'hid::EnableAccelerometer',
    0x120000: 'hid::DisableAccelerometer',
    0x130000: 'hid::EnableGyroscopeLow',
    0x140000: 'hid::DisableGyroscopeLow',
    0x150000: 'hid::GetGyroscopeLowRawToDpsCoefficient',
    0x160000: 'hid::GetGyroscopeLowCalibrateParam',
    0x170000: 'hid::GetSoundVolume'
  },
  'hid_spvr_handle': {
    0x10200: 'hid::CallibrateTouchScreen',
    0x20000: 'hid::HIDSPVR:UpdateTouchConfig',
    0xa0000: 'hid::GetIPCHandles',
    0xb0000: 'hid::StartAnalogStickCalibration',
    0xc0040: 'hid::StopAnalogStickCalibration',
    0xd01c0: 'hid::SetAnalogStickCalibrateParam',
    0xe0000: 'hid::GetAnalogStickCalibrateParam',
    0x110000: 'hid::EnableAccelerometer',
    0x120000: 'hid::DisableAccelerometer',
    0x130000: 'hid::EnableGyroscopeLow',
    0x140000: 'hid::DisableGyroscopeLow',
    0x150000: 'hid::GetGyroscopeLowRawToDpsCoefficient',
    0x160000: 'hid::GetGyroscopeLowCalibrateParam',
    0x170000: 'hid::GetSoundVolume'
  },
  'hid_qtm_handle': {
    0x10200: 'hid::CallibrateTouchScreen',
    0x20000: 'hid::HIDSPVR:UpdateTouchConfig',
    0xa0000: 'hid::GetIPCHandles',
    0xb0000: 'hid::StartAnalogStickCalibration',
    0xc0040: 'hid::StopAnalogStickCalibration',
    0xd01c0: 'hid::SetAnalogStickCalibrateParam',
    0xe0000: 'hid::GetAnalogStickCalibrateParam',
    0x110000: 'hid::EnableAccelerometer',
    0x120000: 'hid::DisableAccelerometer',
    0x130000: 'hid::EnableGyroscopeLow',
    0x140000: 'hid::DisableGyroscopeLow',
    0x150000: 'hid::GetGyroscopeLowRawToDpsCoefficient',
    0x160000: 'hid::GetGyroscopeLowCalibrateParam',
    0x170000: 'hid::GetSoundVolume'
  },
  'hid_nfc_handle': {
    0x10200: 'hid::CallibrateTouchScreen',
    0x20000: 'hid::UpdateTouchConfig',
    0xa0000: 'hid::GetIPCHandles',
    0xb0000: 'hid::StartAnalogStickCalibration',
    0xc0040: 'hid::StopAnalogStickCalibration',
    0xd01c0: 'hid::SetAnalogStickCalibrateParam',
    0xe0000: 'hid::GetAnalogStickCalibrateParam',
    0x110000: 'hid::EnableAccelerometer',
    0x120000: 'hid::DisableAccelerometer',
    0x130000: 'hid::EnableGyroscopeLow',
    0x140000: 'hid::DisableGyroscopeLow',
    0x150000: 'hid::GetGyroscopeLowRawToDpsCoefficient',
    0x160000: 'hid::GetGyroscopeLowCalibrateParam',
    0x170000: 'hid::GetSoundVolume'
  },
  'ptm_u_handle': {
    0x10002: 'ptm::RegisterAlarmClient',
    0x20080: 'ptm::SetRtcAlarm',
    0x30000: 'ptm::GetRtcAlarm',
    0x40000: 'ptm::CancelRtcAlarm',
    0x50000: 'ptm::GetAdapterState',
    0x60000: 'ptm::GetShellState',
    0x70000: 'ptm::GetBatteryLevel',
    0x80000: 'ptm::GetBatteryChargeState',
    0x90000: 'ptm::GetPedometerState',
    0xa0042: 'ptm::GetStepHistoryEntry',
    0xb00c2: 'ptm::GetStepHistory',
    0xc0000: 'ptm::GetTotalStepCount',
    0xd0040: 'ptm::SetPedometerRecordingMode',
    0xe0000: 'ptm::GetPedometerRecordingMode',
    0xf0084: 'ptm::GetStepHistoryAll'
  },
  'ptm_play_handle': {
    0x10002: 'ptm::RegisterAlarmClient',
    0x20080: 'ptm::SetRtcAlarm',
    0x30000: 'ptm::GetRtcAlarm',
    0x40000: 'ptm::CancelRtcAlarm',
    0x50000: 'ptm::GetAdapterState',
    0x60000: 'ptm::GetShellState',
    0x70000: 'ptm::GetBatteryLevel',
    0x80000: 'ptm::GetBatteryChargeState',
    0x90000: 'ptm::GetPedometerState',
    0xa0042: 'ptm::GetStepHistoryEntry',
    0xb00c2: 'ptm::GetStepHistory',
    0xc0000: 'ptm::GetTotalStepCount',
    0xd0040: 'ptm::SetPedometerRecordingMode',
    0xe0000: 'ptm::GetPedometerRecordingMode',
    0xf0084: 'ptm::GetStepHistoryAll',
    0x8070082: 'ptm::GetPlayHistory',
    0x8080000: 'ptm::GetPlayHistoryStart',
    0x8090000: 'ptm::GetPlayHistoryLength',
    0x80b0080: 'ptm::CalcPlayHistoryStart'
  },
  'ptm_s_handle': {
    0x10002: 'ptm::RegisterAlarmClient',
    0x20080: 'ptm::SetRtcAlarm',
    0x30000: 'ptm::GetRtcAlarm',
    0x40000: 'ptm::CancelRtcAlarm',
    0x50000: 'ptm::GetAdapterState',
    0x60000: 'ptm::GetShellState',
    0x70000: 'ptm::GetBatteryLevel',
    0x80000: 'ptm::GetBatteryChargeState',
    0x90000: 'ptm::GetPedometerState',
    0xa0042: 'ptm::GetStepHistoryEntry',
    0xb00c2: 'ptm::GetStepHistory',
    0xc0000: 'ptm::GetTotalStepCount',
    0xd0040: 'ptm::SetPedometerRecordingMode',
    0xe0000: 'ptm::GetPedometerRecordingMode',
    0xf0084: 'ptm::GetStepHistoryAll',
    0x40100c0: 'ptm::SetRtcAlarmEx',
    0x4020042: 'ptm::ReplySleepQuery',
    0x4030042: 'ptm::NotifySleepPreparationComplete',
    0x4040102: 'ptm::SetWakeupTrigger',
    0x4050000: 'ptm::GetAwakeReason',
    0x4060000: 'ptm::RequestSleep',
    0x40700c0: 'ptm::ShutdownAsync',
    0x4080000: 'ptm::Awake',
    0x4090080: 'ptm::RebootAsync',
    0x40a0000: 'ptm::CheckNew3DS',
    0x8010640: 'ptm::SetInfoLEDPattern',
    0x8020040: 'ptm::SetInfoLEDPatternHeader',
    0x8030000: 'ptm::GetInfoLEDStatus',
    0x8040040: 'ptm::SetBatteryEmptyLEDPattern',
    0x8050000: 'ptm::ClearStepHistory',
    0x80600c2: 'ptm::SetStepHistory',
    0x8070082: 'ptm::GetPlayHistory',
    0x8080000: 'ptm::GetPlayHistoryStart',
    0x8090000: 'ptm::GetPlayHistoryLength',
    0x80a0000: 'ptm::ClearPlayHistory',
    0x80b0080: 'ptm::CalcPlayHistoryStart',
    0x80c0080: 'ptm::SetUserTime',
    0x80d0000: 'ptm::InvalidateSystemTime',
    0x80e0140: 'ptm::NotifyPlayEvent',
    0x80f0000: 'ptm::GetSoftwareClosedFlag',
    0x8100000: 'ptm::ClearSoftwareClosedFlag',
    0x8110000: 'ptm::GetShellStatus',
    0x8120000: 'ptm::IsShutdownByBatteryEmpty',
    0x8130000: 'ptm::FormatSavedata',
    0x8140000: 'ptm::GetLegacyJumpProhibitedFlag',
    0x8150040: 'ptm::SetPlayHistoryRecordingMode',
    0x8180040: 'ptm::ConfigureNew3DSCPU'
  },
  'ptm_sysm_handle': {
    0x10002: 'ptm::RegisterAlarmClient',
    0x20080: 'ptm::SetRtcAlarm',
    0x30000: 'ptm::GetRtcAlarm',
    0x40000: 'ptm::CancelRtcAlarm',
    0x50000: 'ptm::GetAdapterState',
    0x60000: 'ptm::GetShellState',
    0x70000: 'ptm::GetBatteryLevel',
    0x80000: 'ptm::GetBatteryChargeState',
    0x90000: 'ptm::GetPedometerState',
    0xa0042: 'ptm::GetStepHistoryEntry',
    0xb00c2: 'ptm::GetStepHistory',
    0xc0000: 'ptm::GetTotalStepCount',
    0xd0040: 'ptm::SetPedometerRecordingMode',
    0xe0000: 'ptm::GetPedometerRecordingMode',
    0xf0084: 'ptm::GetStepHistoryAll',
    0x40100c0: 'ptm::SetRtcAlarmEx',
    0x4020042: 'ptm::ReplySleepQuery',
    0x4030042: 'ptm::NotifySleepPreparationComplete',
    0x4040102: 'ptm::SetWakeupTrigger',
    0x4050000: 'ptm::GetAwakeReason',
    0x4060000: 'ptm::RequestSleep',
    0x40700c0: 'ptm::ShutdownAsync',
    0x4080000: 'ptm::Awake',
    0x4090080: 'ptm::RebootAsync',
    0x40a0000: 'ptm::CheckNew3DS',
    0x8010640: 'ptm::SetInfoLEDPattern',
    0x8020040: 'ptm::SetInfoLEDPatternHeader',
    0x8030000: 'ptm::GetInfoLEDStatus',
    0x8040040: 'ptm::SetBatteryEmptyLEDPattern',
    0x8050000: 'ptm::ClearStepHistory',
    0x80600c2: 'ptm::SetStepHistory',
    0x8070082: 'ptm::GetPlayHistory',
    0x8080000: 'ptm::GetPlayHistoryStart',
    0x8090000: 'ptm::GetPlayHistoryLength',
    0x80a0000: 'ptm::ClearPlayHistory',
    0x80b0080: 'ptm::CalcPlayHistoryStart',
    0x80c0080: 'ptm::SetUserTime',
    0x80d0000: 'ptm::InvalidateSystemTime',
    0x80e0140: 'ptm::NotifyPlayEvent',
    0x80f0000: 'ptm::GetSoftwareClosedFlag',
    0x8100000: 'ptm::ClearSoftwareClosedFlag',
    0x8110000: 'ptm::GetShellStatus',
    0x8120000: 'ptm::IsShutdownByBatteryEmpty',
    0x8130000: 'ptm::FormatSavedata',
    0x8140000: 'ptm::GetLegacyJumpProhibitedFlag',
    0x8150040: 'ptm::SetPlayHistoryRecordingMode',
    0x8180040: 'ptm::ConfigureNew3DSCPU'
  },
  'ptm_gets_handle': {
    0x10002: 'ptm::RegisterAlarmClient',
    0x20080: 'ptm::SetRtcAlarm',
    0x30000: 'ptm::GetRtcAlarm',
    0x40000: 'ptm::CancelRtcAlarm',
    0x50000: 'ptm::GetAdapterState',
    0x60000: 'ptm::GetShellState',
    0x70000: 'ptm::GetBatteryLevel',
    0x80000: 'ptm::GetBatteryChargeState',
    0x90000: 'ptm::GetPedometerState',
    0xa0042: 'ptm::GetStepHistoryEntry',
    0xb00c2: 'ptm::GetStepHistory',
    0xc0000: 'ptm::GetTotalStepCount',
    0xd0040: 'ptm::SetPedometerRecordingMode',
    0xe0000: 'ptm::GetPedometerRecordingMode',
    0xf0084: 'ptm::GetStepHistoryAll',
    0x4010000: 'ptm::GetSystemTime'
  },
  'ptm_sets_handle': {
    0x10080: 'ptm::SetSystemTime'
  },
  'nwm__uds_handle': {
    0x102c2: 'nwm::Initialize',
    0x30000: 'nwm::Shutdown',
    0x40402: 'nwm::CreateNetwork',
    0x50040: 'nwm::EjectClient',
    0x60000: 'nwm::EjectSpectator',
    0x70080: 'nwm::UpdateNetworkAttribute',
    0x80000: 'nwm::DestroyNetwork',
    0x90442: 'nwm::ConnectNetwork',
    0xa0000: 'nwm::DisconnectNetwork',
    0xb0000: 'nwm::GetConnectionStatus',
    0xd0040: 'nwm::GetNodeInformation',
    0xe0006: 'nwm::DecryptBeaconData',
    0xf0404: 'nwm::RecvBeaconBroadcastData',
    0x100042: 'nwm::SetApplicationData',
    0x110040: 'nwm::GetApplicationData',
    0x120100: 'nwm::Bind',
    0x130040: 'nwm::Unbind',
    0x1400c0: 'nwm::PullPacket',
    0x150080: 'nwm::SetMaxSendDelay',
    0x170182: 'nwm::SendTo',
    0x1a0000: 'nwm::GetChannel',
    0x1b0302: 'nwm::InitializeWithVersion',
    0x1d0044: 'nwm::BeginHostingNetwork',
    0x1e0084: 'nwm::ConnectToNetwork',
    0x1f0006: 'nwm::DecryptBeaconData',
    0x200040: 'nwm::Flush',
    0x210080: 'nwm::SetProbeResponseParam',
    0x220402: 'nwm::ScanOnConnection'
  },
  'nwm__inf_handle': {
    0x603c4: 'nwm::RecvBeaconBroadcastData',
    0x70742: 'nwm::ConnectToEncryptedAP',
    0x80302: 'nwm::ConnectToAP'
  },
  'nwm__soc_handle': {
    0x80040: 'nwm::GetMACAddress'
  },
  'nwm__cec_handle': {
    0xd0082: 'nwm::SendProbeRequest'
  },
  'nwm__ext_handle': {
    0x80040: 'nwm::ControlWirelessEnabled'
  },
  'http_c_handle': {
    0x10044: 'http::Initialize',
    0x20082: 'http::CreateContext',
    0x30040: 'http::CloseContext',
    0x40040: 'http::CancelConnection',
    0x50040: 'http::GetRequestState',
    0x60040: 'http::GetDownloadSizeState',
    0x70040: 'http::GetRequestError',
    0x80042: 'http::InitializeConnectionSession',
    0x90040: 'http::BeginRequest',
    0xa0040: 'http::BeginRequestAsync',
    0xb0082: 'http::ReceiveData',
    0xc0102: 'http::ReceiveDataTimeout',
    0xd0146: 'http::SetProxy',
    0xe0040: 'http::SetProxyDefault',
    0xf00c4: 'http::SetBasicAuthorization',
    0x100080: 'http::SetSocketBufferSize',
    0x1100c4: 'http::AddRequestHeader',
    0x1200c4: 'http::AddPostDataAscii',
    0x1300c4: 'http::AddPostDataBinary',
    0x140082: 'http::AddPostDataRaw',
    0x150080: 'http::SetPostDataType',
    0x1600c4: 'http::SendPostDataAscii',
    0x170144: 'http::SendPostDataAsciiTimeout',
    0x1800c4: 'http::SendPostDataBinary',
    0x190144: 'http::SendPostDataBinaryTimeout',
    0x1a0082: 'http::SendPostDataRaw',
    0x1b0102: 'http::SendPOSTDataRawTimeout',
    0x1c0080: 'http::SetPostDataEncoding',
    0x1d0040: 'http::NotifyFinishSendPostData',
    0x1e00c4: 'http::GetResponseHeader',
    0x1f0144: 'http::GetResponseHeaderTimeout',
    0x200082: 'http::GetResponseData',
    0x210102: 'http::GetResponseDataTimeout',
    0x220040: 'http::GetResponseStatusCode',
    0x2300c0: 'http::GetResponseStatusCodeTimeout',
    0x240082: 'http::AddTrustedRootCA',
    0x250080: 'http::AddDefaultCert',
    0x260080: 'http::SelectRootCertChain',
    0x2700c4: 'http::SetClientCert',
    0x280080: 'http::SetClientCertDefault',
    0x290080: 'http::SetClientCertContext',
    0x2b0080: 'http::SetSSLOpt',
    0x2c0080: 'http::SetSSLClearOpt',
    0x2d0000: 'http::CreateRootCertChain',
    0x2e0040: 'http::DestroyRootCertChain',
    0x2f0082: 'http::RootCertChainAddCert',
    0x300080: 'http::RootCertChainAddDefaultCert',
    0x310080: 'http::RootCertChainRemoveCert',
    0x320084: 'http::OpenClientCertContext',
    0x330040: 'http::OpenDefaultClientCertContext',
    0x340040: 'http::CloseClientCertContext',
    0x350186: 'http::SetDefaultProxy',
    0x360000: 'http::ClearDNSCache',
    0x370080: 'http::SetKeepAlive',
    0x3800c0: 'http::SetPostDataTypeSize',
    0x390000: 'http::Finalize',
    0x3a0080: 'http::SetKeepAlive',
    0x3b0082: 'http::SetCrl',
    0x3c0080: 'http::SetInternalCrl',
    0x3d0080: 'http::SetCrlStore',
    0x3e0000: 'http::CreateCrlStore',
    0x3f0040: 'http::DestroyCrlStore',
    0x400082: 'http::AddCrlToCrlStore',
    0x410080: 'http::AddInternalCrl',
    0x420040: 'http::RemoveCrlFromCrlStore'
  },
  'ssl_c_handle': {
    0x10002: 'ssl::Initialize',
    0x200c2: 'ssl::CreateContext',
    0x30000: 'ssl::CreateRootCertChain',
    0x40040: 'ssl::DestroyRootCertChain',
    0x50082: 'ssl::AddTrustedRootCA',
    0x60080: 'ssl::RootCertChainAddDefaultCert',
    0x70080: 'ssl::RootCertChainRemoveCert',
    0x80000: 'ssl::CreateCrlStore',
    0x90040: 'ssl::DestroyCrlStore',
    0xa0082: 'ssl::AddCrlToCrlStore',
    0xb0080: 'ssl::AddInternalCrlToCrlStore',
    0xc0080: 'ssl::RemoveCrlFromCrlStore',
    0xd0084: 'ssl::OpenClientCertContext',
    0xe0040: 'ssl::OpenDefaultClientCertContext',
    0xf0040: 'ssl::CloseClientCertContext',
    0x100000: 'ssl::SeedRNG',
    0x110042: 'ssl::GenerateRandomData',
    0x120042: 'ssl::InitializeConnectionSession',
    0x130040: 'ssl::StartConnection',
    0x140040: 'ssl::StartConnectionGetOut',
    0x150082: 'ssl::Read',
    0x160082: 'ssl::ReadPeek',
    0x170082: 'ssl::Write',
    0x180080: 'ssl::ContextSetRootCertChain',
    0x190080: 'ssl::ContextSetClientCert',
    0x1a0080: 'ssl::SetCrlStore',
    0x1b0080: 'ssl::ContextClearOpt',
    0x1c00c4: 'ssl::ContextGetProtocolCipher',
    0x1d0040: 'ssl::GetCertVerificationErrors',
    0x1e0040: 'ssl::DestroyContext',
    0x1f0082: 'ssl::ContextInitSharedmem',
    0x200082: 'ssl::AddEVPolicyID'
  },
  'soc_u_handle': {
    0x10044: 'soc::InitializeSockets',
    0x200c2: 'soc::socket',
    0x30082: 'soc::listen',
    0x40082: 'soc::accept',
    0x50084: 'soc::bind',
    0x60084: 'soc::connect',
    0x70104: 'soc::recvfrom_other',
    0x80102: 'soc::recvfrom',
    0x90106: 'soc::sendto_other',
    0xa0106: 'soc::sendto',
    0xb0042: 'soc::close',
    0xc0082: 'soc::shutdown',
    0xd0082: 'soc::gethostbyname',
    0xe00c2: 'soc::gethostbyaddr',
    0xf0106: 'soc::getaddrinfo',
    0x100102: 'soc::getnameinfo',
    0x110102: 'soc::getsockopt',
    0x120104: 'soc::setsockopt',
    0x1300c2: 'soc::fcntl',
    0x140084: 'soc::poll',
    0x150042: 'soc::sockatmark',
    0x160000: 'soc::gethostid',
    0x170082: 'soc::getsockname',
    0x180082: 'soc::getpeername',
    0x190000: 'soc::ShutdownSockets',
    0x1a00c0: 'soc::GetNetworkOpt',
    0x1b0040: 'soc::ICMPSocket',
    0x1c0104: 'soc::ICMPPing',
    0x1d0040: 'soc::ICMPCancel',
    0x1e0040: 'soc::ICMPClose',
    0x1f0040: 'soc::GetResolverInfo',
    0x210002: 'soc::CloseSockets',
    0x230040: 'soc::AddGlobalSocket'
  },
  'soc_p_handle': {
    0x10084: 'soc::InitializeSockets',
    0x20000: 'soc::FinalizeSockets',
    0x300c2: 'soc::SetNetworkOpt',
    0x40040: 'soc::CloseSocketsForProcess',
    0x60000: 'soc::gethostid',
    0x90000: 'soc::StopInitializeSockets'
  },
  'ac_u_handle': {
    0x10000: 'ac::CreateDefaultConfig',
    0x15004: 'ac::ExclusiveAsync',
    0x20042: 'ac::DebugSetApType',
    0x30042: 'ac::DebugSetNetworkArea',
    0x40006: 'ac::ConnectAsync',
    0x50002: 'ac::GetConnectResult',
    0x600c6: 'ac::DebugSetNetworkSetting1',
    0x70002: 'ac::CancelConnectAsync',
    0x80004: 'ac::CloseAsync',
    0x90002: 'ac::GetCloseResult',
    0xa0000: 'ac::GetLastErrorCode',
    0xb0000: 'ac::GetLastDetailErrorCode',
    0xc0000: 'ac::GetStatus',
    0xd0000: 'ac::GetWifiStatus',
    0xe0042: 'ac::GetCurrentAPInfo',
    0xf0000: 'ac::GetConnectingInfraPriority',
    0x100042: 'ac::GetCurrentNZoneInfo',
    0x110042: 'ac::GetNZoneApNumService',
    0x120042: 'ac::GetConnectingHotspot',
    0x130042: 'ac::GetConnectingHotspotSubset',
    0x140002: 'ac::GetConnectingLocation',
    0x160002: 'ac::GetExclusiveResult',
    0x170004: 'ac::UnExclusiveAsync',
    0x180002: 'ac::GetUnExcusiveResult',
    0x190004: 'ac::CloseAllASync',
    0x1a0002: 'ac::GetCloseAllResult',
    0x1b0004: 'ac::LogoutHotspotAsync',
    0x1c0002: 'ac::GetLogoutHotspotResult',
    0x1d0042: 'ac::ScanAPs',
    0x1e0042: 'ac::ScanNintendoZone',
    0x1f0042: 'ac::ScanNintendoZoneSubset',
    0x200005: 'ac::BeginScanUsbAccessPoint',
    0x210002: 'ac::EndScanUsbAccessPoint',
    0x220042: 'ac::SetAllowApType',
    0x230042: 'ac::AddAllowApType',
    0x240042: 'ac::AddDenyApType',
    0x250042: 'ac::SetNetworkArea',
    0x260042: 'ac::SetInfraPriority',
    0x270002: 'ac::GetInfraPriority',
    0x280042: 'ac::SetPowerSaveMode',
    0x290002: 'ac::GetPowerSaveMode',
    0x2a0004: 'ac::SetBssidFilter',
    0x2b0004: 'ac::SetApNumFilter',
    0x2c0042: 'ac::SetFromApplication',
    0x2d0082: 'ac::SetRequestEulaVersion',
    0x2e00c4: 'ac::ConvertPassphraseToPsk',
    0x2f0004: 'ac::GetNZoneBeaconNotFoundEvent',
    0x300004: 'ac::RegisterDisconnectEvent',
    0x310002: 'ac::GetStatusChangeEvent',
    0x320042: 'ac::SetAuthServerType',
    0x330000: 'ac::GetConnectingSecurityMode',
    0x340000: 'ac::GetConnectingSsid',
    0x350000: 'ac::GetConnectingSsidLength',
    0x360000: 'ac::GetConnectingProxyEnable',
    0x370000: 'ac::GetConnectingProxyAuthType',
    0x380000: 'ac::GetConnectingProxyPort',
    0x390000: 'ac::GetConnectingProxyHost',
    0x3a0000: 'ac::GetConnectingProxyUserName',
    0x3b0000: 'ac::GetConnectingProxyPassword',
    0x3c0042: 'ac::GetAPSSIDList',
    0x3d0042: 'ac::SetZoneMacFilter',
    0x3e0042: 'ac::IsConnected',
    0x3f0040: 'ac::GetNotAwakeMacFilter',
    0x400042: 'ac::SetClientVersion',
    0x4100c6: 'ac::SetTemporaryNetworkSettings'
  },
  'ac_i_handle': {
    0x4010040: 'ac::LoadNetworkSetting',
    0x4020040: 'ac::UpdateNetworkSetting',
    0x4030040: 'ac::RemoveNetworkSetting',
    0x4040000: 'ac::FlushNetworkSetting',
    0x4050084: 'ac::ConvertNetworkSettingNdsTo3ds',
    0x4060040: 'ac::InitializeNetworkSetting',
    0x4070000: 'ac::GetNetworkSettingVersion',
    0x4080040: 'ac::SetNetworkSettingVersion',
    0x4090000: 'ac::GetNetworkSetting_Crc',
    0x40a0040: 'ac::SetNetworkSetting_Crc',
    0x40b0000: 'ac::GetNetworkWirelessEnable',
    0x40c0040: 'ac::SetNetworkWirelessEnable',
    0x40d0000: 'ac::GetNetworkWirelessEditableEssidSecurity',
    0x40e0040: 'ac::SetNetworkWirelessEditableEssidSecurity',
    0x40f0000: 'ac::GetNetworkWirelessEssidSecuritySsid',
    0x4100002: 'ac::SetNetworkWirelessEssidSecuritySsid',
    0x4110000: 'ac::GetNetworkWireleesEssidSsidLength',
    0x4120040: 'ac::SetNetworkWirelessEssidSsidLength',
    0x4130000: 'ac::GetNetworkWirelessEssidSecurityMode',
    0x4140040: 'ac::SetNetworkWirelessEssidSecurityMode',
    0x4150000: 'ac::GetNetworkWirelessEssidPassphrase',
    0x4160002: 'ac::SetNetworkWirelessEssidPassphrase',
    0x41700000: 'ac::GetNetworkWirelessEssidSecurityKey',
    0x4180002: 'ac::SetNetworkWirelessEssidSecurityKey',
    0x4190000: 'ac::GetNetworkMultiSSIDEnable',
    0x41a0040: 'ac::SetNetworkMultiSSIDEnable',
    0x41b0000: 'ac::GetNetworkWirelesMultiSsidMultiSsidType',
    0x41c0040: 'ac::SetNetworkWirelesMultiSsidMultiSsidType',
    0x41d0000: 'ac::GetNetworkWirelessMultiSsidSettingNum',
    0x41e0040: 'ac::SetNetworkWirelessMultiSsidSettingNum',
    0x41f0000: 'ac::GetNetworkWirelessMultiSsidSetting0Ssid',
    0x4200002: 'ac::SetNetworkWirelessMultiSsidSetting0Ssid',
    0x4210000: 'ac::GetNetworkWirelessMultiSsidSetting0SsidLength',
    0x4250000: 'ac::GetNetworkWirelessMultiSsidSetting0PassPhrase',
    0x4270000: 'ac::GetNetworkWirelessMultiSsidSetting0Key',
    0x4280002: 'ac::SetNetworkWirelessMultiSsidSetting0Key',
    0x4290000: 'ac::GetNetworkMultiSsidSetting1Ssid',
    0x42a0002: 'ac::SetNetworkMultiSsidSetting1Ssid',
    0x42b0000: 'ac::GetNetworkMultiSsidSetting1SsidLength',
    0x42f00000: 'ac::GetNetworkWirelessMultiSsidSetting1PassPhrase',
    0x4310000: 'ac::GetNetworkWirelessMultiSsidSetting1Key',
    0x4320002: 'ac::SetNetworkWirelessMultiSsidSetting1Key',
    0x4330000: 'ac::GetNetworkWirelessMultiSsidSetting2Ssid',
    0x4340002: 'ac::SetNetworkWirelessMultiSsidSetting2Ssid',
    0x4390000: 'ac::GetNetworkWirelessMultiSsidSetting2Passphrase',
    0x43b0000: 'ac::GetNetworkWirelessMultiSsidSetting2Key',
    0x43c0002: 'ac::SetNetworkWirelessMultiSsidSetting2Key',
    0x43d0000: 'ac::GetNetworkWirelessMultiSsidSetting3Ssid',
    0x43e0002: 'ac::SetNetworkWirelessMultiSsidSetting3Ssid',
    0x4450000: 'ac::GetNetworkWirelessMultiSsidSetting3Key',
    0x4460002: 'ac::SetNetworkWirelessMultiSsidSetting3Key',
    0x4470000: 'ac::GetNetworkIpEnableDHCP',
    0x4480040: 'ac::SetNetworkIpEnableDHCP',
    0x4490000: 'ac::GetNetworkAutoDNSSetting',
    0x44a0040: 'ac::SetNetworkAutoDNSSetting',
    0x44b0000: 'ac::GetNetworkIpAddress',
    0x44c0002: 'ac::SetNetworkIpAddress',
    0x44d0000: 'ac::GetNetworkDefaultGateway',
    0x44e0002: 'ac::SetNetworkDefaultGateway',
    0x44f0000: 'ac::GetNetworkIpNetmask',
    0x4500002: 'ac::SetNetworkIpNetMask',
    0x4510000: 'ac::GetNetworkIpPrimaryDNS',
    0x4520002: 'ac::SetNetworkIpPrimaryDNS',
    0x4530000: 'ac::GetNetworkIpSecondaryDNS',
    0x4540002: 'ac::SetNetworkIpSecondaryDNS',
    0x4550000: 'ac::GetNetworkIpScanlessConnectHasConnected',
    0x4560040: 'ac::SetNetworkIpScanlessConnectHasConnected',
    0x459000: 'ac::GetNetworkIpScanlessConnectLastConnectedBssid',
    0x45a002: 'ac::SetNetworkIpScanlessConnectLastConnectedBssid',
    0x45f0000: 'ac::GetNetworkProxyEnable',
    0x4600040: 'ac::SetNetworkProxyEnable',
    0x4610000: 'ac::GetNetworkProxyAuthType',
    0x4620040: 'ac::SetNetworkProxyAuthType',
    0x4630000: 'ac::GetNetworkProxyPort',
    0x4640040: 'ac::SetNetworkProxyPort',
    0x4650000: 'ac::GetNetworkProxyHost',
    0x4660002: 'ac::SetNetworkProxyHost',
    0x4670000: 'ac::GetNetworkSettingProxyUserName',
    0x4680002: 'ac::SetNetworkSettingProxyUserName',
    0x4690000: 'ac::GetNetworkSettingProxyPassword',
    0x46a0002: 'ac::SetNetworkSettingProxyPassword',
    0x46b0000: 'ac::GetNetworkEnableUPnP',
    0x46c0040: 'ac::SetNetworkEnableUPnP',
    0x46d0000: 'ac::GetNetworkOtherMtu',
    0x46e0040: 'ac::SetNetworkOtherMtu',
    0x46f0000: 'ac::GetConnectingNetworkSettingVersion',
    0x4700000: 'ac::GetConnectingNetworkCrc',
    0x4710000: 'ac::GetConnectingNetworkWirelessEnable',
    0x4730000: 'ac::GetConnectingNetworkWirelessEssidSsid',
    0x4770000: 'ac::GetConnectingNetworkWirelessEssidSecurityKey',
    0x4780000: 'ac::GetConnectingNetworkMultiSsidEnable',
    0x48f0000: 'ac::GetConnectingNetworkEnableDHCP',
    0x4900000: 'ac::GetConnectingNetworkIpAutoDNSSetting',
    0x4910000: 'ac::GetConnectingNetworkIpAddress',
    0x4920000: 'ac::GetConnectingNetworkIpDefaultGateway',
    0x4930000: 'ac::GetConnectingNetworkIpNetmask',
    0x4940000: 'ac::GetConnectingNetworkPrimaryDNS',
    0x4950000: 'ac::GetConnectingNetworkSecondaryDNS',
    0x49b0000: 'ac::GetConnectingNetworkProxyEnable',
    0x49c0000: 'ac::GetConnectingNetworkProxyAuthType',
    0x49d0000: 'ac::GetConnectingNetworkProxyPort',
    0x49e0000: 'ac::GetConnectingNetworkProxyHost',
    0x49f0000: 'ac::GetConnectingNetworkProxyUserName',
    0x4a00000: 'ac::GetConnectingNetworkProxyPassword',
    0x4a10000: 'ac::GetConnectingNetworkEnableUPnP',
    0x4a20000: 'ac::GetConnectingNetworkMtu',
    0x10000: 'ac::CreateDefaultConfig',
    0x15004: 'ac::ExclusiveAsync',
    0x20042: 'ac::DebugSetApType',
    0x30042: 'ac::DebugSetNetworkArea',
    0x40006: 'ac::ConnectAsync',
    0x50002: 'ac::GetConnectResult',
    0x600c6: 'ac::DebugSetNetworkSetting1',
    0x70002: 'ac::CancelConnectAsync',
    0x80004: 'ac::CloseAsync',
    0x90002: 'ac::GetCloseResult',
    0xa0000: 'ac::GetLastErrorCode',
    0xb0000: 'ac::GetLastDetailErrorCode',
    0xc0000: 'ac::GetStatus',
    0xd0000: 'ac::GetWifiStatus',
    0xe0042: 'ac::GetCurrentAPInfo',
    0xf0000: 'ac::GetConnectingInfraPriority',
    0x100042: 'ac::GetCurrentNZoneInfo',
    0x110042: 'ac::GetNZoneApNumService',
    0x120042: 'ac::GetConnectingHotspot',
    0x130042: 'ac::GetConnectingHotspotSubset',
    0x140002: 'ac::GetConnectingLocation',
    0x160002: 'ac::GetExclusiveResult',
    0x170004: 'ac::UnExclusiveAsync',
    0x180002: 'ac::GetUnExcusiveResult',
    0x190004: 'ac::CloseAllASync',
    0x1a0002: 'ac::GetCloseAllResult',
    0x1b0004: 'ac::LogoutHotspotAsync',
    0x1c0002: 'ac::GetLogoutHotspotResult',
    0x1d0042: 'ac::ScanAPs',
    0x1e0042: 'ac::ScanNintendoZone',
    0x1f0042: 'ac::ScanNintendoZoneSubset',
    0x200005: 'ac::BeginScanUsbAccessPoint',
    0x210002: 'ac::EndScanUsbAccessPoint',
    0x220042: 'ac::SetAllowApType',
    0x230042: 'ac::AddAllowApType',
    0x240042: 'ac::AddDenyApType',
    0x250042: 'ac::SetNetworkArea',
    0x260042: 'ac::SetInfraPriority',
    0x270002: 'ac::GetInfraPriority',
    0x280042: 'ac::SetPowerSaveMode',
    0x290002: 'ac::GetPowerSaveMode',
    0x2a0004: 'ac::SetBssidFilter',
    0x2b0004: 'ac::SetApNumFilter',
    0x2c0042: 'ac::SetFromApplication',
    0x2d0082: 'ac::SetRequestEulaVersion',
    0x2e00c4: 'ac::ConvertPassphraseToPsk',
    0x2f0004: 'ac::GetNZoneBeaconNotFoundEvent',
    0x300004: 'ac::RegisterDisconnectEvent',
    0x310002: 'ac::GetStatusChangeEvent',
    0x320042: 'ac::SetAuthServerType',
    0x330000: 'ac::GetConnectingSecurityMode',
    0x340000: 'ac::GetConnectingSsid',
    0x350000: 'ac::GetConnectingSsidLength',
    0x360000: 'ac::GetConnectingProxyEnable',
    0x370000: 'ac::GetConnectingProxyAuthType',
    0x380000: 'ac::GetConnectingProxyPort',
    0x390000: 'ac::GetConnectingProxyHost',
    0x3a0000: 'ac::GetConnectingProxyUserName',
    0x3b0000: 'ac::GetConnectingProxyPassword',
    0x3c0042: 'ac::GetAPSSIDList',
    0x3d0042: 'ac::SetZoneMacFilter',
    0x3e0042: 'ac::IsConnected',
    0x3f0040: 'ac::GetNotAwakeMacFilter',
    0x400042: 'ac::SetClientVersion',
    0x4100c6: 'ac::SetTemporaryNetworkSettings'
  },
  'news_u_handle': {
    0x100c8: 'news::AddNotification'
  },
  'news_s_handle': {
    0x100c6: 'news::AddNotification',
    0x50000: 'news::GetTotalNotifications',
    0x60042: 'news::SetNewsDBHeader',
    0x70082: 'news::SetNotificationHeader',
    0x80082: 'news::SetNotificationMessage',
    0x90082: 'news::SetNotificationImage',
    0xa0042: 'news::GetNewsDBHeader',
    0xb0082: 'news::GetNotificationHeader',
    0xc0082: 'news::GetNotificationMessage',
    0xd0082: 'news::GetNotificationImage',
    0xe0040: 'news::SetInfoLEDPattern',
    0x120082: 'news::GetNotificationHeaderOther',
    0x130000: 'news::WriteNewsDBSavedata'
  },
  'pdn_s_handle': {
    0x10000: 'pdn::GetWakeStatus',
    0x20080: 'pdn::ConfigureWakeEvents',
    0x30040: 'pdn::Acknowledge'
  },
  'pdn_d_handle': {
    0x100c0: 'pdn::deassertResetAfterReset'
  },
  'pdn_g_handle': {
    0x100c0: 'pdn::resetRegisters'
  },
  'spi__nor_handle': {
    0x10000: 'spi::SetDeviceState',
    0x30100: 'spi::ReadWriteDevice',
    0x40500: 'spi::ReadWriteDevice2',
    0x50000: 'spi::WriteDevice',
    0x60102: 'spi::ReadWriteDeviceArray',
    0x70102: 'spi::ReadWriteDevice2Array',
    0x800c0: 'spi::EnableSpiBus',
    0x90040: 'spi::EnableTwlSpiBus'
  },
  'spi__cd2_handle': {
    0x10000: 'spi::SetDeviceState',
    0x30100: 'spi::ReadWriteDevice',
    0x40500: 'spi::ReadWriteDevice2',
    0x50000: 'spi::WriteDevice',
    0x60102: 'spi::ReadWriteDeviceArray',
    0x70102: 'spi::ReadWriteDevice2Array',
    0x800c0: 'spi::EnableSpiBus',
    0x90040: 'spi::EnableTwlSpiBus'
  },
  'spi__cs2_handle': {
    0x10000: 'spi::SetDeviceState',
    0x30100: 'spi::ReadWriteDevice',
    0x40500: 'spi::ReadWriteDevice2',
    0x50000: 'spi::WriteDevice',
    0x60102: 'spi::ReadWriteDeviceArray',
    0x70102: 'spi::ReadWriteDevice2Array',
    0x800c0: 'spi::EnableSpiBus',
    0x90040: 'spi::EnableTwlSpiBus'
  },
  'spi__cs3_handle': {
    0x10000: 'spi::SetDeviceState',
    0x30100: 'spi::ReadWriteDevice',
    0x40500: 'spi::ReadWriteDevice2',
    0x50000: 'spi::WriteDevice',
    0x60102: 'spi::ReadWriteDeviceArray',
    0x70102: 'spi::ReadWriteDevice2Array',
    0x800c0: 'spi::EnableSpiBus',
    0x90040: 'spi::EnableTwlSpiBus'
  },
  'spi__def_handle': {
    0x10000: 'spi::SetDeviceState',
    0x30100: 'spi::ReadWriteDevice',
    0x40500: 'spi::ReadWriteDevice2',
    0x50000: 'spi::WriteDevice',
    0x60102: 'spi::ReadWriteDeviceArray',
    0x70102: 'spi::ReadWriteDevice2Array',
    0x800c0: 'spi::EnableSpiBus',
    0x90040: 'spi::EnableTwlSpiBus'
  },
  'loader_handle': {
    0x10080: 'loader::LoadProcess',
    0x20200: 'loader::RegisterProgram',
    0x30080: 'loader::UnregisterProgram',
    0x40080: 'loader::GetProgramInfo'
  },
  'mcu__cam_handle': {
    0x10040: 'mcu::WriteCameraLedState',
    0x20080: 'mcu::ReadCameraLedState'
  },
  'mcu__gpu_handle': {
    0x10000: 'mcu::GetLcdPowerState',
    0x20080: 'mcu::SetLcdPowerState',
    0x30000: 'mcu::GetGpuLcdInterfaceState',
    0x40040: 'mcu::SetGpuLcdInterfaceState',
    0x50040: 'mcu::SetTopScreenFlicker',
    0x60080: 'mcu::GetTopScreenFlicker',
    0x70040: 'mcu::SetBottomScreenFlicker',
    0x80080: 'mcu::GetBottomScreenFlicker',
    0x90000: 'mcu::GetMcuFwVerHigh',
    0xa0000: 'mcu::GetMcuFwVerLow',
    0xb0040: 'mcu::Set3dLedState',
    0xc0000: 'mcu::Get3dLedState',
    0xd0000: 'mcu::GetMcuGpuEventHandle',
    0xe0000: 'mcu::GetMcuGpuEventReason'
  },
  'mcu__hid_handle': {
    0x60000: 'mcu::ReadGyroscopeValues',
    0x70000: 'mcu::GetRaw3DSliderPosition',
    0xc0000: 'mcu::GetMcuHidEventHandle',
    0xd0000: 'mcu::GetMcuHidEventReason',
    0xe0000: 'mcu::GetSoundVolume',
    0xf0040: 'mcu::EnableAccelerometerInterrupt'
  },
  'mcu__rtc_handle': {
    0x10080: 'mcu::SetRTC',
    0x20000: 'mcu::GetRTC',
    0x30040: 'mcu::SetRTCSeconds',
    0x40000: 'mcu::GetRTCSeconds',
    0x50040: 'mcu::SetRTCMinutes',
    0x60000: 'mcu::GetRTCMinutes',
    0x70040: 'mcu::SetRTCHours',
    0x80000: 'mcu::GetRTCHours',
    0x90040: 'mcu::SetRTCDayOfWeek',
    0xa0000: 'mcu::GetRTCDayOfWeek',
    0xb0040: 'mcu::SetRTCDayOfMonth',
    0xc0000: 'mcu::GetRTCDayOfMonth',
    0xd0040: 'mcu::SetRTCMonth',
    0xe0000: 'mcu::GetRTCMonth',
    0xf0040: 'mcu::SetRTCYear',
    0x100000: 'mcu::GetRTCYear',
    0x110040: 'mcu::SetRTCLeapYearCounter',
    0x120000: 'mcu::GetRTCLeapYearCounter',
    0x130080: 'mcu::SetRTCAlarm',
    0x140000: 'mcu::GetRTCAlarm',
    0x150040: 'mcu::SetRTCAlarmComponent',
    0x160000: 'mcu::GetRTCAlarmComponent',
    0x170040: 'mcu::SetRTCAlarmComponent',
    0x180000: 'mcu::GetRTCAlarmComponent',
    0x190040: 'mcu::SetRTCAlarmComponent',
    0x1a0000: 'mcu::GetRTCAlarmComponent',
    0x1b0040: 'mcu::SetRTCAlarmComponent',
    0x1c0000: 'mcu::GetRTCAlarmComponent',
    0x1d0040: 'mcu::SetRTCAlarmComponent',
    0x1e0000: 'mcu::GetRTCAlarmComponent',
    0x1f0040: 'mcu::SetPedometerRecordingMode',
    0x200000: 'mcu::GetPedometerRecordingMode',
    0x210080: 'mcu::GetStepCount',
    0x220042: 'mcu::ReadRegister4Fh',
    0x240000: 'mcu::GetPowerEventHandle',
    0x250000: 'mcu::GetPowerInterruptHistory',
    0x260000: 'mcu::CheckRegister02hBit0',
    0x270000: 'mcu::ClearRegister02hBit0',
    0x280000: 'mcu::CheckRegister02hBit1',
    0x290000: 'mcu::ClearRegister02hBit1',
    0x2a0000: 'mcu::GetShellState',
    0x2b0000: 'mcu::GetAdapterState',
    0x2c0000: 'mcu::GetBatteryChargeState',
    0x2d0000: 'mcu::GetBatteryLevel',
    0x2e0000: 'mcu::SetPowerModeIndicatorState',
    0x2f0000: 'mcu::GetBatteryEmptyPatternByte0_safe',
    0x300040: 'mcu::SetLEDBrightness',
    0x310000: 'mcu::GetLEDBrightness',
    0x320000: 'mcu::PowerOff',
    0x330000: 'mcu::HardwareReboot',
    0x340000: 'mcu::ResetMcu',
    0x360040: 'mcu::SetWatchdogTimer',
    0x370000: 'mcu::GetWatchdogTimer',
    0x380042: 'mcu::GetInfoRegisters',
    0x390082: 'mcu::SetPlayCountRegisters',
    0x3a0082: 'mcu::GetPlayCountRegisters',
    0x3b0640: 'mcu::SetInfoLEDPattern',
    0x3c0040: 'mcu::SetInfoLEDPatternHeader',
    0x3d0000: 'mcu::GetInfoLEDStatus',
    0x3e0040: 'mcu::WriteRegister50h',
    0x3f0000: 'mcu::ReadRegister50h',
    0x400040: 'mcu::WriteRegister51h',
    0x410000: 'mcu::ReadRegister51h',
    0x420040: 'mcu::SetBatteryEmptyLEDPattern',
    0x430040: 'mcu::SetScreenFlickerTop',
    0x440000: 'mcu::GetScreenFlickerTop',
    0x450040: 'mcu::SetScreenFlickerBottom',
    0x460000: 'mcu::GetScreenFlickerBottom',
    0x470080: 'mcu::SetVolumeSliderBounds',
    0x480000: 'mcu::GetVolumeSliderBounds',
    0x490040: 'mcu::SetInterruptMask',
    0x4a0000: 'mcu::GetInterruptMask',
    0x4b0000: 'mcu::ExitExclusiveInterruptMode',
    0x4c0000: 'mcu::EnterExclusiveInterruptMode',
    0x4d0000: 'mcu::ReadInterrupt',
    0x4e0040: 'mcu::TriggerInterrupt',
    0x4f0040: 'mcu::SetMCUFirmUpdated',
    0x500000: 'mcu::IsMCUFirmUpdated',
    0x510040: 'mcu::SetSoftwareClosedFlag',
    0x520000: 'mcu::GetSoftwareClosedFlag',
    0x530040: 'mcu::SetLgyLcdData',
    0x540000: 'mcu::GetLgyLcdData',
    0x550040: 'mcu::SetLgyNativeResolutionFlag',
    0x560000: 'mcu::GetLgyNativeResolutionFlag',
    0x570040: 'mcu::SetLocalFriendCodeCounter',
    0x580000: 'mcu::GetLocalFriendCodeCounter',
    0x590040: 'mcu::SetLegacyJumpProhibitedFlag',
    0x5a0000: 'mcu::GetLegacyJumpProhibitedFlag',
    0x5b0040: 'mcu::SetUUIDClockSequence',
    0x5c0000: 'mcu::GetUUIDClockSequence'
  },
  'mcu__snd_handle': {
    0x10080: 'mcu::GetSoundVolume',
    0x30000: 'mcu::GetRegister25h'
  },
  'mcu__hwc_handle': {
    0x10082: 'mcu::ReadRegister',
    0x20082: 'mcu::WriteRegister',
    0x30042: 'mcu::GetInfoRegisters',
    0x40000: 'mcu::GetBatteryVoltage',
    0x50000: 'mcu::GetBatteryLevel',
    0x60040: 'mcu::SetPowerLEDPattern',
    0x70040: 'mcu::SetWifiLEDState',
    0x80040: 'mcu::SetCameraLEDPattern',
    0x90040: 'mcu::Set3DLEDState',
    0xb0000: 'mcu::GetSoundVolume',
    0xc0040: 'mcu::SetTopScreenFlicker',
    0xd0040: 'mcu::SetBottomScreenFlicker',
    0xe0080: 'mcu::GetBatteryTemperature',
    0xf00c0: 'mcu::GetRtcTime',
    0x100000: 'mcu::GetMcuFwVerHigh',
    0x110000: 'mcu::GetMcuFwVerLow'
  },
  'mcu__pls_handle': {
    0x10000: 'mcu::GetDatetime',
    0x20000: 'mcu::GetSeconds',
    0x30000: 'mcu::GetMinutes',
    0x40000: 'mcu::GetHour',
    0x50000: 'mcu::GetDayOfWeek',
    0x60000: 'mcu::GetDay',
    0x70000: 'mcu::GetMonth',
    0x80000: 'mcu::GetYear',
    0x90000: 'mcu::GetTickCounter'
  },
  'mic_u_handle': {
    0x10042: 'mic::MapSharedMem',
    0x20000: 'mic::UnmapSharedMem',
    0x30140: 'mic::StartSampling',
    0x40040: 'mic::AdjustSampling',
    0x50000: 'mic::StopSampling',
    0x60000: 'mic::IsSampling',
    0x70000: 'mic::GetEventHandle',
    0x80040: 'mic::SetGain',
    0x90000: 'mic::GetGain',
    0xa0040: 'mic::SetPower',
    0xb0000: 'mic::GetPower',
    0xc0042: 'mic::SetIirFilterMic',
    0xd0040: 'mic::SetClamp',
    0xe0000: 'mic::GetClamp',
    0xf0040: 'mic::SetAllowShellClosed'
  },
  'act_u_handle': {
    0x10084: 'act::Initialize',
    0x20040: 'act::GetErrorCode',
    0x30000: 'act::GetLastResponsecode',
    0x50082: 'act::GetCommonInfo',
    0x600c2: 'act::GetAccountDataBlock',
    0x70082: 'act::GetResultAsync',
    0x800c2: 'act::GetMiiImageData',
    0x90180: 'act::SetNfsPassword',
    0xb0042: 'act::AcquireEulaList',
    0xd0040: 'act::GenerateUuid',
    0xf0140: 'act::FindSlotNoByUuid',
    0x110080: 'act::GetTransferableId',
    0x120102: 'act::AccquireNexServiceToken',
    0x130002: 'act::GetNexServiceToken',
    0x140382: 'act::AccquireIndependentServiceToken',
    0x150002: 'act::GetIndependentServiceToken',
    0x160082: 'act::AccquireAccountInfo',
    0x170084: 'act::AccquireAccountIdByPid',
    0x180044: 'act::GetPidByAccountID',
    0x190044: 'act::AcquireMii',
    0x1a0042: 'act::AccquireRawAccountInfo',
    0x1b0084: 'act::AccquireOtherTypePrincipalID',
    0x1e0082: 'act::AcquireEula',
    0x1f0082: 'act::AcquireEulaLanguageList'
  },
  'act_a_handle': {
    0x41300c2: 'act::UpdateMiiImage',
    0x41b0142: 'act::AgreeEula',
    0x4210042: 'act::UploadMii',
    0x4230082: 'act::ValidateMailAddress'
  },
  'mp_u_handle': {
    0x10040: 'mp::GetHandle',
    0x20000: 'mp::Initialize',
    0x30000: 'mp::Shutdown',
    0x400c0: 'mp::Bind',
    0x50042: 'mp::SetBeaconData',
    0x70042: 'mp::SetAppData',
    0x110080: 'mp::RecvDataFrame',
    0x1400c2: 'mp::SendDataFrame'
  },
  'nfc_u_handle': {
    0x10040: 'nfc::Initialize',
    0x20040: 'nfc::Shutdown',
    0x30000: 'nfc::StartCommunication',
    0x40000: 'nfc::StopCommunication',
    0x50040: 'nfc::StartTagScanning',
    0x60000: 'nfc::StopTagScanning',
    0x70000: 'nfc::LoadAmiiboData',
    0x80000: 'nfc::ResetTagScanState',
    0x90002: 'nfc::UpdateStoredAmiiboData',
    0xb0000: 'nfc::GetTagInRangeEvent',
    0xc0000: 'nfc::GetTagOutOfRangeEvent',
    0xd0000: 'nfc::GetTagState',
    0xf0000: 'nfc::CommunicationGetStatus',
    0x100000: 'nfc::GetTagInfo2',
    0x110000: 'nfc::GetTagInfo',
    0x120000: 'nfc::CommunicationGetResult',
    0x130040: 'nfc::OpenAppData',
    0x140384: 'nfc::InitializeWriteAppData',
    0x150040: 'nfc::ReadAppData',
    0x160242: 'nfc::WriteAppData',
    0x170000: 'nfc::GetAmiiboSettings',
    0x180000: 'nfc::GetAmiiboConfig',
    0x190000: 'nfc::GetAppDataInitStruct',
    0x1f0080: 'nfc::StartOtherTagScanning',
    0x200102: 'nfc::SendTagCommand'
  },
  'nfc_m_handle': {
    0x10040: 'nfc::Initialize',
    0x20040: 'nfc::Shutdown',
    0x30000: 'nfc::StartCommunication',
    0x40000: 'nfc::StopCommunication',
    0x50040: 'nfc::StartTagScanning',
    0x60000: 'nfc::StopTagScanning',
    0x70000: 'nfc::LoadAmiiboData',
    0x80000: 'nfc::ResetTagScanState',
    0x90002: 'nfc::UpdateStoredAmiiboData',
    0xb0000: 'nfc::GetTagInRangeEvent',
    0xc0000: 'nfc::GetTagOutOfRangeEvent',
    0xd0000: 'nfc::GetTagState',
    0xf0000: 'nfc::CommunicationGetStatus',
    0x100000: 'nfc::GetTagInfo2',
    0x110000: 'nfc::GetTagInfo',
    0x120000: 'nfc::CommunicationGetResult',
    0x130040: 'nfc::OpenAppData',
    0x140384: 'nfc::InitializeWriteAppData',
    0x150040: 'nfc::ReadAppData',
    0x160242: 'nfc::WriteAppData',
    0x170000: 'nfc::GetAmiiboSettings',
    0x180000: 'nfc::GetAmiiboConfig',
    0x190000: 'nfc::GetAppDataInitStruct',
    0x1f0080: 'nfc::StartOtherTagScanning',
    0x200102: 'nfc::SendTagCommand'
  },
  'mvd_std_handle': {
    0x10082: 'mvd::Initialize',
    0x20000: 'mvd::Shutdown',
    0x30300: 'mvd::CalculateWorkBufSize',
    0x400c0: 'mvd::CalculateImageSize',
    0x80142: 'mvd::ProcessNALUnit',
    0x90042: 'mvd::ControlFrameRendering',
    0xa0000: 'mvd::GetStatus',
    0xb0000: 'mvd::GetStatusOther',
    0x1d0042: 'mvd::GetConfig',
    0x1e0044: 'mvd::SetConfig',
    0x1f0902: 'mvd::SetupOutputBuffers',
    0x210100: 'mvd::OverrideOutputBuffers'
  },
  'l2b_u_handle': {
    0x10040: 'l2b::SetInputFormat',
    0x20080: 'l2b::GetInputFormat',
    0x30040: 'l2b::SetOutputFormat',
    0x40080: 'l2b::GetOutputFormat',
    0x50040: 'l2b::SetTransferEndInterrupt',
    0x60080: 'l2b::GetTransferEndInterrupt',
    0x70080: 'l2b::GetL2BEndEvent',
    0xa0102: 'l2b::MaybeSetRecieving',
    0xb0080: 'l2b::IsDoneRecieving',
    0xc0040: 'l2b::SetInputLineWidth',
    0xd0080: 'l2b::GetInputLineWidth',
    0xe0040: 'l2b::SetInputLines',
    0xf0080: 'l2b::GetInputLines',
    0x100040: 'l2b::MaybeSetAlpha',
    0x110080: 'l2b::MaybeGetAlpha',
    0x120040: 'l2b::StartConversion',
    0x130040: 'l2b::StopConversion',
    0x140080: 'l2b::IsBusyConversion',
    0x150040: 'l2b::SetPackageParameter',
    0x160080: 'l2b::GetPackageParameter',
    0x170080: 'l2b::PingProcess'
  },
  'l2b2_u_handle': {
    0x10040: 'l2b2::SetInputFormat',
    0x20080: 'l2b2::GetInputFormat',
    0x30040: 'l2b2::SetOutputFormat',
    0x40080: 'l2b2::GetOutputFormat',
    0x50040: 'l2b2::SetTransferEndInterrupt',
    0x60080: 'l2b2::GetTransferEndInterrupt',
    0x70080: 'l2b2::GetL2BEndEvent',
    0xa0102: 'l2b2::MaybeSetRecieving',
    0xb0080: 'l2b2::IsDoneRecieving',
    0xc0040: 'l2b2::SetInputLineWidth',
    0xd0080: 'l2b2::GetInputLineWidth',
    0xe0040: 'l2b2::SetInputLines',
    0xf0080: 'l2b2::GetInputLines',
    0x100040: 'l2b2::MaybeSetAlpha',
    0x110080: 'l2b2::MaybeGetAlpha',
    0x120040: 'l2b2::StartConversion',
    0x130040: 'l2b2::StopConversion',
    0x140080: 'l2b2::IsBusyConversion',
    0x150040: 'l2b2::SetPackageParameter',
    0x160080: 'l2b2::GetPackageParameter',
    0x170080: 'l2b2::PingProcess'
  },
  'y2r2_u_handle': {
    0x10040: 'y2r2::SetInputFormat',
    0x20000: 'y2r2::GetInputFormat',
    0x30040: 'y2r2::SetOutputFormat',
    0x40000: 'y2r2::GetOutputFormat',
    0x50040: 'y2r2::SetRotation',
    0x60000: 'y2r2::GetRotation',
    0x70040: 'y2r2::SetBlockAlignment',
    0x80000: 'y2r2::GetBlockAlignment',
    0x90040: 'y2r2::SetSpacialDithering',
    0xa0000: 'y2r2::GetSpacialDithering',
    0xb0040: 'y2r2::SetTemporalDithering',
    0xc0000: 'y2r2::GetTemporalDithering',
    0xd0040: 'y2r2::SetTransferEndInterrupt',
    0xe0000: 'y2r2::GetTransferEndInterrupt',
    0xf0000: 'y2r2::GetTransferEndEvent',
    0x100102: 'y2r2::SetSendingY',
    0x110102: 'y2r2::SetSendingU',
    0x120102: 'y2r2::SetSendingV',
    0x130102: 'y2r2::SetSendingYuv',
    0x140000: 'y2r2::IsFinishedSendingYuv',
    0x150000: 'y2r2::IsFinishedSendingY',
    0x160000: 'y2r2::IsFinishedSendingU',
    0x170000: 'y2r2::IsFinishedSendingV',
    0x180102: 'y2r2::SetReceiving',
    0x190000: 'y2r2::IsFinishedReceiving',
    0x1a0040: 'y2r2::SetInputLineWidth',
    0x1b0000: 'y2r2::GetInputLineWidth',
    0x1c0040: 'y2r2::SetInputLines',
    0x1d0000: 'y2r2::GetInputLines',
    0x1e0100: 'y2r2::SetCoefficientParams',
    0x1f0000: 'y2r2::GetCoefficientParams',
    0x200040: 'y2r2::SetStandardCoefficient',
    0x210040: 'y2r2::GetStandardCoefficientParams',
    0x220040: 'y2r2::SetAlpha',
    0x230000: 'y2r2::GetAlpha',
    0x240200: 'y2r2::SetDitheringWeightParams',
    0x250000: 'y2r2::GetDitheringWeightParams',
    0x260000: 'y2r2::StartConversion',
    0x270000: 'y2r2::StopConversion',
    0x280000: 'y2r2::IsBusyConversion',
    0x2901c0: 'y2r2::SetPackageParameter',
    0x2a0000: 'y2r2::PingProcess',
    0x2b0000: 'y2r2::DriverInitialize',
    0x2c0000: 'y2r2::DriverFinalize',
    0x2d0000: 'y2r2::GetPackageParameter'
  },
  'qtm_u_handle': {
    0x10080: 'qtm::GetHeadtrackingInfoRaw',
    0x20080: 'qtm::GetHeadtrackingInfo'
  },
  'qtm_sp_handle': {
    0x10080: 'qtm::GetHeadtrackingInfoRaw',
    0x20080: 'qtm::GetHeadtrackingInfo'
  },
  'qtm_s_handle': {
    0x10080: 'qtm::GetHeadtrackingInfoRaw',
    0x20080: 'qtm::GetHeadtrackingInfo'
  },
  'qtm_c_handle': {
    0x10000: 'qtm::InitializeHardwareCheck',
    0x50040: 'qtm::SetIrLedCheck',
    0x10080: 'qtm::GetHeadtrackingInfoRaw',
    0x20080: 'qtm::GetHeadtrackingInfo'
  }
}

# Sometimes when reverse engineering sysmodules
# we only see the command number, not the full IPC header.
# This is for services where the full header may not be known.
services_command_only = {
  'cam_q_handle': {
    0x3: 'cam::IsBusy',
    0x5: 'cam::GetVsyncInterruptEvent',
    0x6: 'cam::GetBufferErrorInterruptEvent',
    0x7: 'cam::StartRecieving',
    0xa: 'cam::GetMaxLines',
    0xc: 'cam::GetTransferBytes',
    0xd: 'cam::GetMaxBytes',
    0xf: 'cam::IsTrimming',
    0x11: 'cam::GetTrimmingParams',
    0x19: 'cam::IsAutoExposure',
    0x1b: 'cam::IsAutoWhiteBalance',
    0x1d: 'cam::SetDetailSize',
    0x25: 'cam::SetAutoExposureWindow',
    0x26: 'cam::SetAutoWhiteBalanceWindow',
    0x29: 'cam::GetLatestVsyncTiming',
    0x2a: 'cam::GetStereoCallibrationData',
    0x2b: 'cam::SetPackageParameterWithoutContext',
    0x2d: 'cam::SetPackageParameterWithContextDetail',
    0x2e: 'cam::GetSuitableY2RStandardCoeffecient',
    0x2f: 'cam::PlayShutterSoundWithWave',
    0x30: 'cam::GetShutterSound',
    0x31: 'cam::DriverInitialize',
    0x32: 'cam::DriverFinalize',
    0x33: 'cam::GetActivatedCamera',
    0x34: 'cam::GetSleepCamera',
    0x35: 'cam::SetSleepCamera',
    0x36: 'cam::SetBrightnessSyncronization'
  },
  'frd_u_handle': {
    0x1: 'frd::HasLoggedIn',
    0x2: 'frd::IsOnline',
    0x3: 'frd::Login',
    0x4: 'frd::Logout',
    0x5: 'frd::GetMyFriendKey',
    0x6: 'frd::GetMyPreference',
    0x7: 'frd::GetMyProfile',
    0x8: 'frd::GetMyPresence',
    0x9: 'frd::GetMyScreenName',
    0xa: 'frd::GetMyMii',
    0xb: 'frd::GetMyLocalAccountId',
    0xc: 'frd::GetMyPlayingGame',
    0xd: 'frd::GetMyFavoriteGame',
    0xe: 'frd::GetMyNcPrincipalId',
    0xf: 'frd::GetMyComment',
    0x10: 'frd::GetMyPassword',
    0x11: 'frd::GetFriendKeyList',
    0x12: 'frd::GetFriendPresence',
    0x13: 'frd::GetFriendScreenName',
    0x14: 'frd::GetFriendMii',
    0x15: 'frd::GetFriendProfile',
    0x16: 'frd::GetFriendRelationship',
    0x17: 'frd::GetFriendAttributeFlags',
    0x18: 'frd::GetFriendPlayingGame',
    0x19: 'frd::GetFriendFavoriteGame',
    0x1a: 'frd::GetFriendInfo',
    0x1b: 'frd::IsIncludedInFriendList',
    0x1c: 'frd::UnscrambleLocalFriendCode',
    0x1d: 'frd::UpdateGameModeDescription',
    0x1e: 'frd::UpdateGameMode',
    0x1f: 'frd::SendInvitation',
    0x20: 'frd::AttachToEventNotification',
    0x21: 'frd::SetNotificationMask',
    0x22: 'frd::GetEventNotification',
    0x23: 'frd::GetLastResponseResult',
    0x24: 'frd::PrincipalIdToFriendCode',
    0x25: 'frd::FriendCodeToPrincipalId',
    0x26: 'frd::IsValidFriendCode',
    0x27: 'frd::ResultToErrorCode',
    0x28: 'frd::RequestGameAuthentication',
    0x29: 'frd::GetGameAuthenticationData',
    0x2a: 'frd::RequestServiceLocator',
    0x2b: 'frd::GetServiceLocatorData',
    0x2c: 'frd::DetectNatProperties',
    0x2d: 'frd::GetNatProperties',
    0x2e: 'frd::GetServerTimeInterval',
    0x2f: 'frd::AllowHalfAwake',
    0x30: 'frd::GetServerTypes',
    0x31: 'frd::GetFriendComment',
    0x32: 'frd::SetClientSdkVersion',
    0x33: 'frd::GetMyApproachContext',
    0x34: 'frd::AddFriendWithApproach',
    0x35: 'frd::DecryptApproachContext',
    0x36: 'frd::GetExtendedNatProperties'
  },
  'frd_n_handle': {
    0x1: 'frd::GetWiFiEvent',
    0x2: 'frd::ConnectToWiFi',
    0x3: 'frd::DisconnectFromWiFi',
    0x4: 'frd::GetWiFiState'
  },
  'frd_a_handle': {
    0x401: 'frd::CreateLocalAccount',
    0x402: 'frd::DeleteConfig',
    0x403: 'frd::SetLocalAccountId',
    0x404: 'frd::ResetAccountConfig',
    0x405: 'frd::HasUserData',
    0x406: 'frd::AddFriendOnline',
    0x407: 'frd::AddFriendOffline',
    0x408: 'frd::SetFriendDisplayName',
    0x409: 'frd::RemoveFriend',
    0x40a: 'frd::SetPresenseGameKey',
    0x40b: 'frd::SetPrivacySettings',
    0x40c: 'frd::SetMyData',
    0x40d: 'frd::SetMyFavoriteGame',
    0x40e: 'frd::SetMyNCPrincipalId',
    0x40f: 'frd::SetPersonalComment',
    0x410: 'frd::IncrementAccountConfigCounter'
  },
  'ir_user_handle': {
    0x11: 'ir::GetLatestReceiveErrorResult',
    0x12: 'ir::GetLatestSendErrorResult',
    0x13: 'ir::GetConnectionStatus',
    0x14: 'ir::GetTryingToConnectStatus',
    0x15: 'ir::GetReceiveSizeFreeAndUsed',
    0x16: 'ir::GetSendSizeFreeAndUsed',
    0x17: 'ir::GetConnectionRole'
  },
  'ptm_sysm_handle': {
    0x816: 'ptm::GetSystemClock',
    0x817: 'ptm::SetSystemClock'
  },
  'spi__nor_handle': {
    0x1: 'spi::SetDeviceState',
    0x2: 'spi::Stubbed',
    0x5: 'spi::WriteDevice'
  },
  'spi__cd2_handle': {
    0x1: 'spi::SetDeviceState',
    0x2: 'spi::Stubbed',
    0x5: 'spi::WriteDevice'
  },
  'spi__cs2_handle': {
    0x1: 'spi::SetDeviceState',
    0x2: 'spi::Stubbed',
    0x5: 'spi::WriteDevice'
  },
  'spi__cs3_handle': {
    0x1: 'spi::SetDeviceState',
    0x2: 'spi::Stubbed',
    0x5: 'spi::WriteDevice'
  },
  'spi__def_handle': {
    0x1: 'spi::SetDeviceState',
    0x2: 'spi::Stubbed',
    0x5: 'spi::WriteDevice'
  }
}

# These are unique commands that can be identified without handles
unique_commands = {
  0x40100c4: 'fs::Control',
  0x8010002: 'fs::Initialize',
  0x80201c2: 'fs::OpenFile',
  0x8030204: 'fs::OpenFileDirectly',
  0x8040142: 'fs::DeleteFile',
  0x8050244: 'fs::RenameFile',
  0x8060142: 'fs::DeleteDirectory',
  0x8070142: 'fs::DeleteDirectoryRecursively',
  0x8080202: 'fs::CreateFile',
  0x8090182: 'fs::CreateDirectory',
  0x80a0244: 'fs::RenameDirectory',
  0x80b0102: 'fs::OpenDirectory',
  0x80c00c2: 'fs::OpenArchive',
  0x80d0144: 'fs::ControlArchive',
  0x80e0080: 'fs::CloseArchive',
  0x80f0180: 'fs::Obsoleted_2_0_FormatThisUserSaveData',
  0x8100200: 'fs::Obsoleted_3_0_CreateSystemSaveData',
  0x8110040: 'fs::Obsoleted_3_0_DeleteSystemSaveData',
  0x8120080: 'fs::GetFreeBytes',
  0x8150000: 'fs::GetNandArchiveResource',
  0x8180000: 'fs::IsSdmcWritable',
  0x8190042: 'fs::GetSdmcCid',
  0x81b0000: 'fs::GetSdmcSpeedInfo',
  0x81c0000: 'fs::GetNandSpeedInfo',
  0x81d0042: 'fs::GetSdmcLog',
  0x81e0042: 'fs::GetNandLog',
  0x81f0000: 'fs::ClearSdmcLog',
  0x8200000: 'fs::ClearNandLog',
  0x8210000: 'fs::CardSlotIsInserted',
  0x8230000: 'fs::CardSlotPowerOff',
  0x8240000: 'fs::CardSlotGetCardIFPowerStatus',
  0x8250040: 'fs::CardNorDirectCommand',
  0x8260080: 'fs::CardNorDirectCommandWithAddress',
  0x8270082: 'fs::CardNorDirectRead',
  0x82800c2: 'fs::CardNorDirectReadWithAddress',
  0x8290082: 'fs::CardNorDirectWrite',
  0x82a00c2: 'fs::CardNorDirectWriteWithAddress',
  0x82b00c2: 'fs::CardNorDirectRead_4xIO',
  0x82c0082: 'fs::CardNorDirectCpuWriteWithoutVerify',
  0x82d0040: 'fs::CardNorDirectSectorEraseWithoutVerify',
  0x82e0040: 'fs::GetProductInfo',
  0x82f0040: 'fs::GetProgramLaunchInfo',
  0x8300182: 'fs::Obsoleted_3_0_CreateExtSaveData',
  0x8310180: 'fs::Obsoleted_3_0_CreateSharedExtSaveData',
  0x8320102: 'fs::Obsoleted_3_0_ReadExtSaveDataIcon',
  0x8330082: 'fs::Obsoleted_3_0_EnumerateExtSaveData',
  0x8340082: 'fs::Obsoleted_3_0_EnumerateSharedExtSaveData',
  0x8350080: 'fs::Obsoleted_3_0_DeleteExtSaveData',
  0x8360080: 'fs::Obsoleted_3_0_DeleteSharedExtSaveData',
  0x8370040: 'fs::SetCardSpiBaudRate',
  0x8380040: 'fs::SetCardSpiBusMode',
  0x8390000: 'fs::SendInitializeInfoTo9',
  0x83a0100: 'fs::GetSpecialContentIndex',
  0x83b00c2: 'fs::GetLegacyRomHeader',
  0x83c00c2: 'fs::GetLegacyBannerData',
  0x83d0100: 'fs::CheckAuthorityToAccessExtSaveData',
  0x83e00c2: 'fs::QueryTotalQuotaSize',
  0x83f00c0: 'fs::Obsoleted_3_0_GetExtDataBlockSize',
  0x8400040: 'fs::AbnegateAccessRight',
  0x8410000: 'fs::DeleteSdmcRoot',
  0x8420040: 'fs::DeleteAllExtSaveDataOnNand',
  0x8430000: 'fs::InitializeCtrFileSystem',
  0x8440000: 'fs::CreateSeed',
  0x84500c2: 'fs::GetFormatInfo',
  0x8460102: 'fs::GetLegacyRomHeader2',
  0x8470180: 'fs::Obsoleted_2_0_FormatCtrCardUserSaveData',
  0x8480042: 'fs::GetSdmcCtrRootPath',
  0x8490040: 'fs::GetArchiveResource',
  0x84a0002: 'fs::ExportIntegrityVerificationSeed',
  0x84b0002: 'fs::ImportIntegrityVerificationSeed',
  0x84c0242: 'fs::FormatSaveData',
  0x84d0102: 'fs::GetLegacySubBannerData',
  0x84e0342: 'fs::UpdateSha256Context',
  0x84f0102: 'fs::ReadSpecialFile',
  0x8500040: 'fs::GetSpecialFileSize',
  0x8510242: 'fs::CreateExtSaveData',
  0x8520100: 'fs::DeleteExtSaveData',
  0x8530142: 'fs::ReadExtSaveDataIcon',
  0x85400c0: 'fs::GetExtDataBlockSize',
  0x8550102: 'fs::EnumerateExtSaveData',
  0x8560240: 'fs::CreateSystemSaveData',
  0x8570080: 'fs::DeleteSystemSaveData',
  0x8580000: 'fs::StartDeviceMoveAsSource',
  0x8590200: 'fs::StartDeviceMoveAsDestination',
  0x85a00c0: 'fs::SetArchivePriority',
  0x85b0080: 'fs::GetArchivePriority',
  0x85c00c0: 'fs::SetCtrCardLatencyParameter',
  0x85d01c0: 'fs::SetFsCompatibilityInfo',
  0x85e0040: 'fs::ResetCardCompatibilityParameter',
  0x85f0040: 'fs::SwitchCleanupInvalidSaveData',
  0x8600042: 'fs::EnumerateSystemSaveData',
  0x8610042: 'fs::InitializeWithSdkVersion',
  0x8620040: 'fs::SetPriority',
  0x8630000: 'fs::GetPriority',
  0x8640000: 'fs::Obsoleted_4_0_GetNandInfo',
  0x8650140: 'fs::SetSaveDataSecureValue',
  0x86600c0: 'fs::GetSaveDataSecureValue',
  0x86700c4: 'fs::ControlSecureSave',
  0x8680000: 'fs::GetMediaType',
  0x8690000: 'fs::Obsoleted_4_0_GetNandEraseCount',
  0x86a0082: 'fs::ReadNandReport',
  0x86b00c2: 'fs::SetOtherSaveDataSecureValue',
  0x86c00c2: 'fs::GetOtherSaveDataSecureValue',
  0x86e00c0: 'fs::SetThisSaveDataSecureValue',
  0x86f0040: 'fs::GetThisSaveDataSecureValue',
  0x87900c2: 'fs::GetLegacyBannerData',
  0x87a0180: 'fs::AddSeed',
  0x87d0000: 'fs::GetNumSeeds',
  0x88600c0: 'fs::CheckUpdatedDat',
  0x40103c0: 'fs::Register',
  0x40300c0: 'fs::GetProgramInfo',
  0x4040100: 'fs::LoadProgram',
  0x4050080: 'fs::UnloadProgram',
  0x4060080: 'fs::CheckHostLoadId',
  0x100100: 'pxi::InstallTitleBegin',
  0x140042: 'pxi::InstallTmdWrite',
  0x180042: 'pxi::InstallContentWrite',
  0x1d0080: 'pxi::GetPendingTitleCount',
  0x2000c0: 'pxi::DeletePendingTitle',
  0x220102: 'pxi::GetImportContentContextList',
  0x230104: 'pxi::GetImportContentContexts',
  0x240102: 'pxi::DeleteImportContentContexts',
  0x2a00c2: 'pxi::InstallTitlesFinish',
  0x390146: 'pxi::Sign',
  0x3b0042: 'pxi::GetCTCert',
  0x3d0108: 'pxi::SetCertificates',
  0x420142: 'pxi::InstallTitlesFinishFIRM',
  0x4301c8: 'pxi::VerifyDSiWareFooter',
  0x460182: 'pxi::WriteTWLSavedata',
  0x480040: 'pxi::ReloadDBS',
  0x490080: 'pxi::GetNumTicketIds',
  0x4a0102: 'pxi::GetTicketIdList',
  0x4b0100: 'pxi::DeleteTicketId',
  0x4c0042: 'pxi::GetPersonalizedTicketInfoList',
  0x4d0144: 'pxi::ExportDSiWare',
  0x4e00c0: 'pxi::InstallTitleBeginDSi',
  0x4f00c0: 'pxi::GetDSiWareExportSize',
  0x500044: 'pxi::GetTwlProgramListForReboot',
  0x510000: 'pxi::DeleteAllTwlUserPrograms',
  0x520040: 'pxi::DeleteAllExpiredUserPrograms',
  0x530084: 'pxi::ValidateDSiWareMovableSedHash',
  0x5500c4: 'pxi::ValidateDSiWareSectionMAC',
  0x5600c0: 'pxi::CheckContentRights',
  0x570042: 'pxi::InstallTitleSetContentIndices',
  0x5800c0: 'pxi::GetNumContentInfos',
  0x590104: 'pxi::FindContentInfos',
  0x5a0142: 'pxi::ListContentInfos',
  0x5b0000: 'pxi::GetNumCurrentContentInfos',
  0x5d0082: 'pxi::ListCurrentContentInfos',
  0x5e0102: 'pxi::DeleteContents',
  0x600102: 'pxi::ListDataTitleTicketInfos',
  0x610142: 'pxi::ExportLicenseTicket',
  0x620044: 'pxi::GetTicketLimitInfos',
  0x630042: 'pxi::UpdateImportContentContexts',
  0x6400c0: 'pxi::GetInternalTitleLocationInfo',
  0x6500c0: 'pxi::MigrateAGBtoSAV',
  0x670082: 'pxi::DeleteProgramsAtomically',
  0x6801c2: 'pxi::GetItemRights',
  0x6900c0: 'pxi::IsDataTitleInUse',
  0x6a00c0: 'pxi::GetNumExistingContentInfos',
  0x6d0184: 'pxi::ExportTicketWrapped',
  0x201c2: 'pxi::WriteHostIO',
  0x30102: 'pxi::ReadHostEx',
  0x50102: 'pxi::WriteHostExStart',
  0xd0688: 'pxi::SPIMultiWriteRead',
  0xe0284: 'pxi::SPIWriteRead',
  0x20284: 'pxi::SignRsaSha256',
  0x30284: 'pxi::VerifyRsaSha256',
  0x401c4: 'pxi::EncryptDecryptAes',
  0x50284: 'pxi::EncryptSignDecryptVerifyAesCcm',
  0x8010000: 'am::BeginImportTicket',
  0x8020002: 'am::CancelImportTicket',
  0x8030002: 'am::EndImportTicket',
  0x8040100: 'am::BeginImportTitle',
  0x80600c0: 'am::ResumeImportTitle',
  0x8070000: 'am::CancelImportTitle',
  0x80900c2: 'am::CommitImportTitles',
  0x80b0002: 'am::CancelImportTmd',
  0x80d0042: 'am::CreateImportContentContexts',
  0x80e0040: 'am::BeginImportContent',
  0x80f0002: 'am::StopImportContent',
  0x8100040: 'am::ResumeImportContent',
  0x8110002: 'am::CancelImportContent',
  0x8120002: 'am::EndImportContent',
  0x8150044: 'am::GetCurrentImportContentContexts',
  0x8160146: 'am::Sign',
  0x8170146: 'am::Verify',
  0x8190108: 'am::ImportCertificates',
  0x81b00c2: 'am::CommitImportTitlesAndUpdateFirmwareAuto',
  0x81c0100: 'am::DeleteTicketId',
  0x81d0080: 'am::GetNumTicketIds',
  0x81e0102: 'am::GetTicketIdList',
  0x81f0080: 'am::GetNumTicketsOfProgram',
  0x8200102: 'am::ListTicketInfos',
  0x8210142: 'am::ExportLicenseTicket',
  0x8230044: 'am::FindCurrentContentInfos',
  0x8240082: 'am::ListCurrentContentInfos',
  0x8250102: 'am::CalculateContextRequiredSize',
  0x8260042: 'am::UpdateImportContentContexts',
  0x8270000: 'am::DeleteAllDemoLaunchInfos',
  0x82800c0: 'am::BeginImportTitleForOverWrite',
  0x8290184: 'am::ExportTicketWrapped',
  0x100100c0: 'am::GetDLCContentInfoCount',
  0x10020104: 'am::FindDLCContentInfos',
  0x10030142: 'am::ListDLCContentInfos',
  0x10040102: 'am::DeleteContents',
  0x10050084: 'am::GetDLCTitleInfos',
  0x10060080: 'am::GetDLCOrLicenseNumTickets',
  0x10070102: 'am::ListDataTitleTicketInfos',
  0x100801c2: 'am::GetDLCOrLicenseItemRights',
  0x100900c0: 'am::IsDataTitleInUse',
  0x100a0000: 'am::IsExternalTitleDatabaseInitialized',
  0x100b00c0: 'am::GetNumDLCExistingContentInfos',
  0x100c0142: 'am::ListExistingContentInfos',
  0x100d0084: 'am::GetPatchTitleInfos',
  0x40100: 'pm::TerminateTitle',
  0xa0140: 'pm::SetAppResourceLimit',
  0xb0140: 'pm::GetAppResourceLimit',
  0xd0240: 'pm::LaunchTitleUpdate',
  0x20140: 'pm::LaunchApp',
  0x290246: 'nim::RegisterTask',
  0xb0084: 'nim::SetAttribute',
  0x16020a: 'nim::ListTitles',
  0x2d0042: 'nim::DownloadTickets',
  0x3c0002: 'nim::RegisterSelf',
  0x420240: 'nim::StartDownload',
  0x550246: 'nim::RegisterTask',
  0x570082: 'nim::ConnectNoTicketDownload',
  0x40042: 'nim::SetTin',
  0x902d0: 'nim::ListContentSetsEx',
  0x240282: 'nim::CalculateContentsRequiredSize',
  0x8010082: 'cfg::GetConfigInfoBlk8',
  0x8020082: 'cfg::SetConfigInfoBlk4',
  0x80400c2: 'cfg::CreateConfigInfoBlk',
  0x8060000: 'cfg::FormatConfig',
  0x80b0082: 'cfg::SetGetLocalFriendCodeSeedData',
  0x80e0000: 'cfg::VerifySigLocalFriendCodeSeed',
  0x80f0042: 'cfg::GetLocalFriendCodeSeedData',
  0x8110084: 'cfg::SetSecureInfo',
  0x8150042: 'cfg::SecureInfoGetSignature',
  0x100082: 'cfg::WriteDataOther',
  0x100180: 'ns::RebootSystem',
  0x110100: 'ns::TerminateTitle',
  0x402c2: 'ldr::LoadCRO',
  0x902c2: 'ldr::LoadCRO_New',
  0x20002: 'ndm::LeaveExclusiveState',
  0x40002: 'ndm::LockState',
  0x1c00c0: 'cam::FlipImage',
  0x1e00c0: 'cam::SetSize',
  0x2400c0: 'cam::SetOutputFormat',
  0x270080: 'cam::SetNoiseFilter',
  0x400c2: 'cdc::WriteSPI',
  0x100c3: 'dlp::clnt::Initialize',
  0xd0100: 'dlp::clnt::StartTitleDownload',
  0x130100: 'dlp::clnt::GetCupVersion',
  0x140100: 'dlp::clnt::GetDupAvailability',
  0x10183: 'dlp::srvr::Initialize',
  0x50080: 'dlp::srvr::StartAccepting',
  0xf0303: 'dlp::srvr::InitializeWithName',
  0x10083: 'dlp::fkcl::Initialize',
  0x130082: 'dsp::FlushDataCache',
  0x1c0082: 'dsp::SetIirFilterEQ',
  0x20084: 'gsp::WriteHWRegsWithMask',
  0x50200: 'gsp::SetBufferSwap',
  0x700c2: 'gsp::RequestDma',
  0xa0044: 'gsp::RegisterInterruptEvents',
  0xe0180: 'gsp::SetTextureCopy',
  0xf0200: 'gsp::SetMemoryFill',
  0x160042: 'gsp::AcquireRight',
  0x1e0080: 'gsp::SetInternalPriorities',
  0x20100: 'boss::SetStorageInfo',
  0x1c0042: 'boss::StartTask',
  0x2300c2: 'boss::GetTaskStatus',
  0x260040: 'boss::DeleteNsData',
  0x2700c2: 'boss::GetNsDataHeaderInfo',
  0x280102: 'boss::ReadNsData',
  0x2c0040: 'boss::GetNsDataNewFlag',
  0x2f0140: 'boss::RegisterStorageEntry',
  0x330042: 'boss::StartBgImmediate',
  0x340042: 'boss::GetTaskProperty0',
  0x3500c2: 'boss::RegisterImmediateTask',
  0x4040080: 'boss::GetAppNewFlag',
  0x40d0182: 'boss::GetNsDataIdListPrivileged',
  0x40e0182: 'boss::GetNsDataIdListPrivileged1',
  0x4130082: 'boss::SendPropertyPrivileged',
  0x41500c0: 'boss::DeleteNsDataPrivileged',
  0x4160142: 'boss::GetNsDataHeaderInfoPrivileged',
  0x4170182: 'boss::ReadNsDataPrivileged',
  0x41a0100: 'boss::SetNsDataNewFlagPrivileged',
  0x41b00c0: 'boss::GetNsDataNewFlagPrivileged',
  0x30104: 'cecd::ReadMessage',
  0x40106: 'cecd::ReadMessageWithHMAC',
  0x60104: 'cecd::WriteMessage',
  0x70106: 'cecd::WriteMessageWithHMAC',
  0xa00c4: 'cecd::GetSystemInfo',
  0x10182: 'ir::InitializeIrnop',
  0x702c0: 'ir::AutoConnection',
  0x180182: 'ir::InitializeIrnopShared',
  0x4010000: 'ptm::GetSystemTime',
  0x102c2: 'nwm::Initialize',
  0x40402: 'nwm::CreateNetwork',
  0x90442: 'nwm::ConnectNetwork',
  0xe0006: 'nwm::DecryptBeaconData',
  0xf0404: 'nwm::RecvBeaconBroadcastData',
  0x120100: 'nwm::Bind',
  0x1400c0: 'nwm::PullPacket',
  0x170182: 'nwm::SendTo',
  0x1b0302: 'nwm::InitializeWithVersion',
  0x1d0044: 'nwm::BeginHostingNetwork',
  0x1f0006: 'nwm::DecryptBeaconData',
  0x220402: 'nwm::ScanOnConnection',
  0x603c4: 'nwm::RecvBeaconBroadcastData',
  0x70742: 'nwm::ConnectToEncryptedAP',
  0x80302: 'nwm::ConnectToAP',
  0xc0102: 'http::ReceiveDataTimeout',
  0xd0146: 'http::SetProxy',
  0xf00c4: 'http::SetBasicAuthorization',
  0x100080: 'http::SetSocketBufferSize',
  0x1100c4: 'http::AddRequestHeader',
  0x1200c4: 'http::AddPostDataAscii',
  0x1300c4: 'http::AddPostDataBinary',
  0x1600c4: 'http::SendPostDataAscii',
  0x170144: 'http::SendPostDataAsciiTimeout',
  0x1800c4: 'http::SendPostDataBinary',
  0x190144: 'http::SendPostDataBinaryTimeout',
  0x1a0082: 'http::SendPostDataRaw',
  0x1b0102: 'http::SendPOSTDataRawTimeout',
  0x1c0080: 'http::SetPostDataEncoding',
  0x1e00c4: 'http::GetResponseHeader',
  0x1f0144: 'http::GetResponseHeaderTimeout',
  0x210102: 'http::GetResponseDataTimeout',
  0x2300c0: 'http::GetResponseStatusCodeTimeout',
  0x240082: 'http::AddTrustedRootCA',
  0x250080: 'http::AddDefaultCert',
  0x260080: 'http::SelectRootCertChain',
  0x2700c4: 'http::SetClientCert',
  0x2f0082: 'http::RootCertChainAddCert',
  0x310080: 'http::RootCertChainRemoveCert',
  0x330040: 'http::OpenDefaultClientCertContext',
  0x350186: 'http::SetDefaultProxy',
  0x370080: 'http::SetKeepAlive',
  0x3800c0: 'http::SetPostDataTypeSize',
  0x3a0080: 'http::SetKeepAlive',
  0x3b0082: 'http::SetCrl',
  0x3c0080: 'http::SetInternalCrl',
  0x3d0080: 'http::SetCrlStore',
  0x400082: 'http::AddCrlToCrlStore',
  0x410080: 'http::AddInternalCrl',
  0x1c00c4: 'ssl::ContextGetProtocolCipher',
  0x40082: 'soc::accept',
  0x50084: 'soc::bind',
  0x60084: 'soc::connect',
  0x70104: 'soc::recvfrom_other',
  0x90106: 'soc::sendto_other',
  0xa0106: 'soc::sendto',
  0xf0106: 'soc::getaddrinfo',
  0x1300c2: 'soc::fcntl',
  0x140084: 'soc::poll',
  0x1c0104: 'soc::ICMPPing',
  0x4010040: 'ac::LoadNetworkSetting',
  0x4030040: 'ac::RemoveNetworkSetting',
  0x4040000: 'ac::FlushNetworkSetting',
  0x4050084: 'ac::ConvertNetworkSettingNdsTo3ds',
  0x4060040: 'ac::InitializeNetworkSetting',
  0x4080040: 'ac::SetNetworkSettingVersion',
  0x40a0040: 'ac::SetNetworkSetting_Crc',
  0x40b0000: 'ac::GetNetworkWirelessEnable',
  0x40c0040: 'ac::SetNetworkWirelessEnable',
  0x40d0000: 'ac::GetNetworkWirelessEditableEssidSecurity',
  0x40e0040: 'ac::SetNetworkWirelessEditableEssidSecurity',
  0x4100002: 'ac::SetNetworkWirelessEssidSecuritySsid',
  0x4110000: 'ac::GetNetworkWireleesEssidSsidLength',
  0x4120040: 'ac::SetNetworkWirelessEssidSsidLength',
  0x4130000: 'ac::GetNetworkWirelessEssidSecurityMode',
  0x4140040: 'ac::SetNetworkWirelessEssidSecurityMode',
  0x4150000: 'ac::GetNetworkWirelessEssidPassphrase',
  0x4160002: 'ac::SetNetworkWirelessEssidPassphrase',
  0x41700000: 'ac::GetNetworkWirelessEssidSecurityKey',
  0x4180002: 'ac::SetNetworkWirelessEssidSecurityKey',
  0x41a0040: 'ac::SetNetworkMultiSSIDEnable',
  0x41b0000: 'ac::GetNetworkWirelesMultiSsidMultiSsidType',
  0x41c0040: 'ac::SetNetworkWirelesMultiSsidMultiSsidType',
  0x41d0000: 'ac::GetNetworkWirelessMultiSsidSettingNum',
  0x41e0040: 'ac::SetNetworkWirelessMultiSsidSettingNum',
  0x41f0000: 'ac::GetNetworkWirelessMultiSsidSetting0Ssid',
  0x4200002: 'ac::SetNetworkWirelessMultiSsidSetting0Ssid',
  0x4210000: 'ac::GetNetworkWirelessMultiSsidSetting0SsidLength',
  0x4250000: 'ac::GetNetworkWirelessMultiSsidSetting0PassPhrase',
  0x4270000: 'ac::GetNetworkWirelessMultiSsidSetting0Key',
  0x4280002: 'ac::SetNetworkWirelessMultiSsidSetting0Key',
  0x4290000: 'ac::GetNetworkMultiSsidSetting1Ssid',
  0x42a0002: 'ac::SetNetworkMultiSsidSetting1Ssid',
  0x42b0000: 'ac::GetNetworkMultiSsidSetting1SsidLength',
  0x42f00000: 'ac::GetNetworkWirelessMultiSsidSetting1PassPhrase',
  0x4310000: 'ac::GetNetworkWirelessMultiSsidSetting1Key',
  0x4320002: 'ac::SetNetworkWirelessMultiSsidSetting1Key',
  0x4330000: 'ac::GetNetworkWirelessMultiSsidSetting2Ssid',
  0x4340002: 'ac::SetNetworkWirelessMultiSsidSetting2Ssid',
  0x4390000: 'ac::GetNetworkWirelessMultiSsidSetting2Passphrase',
  0x43b0000: 'ac::GetNetworkWirelessMultiSsidSetting2Key',
  0x43c0002: 'ac::SetNetworkWirelessMultiSsidSetting2Key',
  0x43d0000: 'ac::GetNetworkWirelessMultiSsidSetting3Ssid',
  0x43e0002: 'ac::SetNetworkWirelessMultiSsidSetting3Ssid',
  0x4450000: 'ac::GetNetworkWirelessMultiSsidSetting3Key',
  0x4460002: 'ac::SetNetworkWirelessMultiSsidSetting3Key',
  0x4470000: 'ac::GetNetworkIpEnableDHCP',
  0x4480040: 'ac::SetNetworkIpEnableDHCP',
  0x4490000: 'ac::GetNetworkAutoDNSSetting',
  0x44a0040: 'ac::SetNetworkAutoDNSSetting',
  0x44b0000: 'ac::GetNetworkIpAddress',
  0x44c0002: 'ac::SetNetworkIpAddress',
  0x44d0000: 'ac::GetNetworkDefaultGateway',
  0x44e0002: 'ac::SetNetworkDefaultGateway',
  0x44f0000: 'ac::GetNetworkIpNetmask',
  0x4500002: 'ac::SetNetworkIpNetMask',
  0x4510000: 'ac::GetNetworkIpPrimaryDNS',
  0x4520002: 'ac::SetNetworkIpPrimaryDNS',
  0x4530000: 'ac::GetNetworkIpSecondaryDNS',
  0x4540002: 'ac::SetNetworkIpSecondaryDNS',
  0x4550000: 'ac::GetNetworkIpScanlessConnectHasConnected',
  0x4560040: 'ac::SetNetworkIpScanlessConnectHasConnected',
  0x459000: 'ac::GetNetworkIpScanlessConnectLastConnectedBssid',
  0x45a002: 'ac::SetNetworkIpScanlessConnectLastConnectedBssid',
  0x45f0000: 'ac::GetNetworkProxyEnable',
  0x4600040: 'ac::SetNetworkProxyEnable',
  0x4610000: 'ac::GetNetworkProxyAuthType',
  0x4620040: 'ac::SetNetworkProxyAuthType',
  0x4630000: 'ac::GetNetworkProxyPort',
  0x4640040: 'ac::SetNetworkProxyPort',
  0x4650000: 'ac::GetNetworkProxyHost',
  0x4660002: 'ac::SetNetworkProxyHost',
  0x4670000: 'ac::GetNetworkSettingProxyUserName',
  0x4680002: 'ac::SetNetworkSettingProxyUserName',
  0x4690000: 'ac::GetNetworkSettingProxyPassword',
  0x46a0002: 'ac::SetNetworkSettingProxyPassword',
  0x46b0000: 'ac::GetNetworkEnableUPnP',
  0x46c0040: 'ac::SetNetworkEnableUPnP',
  0x46d0000: 'ac::GetNetworkOtherMtu',
  0x46e0040: 'ac::SetNetworkOtherMtu',
  0x46f0000: 'ac::GetConnectingNetworkSettingVersion',
  0x4700000: 'ac::GetConnectingNetworkCrc',
  0x4710000: 'ac::GetConnectingNetworkWirelessEnable',
  0x4730000: 'ac::GetConnectingNetworkWirelessEssidSsid',
  0x4770000: 'ac::GetConnectingNetworkWirelessEssidSecurityKey',
  0x4780000: 'ac::GetConnectingNetworkMultiSsidEnable',
  0x48f0000: 'ac::GetConnectingNetworkEnableDHCP',
  0x4900000: 'ac::GetConnectingNetworkIpAutoDNSSetting',
  0x4910000: 'ac::GetConnectingNetworkIpAddress',
  0x4920000: 'ac::GetConnectingNetworkIpDefaultGateway',
  0x4930000: 'ac::GetConnectingNetworkIpNetmask',
  0x4940000: 'ac::GetConnectingNetworkPrimaryDNS',
  0x4950000: 'ac::GetConnectingNetworkSecondaryDNS',
  0x49b0000: 'ac::GetConnectingNetworkProxyEnable',
  0x49c0000: 'ac::GetConnectingNetworkProxyAuthType',
  0x49d0000: 'ac::GetConnectingNetworkProxyPort',
  0x49e0000: 'ac::GetConnectingNetworkProxyHost',
  0x49f0000: 'ac::GetConnectingNetworkProxyUserName',
  0x4a00000: 'ac::GetConnectingNetworkProxyPassword',
  0x4a10000: 'ac::GetConnectingNetworkEnableUPnP',
  0x4a20000: 'ac::GetConnectingNetworkMtu',
  0x100c8: 'news::AddNotification',
  0x120082: 'news::GetNotificationHeaderOther',
  0x130080: 'mcu::SetRTCAlarm',
  0x1e0000: 'mcu::GetRTCAlarmComponent',
  0x2e0000: 'mcu::SetPowerModeIndicatorState',
  0x2f0000: 'mcu::GetBatteryEmptyPatternByte0_safe',
  0x300040: 'mcu::SetLEDBrightness',
  0x310000: 'mcu::GetLEDBrightness',
  0x380042: 'mcu::GetInfoRegisters',
  0x390082: 'mcu::SetPlayCountRegisters',
  0x3a0082: 'mcu::GetPlayCountRegisters',
  0x3b0640: 'mcu::SetInfoLEDPattern',
  0x3c0040: 'mcu::SetInfoLEDPatternHeader',
  0x3d0000: 'mcu::GetInfoLEDStatus',
  0x460000: 'mcu::GetScreenFlickerBottom',
  0x480000: 'mcu::GetVolumeSliderBounds',
  0x490040: 'mcu::SetInterruptMask',
  0x4a0000: 'mcu::GetInterruptMask',
  0x4d0000: 'mcu::ReadInterrupt',
  0x4e0040: 'mcu::TriggerInterrupt',
  0x4f0040: 'mcu::SetMCUFirmUpdated',
  0x500000: 'mcu::IsMCUFirmUpdated',
  0x520000: 'mcu::GetSoftwareClosedFlag',
  0x530040: 'mcu::SetLgyLcdData',
  0x570040: 'mcu::SetLocalFriendCodeCounter',
  0x580000: 'mcu::GetLocalFriendCodeCounter',
  0x590040: 'mcu::SetLegacyJumpProhibitedFlag',
  0x5a0000: 'mcu::GetLegacyJumpProhibitedFlag',
  0x5b0040: 'mcu::SetUUIDClockSequence',
  0x5c0000: 'mcu::GetUUIDClockSequence',
  0x30140: 'mic::StartSampling',
  0x600c2: 'act::GetAccountDataBlock',
  0x90180: 'act::SetNfsPassword',
  0xf0140: 'act::FindSlotNoByUuid',
  0x130002: 'act::GetNexServiceToken',
  0x140382: 'act::AccquireIndependentServiceToken',
  0x170084: 'act::AccquireAccountIdByPid',
  0x180044: 'act::GetPidByAccountID',
  0x190044: 'act::AcquireMii',
  0x1b0084: 'act::AccquireOtherTypePrincipalID',
  0x41300c2: 'act::UpdateMiiImage',
  0x41b0142: 'act::AgreeEula',
  0x4210042: 'act::UploadMii',
  0x4230082: 'act::ValidateMailAddress',
  0x1400c2: 'mp::SendDataFrame',
  0x30300: 'mvd::CalculateWorkBufSize',
  0x80142: 'mvd::ProcessNALUnit',
  0x1e0044: 'mvd::SetConfig',
  0x1f0902: 'mvd::SetupOutputBuffers',
  0x210100: 'mvd::OverrideOutputBuffers',
}

service_to_handle_name = {
  'fs:USER': 'fs_user_handle',
  'fs:LDR': 'fs_ldr_handle',
  'fs:REG': 'fs_reg_handle',
  'ps:ps': 'ps_ps_handle',
  'PxiFS0': 'pxifs0_handle',
  'PxiFS1': 'pxifs1_handle',
  'PxiFSB': 'pxifsb_handle',
  'PxiFSR': 'pxifsr_handle',
  'PxiPM': 'pxipm_handle',
  'pxi:am9': 'pxi_am9_handle',
  'pxi:dev': 'pxi_dev_handle',
  'pxi:mc': 'pxi_mc_handle',
  'pxi:ps9': 'pxi_ps9_handle',
  'am:app': 'am_app_handle',
  'am:net': 'am_net_handle',
  'am:u': 'am_u_handle',
  'am:sys': 'am_sys_handle',
  'am:pipe': 'am_pipe_handle',
  'pm:app': 'pm_app_handle',
  'pm:dbg': 'pm_dbg_handle',
  'nim:aoc': 'nim_aoc_handle',
  'nim:ndm': 'nim_ndm_handle',
  'nim:s': 'nim_s_handle',
  'nim:u': 'nim_u_handle',
  'cfg:u': 'cfg_u_handle',
  'cfg:s': 'cfg_s_handle',
  'cfg:i': 'cfg_i_handle',
  'cfg:nor': 'cfg_nor_handle',
  'ns:s': 'ns_s_handle',
  'ns:p': 'ns_p_handle',
  'ns:c': 'ns_c_handle',
  'APT:A': 'apt_a_handle',
  'APT:S': 'apt_s_handle',
  'APT:U': 'apt_u_handle',
  'ldr:ro': 'ldr_ro_handle',
  'ndm:u': 'ndm_u_handle',
  'csnd:SND': 'csnd_snd_handle',
  'cam:u': 'cam_u_handle',
  'y2r:u': 'y2r_u_handle',
  'cam:s': 'cam_s_handle',
  'cam:c': 'cam_c_handle',
  'cam:q': 'cam_q_handle',
  'cdc:HID': 'cdc_hid_handle',
  'cdc:MIC': 'cdc_mic_handle',
  'cdc:CSN': 'cdc_csn_handle',
  'cdc:DSP': 'cdc_dsp_handle',
  'cdc:LGY': 'cdc_lgy_handle',
  'cdc:CHK': 'cdc_chk_handle',
  'dlp:CLNT': 'dlp_clnt_handle',
  'dlp:FKCL': 'dlp_fkcl_handle',
  'dlp:SRVR': 'dlp_srvr_handle',
  'dsp::DSP': 'dsp__dsp_handle',
  'gsp::Lcd': 'gsp__lcd_handle',
  'gsp::Gpu': 'gsp__gpu_handle',
  'boss:U': 'boss_u_handle',
  'boss:P': 'boss_p_handle',
  'boss:M': 'boss_m_handle',
  'cecd:u': 'cecd_u_handle',
  'cecd:s': 'cecd_s_handle',
  'cecd:ndm': 'cecd_ndm_handle',
  'ir:u': 'ir_u_handle',
  'ir:USER': 'ir_user_handle',
  'ir:rst': 'ir_rst_handle',
  'i2c::MCU': 'i2c__mcu_handle',
  'i2c::CAM': 'i2c__cam_handle',
  'i2c::LCD': 'i2c__lcd_handle',
  'i2c::DEB': 'i2c__deb_handle',
  'i2c::HID': 'i2c__hid_handle',
  'i2c::IR': 'i2c__ir_handle',
  'i2c::EEP': 'i2c__eep_handle',
  'i2c::NFC': 'i2c__nfc_handle',
  'i2c::QTM': 'i2c__qtm_handle',
  'gpio:CDC': 'gpio_cdc_handle',
  'gpio:MCU': 'gpio_mcu_handle',
  'gpio:HID': 'gpio_hid_handle',
  'gpio:NWM': 'gpio_nwm_handle',
  'gpio:IR': 'gpio_ir_handle',
  'gpio:NFC': 'gpio_nfc_handle',
  'gpio:QTM': 'gpio_qtm_handle',
  'hid:NFC': 'hid_nfc_handle',
  'hid:QTM': 'hid_qtm_handle',
  'hid:SPVR': 'hid_spvr_handle',
  'hid:USER': 'hid_user_handle',
  'ptm:gets': 'ptm_gets_handle',
  'ptm:play': 'ptm_play_handle',
  'ptm:s': 'ptm_s_handle',
  'ptm:sets': 'ptm_sets_handle',
  'ptm:sysm': 'ptm_sysm_handle',
  'ptm:u': 'ptm_u_handle',
  'nwm::CEC': 'nwm__cec_handle',
  'nwm::EXT': 'nwm__ext_handle',
  'nwm::INF': 'nwm__inf_handle',
  'nwm::SAP': 'nwm__sap_handle',
  'nwm::SOC': 'nwm__soc_handle',
  'nwm::TST': 'nwm__tst_handle',
  'nwm::UDS': 'nwm__uds_handle',
  'http:C': 'http_c_handle',
  'ssl:C': 'ssl_c_handle',
  'soc:P': 'soc_p_handle',
  'soc:U': 'soc_u_handle',
  'ac:i': 'ac_i_handle',
  'ac:u': 'ac_u_handle',
  'frd:a': 'frd_a_handle',
  'frd:n': 'frd_n_handle',
  'frd:u': 'frd_u_handle',
  'news:s': 'news_s_handle',
  'news:u': 'news_u_handle',
  'pdn:s': 'pdn_s_handle',
  'pdn:d': 'pdn_d_handle',
  'pdn:i': 'pdn_i_handle',
  'pdn:g': 'pdn_g_handle',
  'pdn:c': 'pdn_c_handle',
  'SPI::NOR': 'spi__nor_handle',
  'SPI::CD2': 'spi__cd2_handle',
  'SPI::CS2': 'spi__cs2_handle',
  'SPI::CS3': 'spi__cs3_handle',
  'SPI::DEF': 'spi__def_handle',
  'Loader': 'loader_handle',
  'mcu::CAM': 'mcu__cam_handle',
  'mcu::GPU': 'mcu__gpu_handle',
  'mcu::HID': 'mcu__hid_handle',
  'mcu::RTC': 'mcu__rtc_handle',
  'mcu::SND': 'mcu__snd_handle',
  'mcu::NWM': 'mcu__nwm_handle',
  'mcu::HWC': 'mcu__hwc_handle',
  'mcu::PLS': 'mcu__pls_handle',
  'mcu::CDC': 'mcu__cdc_handle',
  'mic:u': 'mic_u_handle',
  'act:a': 'act_a_handle',
  'act:u': 'act_u_handle',
  'mp:u': 'mp_u_handle',
  'nfc:dev': 'nfc_dev_handle',
  'nfc:m': 'nfc_m_handle',
  'nfc:p': 'nfc_p_handle',
  'nfc:r': 'nfc_r_handle',
  'nfc:s': 'nfc_s_handle',
  'nfc:u': 'nfc_u_handle',
  'mvd:STD': 'mvd_std_handle',
  'l2b:u': 'l2b_u_handle',
  'l2b2:u': 'l2b2_u_handle',
  'y2r2:u': 'y2r2_u_handle',
  'qtm:u': 'qtm_u_handle',
  'qtm:s': 'qtm_s_handle',
  'qtm:sp': 'qtm_sp_handle',
  'qtm:c': 'qtm_c_handle'
}

service_names = service_to_handle_name.keys()
service_handle_names = services.keys() + services_command_only.keys()

def getCommandName(header, handle):
  if handle is None:
    command = unique_commands.get(header)
    if command is not None:
      return command
    else:
      return 'CTR_FN_{:X}'.format(header)

  commands = services.get(handle)
  if commands is not None:
    command = commands.get(header)
    if command is not None:
      return command

  commands = services_command_only.get(handle)
  if commands is not None:
    command = commands.get(header >> 16)
    if command is not None:
      return command

  return '{}_{:X}'.format(handle, header)

def getServiceHandleName(service):
  name = service_to_handle_name.get(service)
  if name is None:
    name = service.replace(':', '_') + '_handle'
    print('Unmapped service {}!  Using default name.'.format(name))
  return name

def getServiceCallerRefs():
  service_refs = {}
  for service in service_names:
    service_addr = memory.findBytes(toAddr(0), service, None, True, monitor)
    if service_addr is not None:
      # Prevent confusing am:u with cam:u
      if service == 'am:u' and memory.getByte(service_addr.add(1)) == 0x63:
        service_str = None
      else:
        service_str = getDataAt(service_addr)

      # Set the data type if it's not already
      if service_str is None:
        try:
          createAsciiString(service_addr)
        except:
          pass

      refs = getReferencesTo(service_addr)
      for ref in refs:
        caller_func = getFunctionContaining(ref.getFromAddress())
        if caller_func is not None:
          caller_addr = caller_func.getEntryPoint()
          service_refs[caller_addr] = service

  return service_refs
